<p align="center">
   <img src="docs/figures/logo.png" alt="Uno" width="100%" />
</p>

# Uno (Unifying Nonlinear Optimization)

Uno is a C++ library for solving nonlinearly constrained optimization problems of the form:

$$
\begin{align}
\min_{x \in \mathbb{R}^n}  & ~f(x) \\
\text{s.t.}                & ~c_L \le c(x) \le c_U \\
                           & ~x_L \le x \le x_U \\
\end{align}
$$

where $f: \mathbb{R}^n \rightarrow \mathbb{R}$ and $c: \mathbb{R}^n \rightarrow \mathbb{R}^m$ are (ideally twice) continuously differentiable.

Uno unifies Lagrange-Newton (essentially **SQP** and **interior-point**) methods that iteratively solve the optimality (KKT) conditions with Newton's method. It breaks them down into a set of building blocks that interact with one another. Our unification framework can be visualized in the following hypergraph:

<p align="center">
   <img src="docs/figures/wheel.png" alt="Uno hypergraph" width="40%" />
</p>

Uno currently implements the following strategies:
* **constraint relaxation strategies**: feasibility restoration;
* **inequality handling methods**: inequality constrained method, interior-point method;
* **Hessian models**: exact, L-BFGS, identity, zero;
* **inertia control strategies**: primal, primal-dual, none;
* **globalization strategies**: filter method, funnel method, merit function;
* **globalization mechanisms**: backtracking line search, trust-region method.

and the following subproblem solvers:
* QP solvers: BQPD (for nonconvex QPs), HiGHS (for convex QPs);
* LP solvers: BQPD, HiGHS
* indefinite linear solvers: HSL, MA57, MA27, MUMPS, SSIDS

You can combine these strategies in a ton of different ways via options (see [documentation](docs/options.md)). Uno also implements **presets**, that is strategy combinations that mimic existing solvers:
* `filtersqp` mimics filterSQP (trust-region feasibility restoration filter SQP method with exact Hessian);
* `ipopt` mimics IPOPT (line-search feasibility restoration filter barrier method with exact Hessian and primal-dual inertia correction).

Note that all combinations do not necessarily result in sensible algorithms, or even convergent approaches.

For more details on our unification theory, check out the [UNIFICATION](UNIFICATION.md) page, our [preprint](https://www.researchgate.net/publication/397446552_Implementing_a_unified_solver_for_nonlinearly_constrained_optimization), or my [latest slides](https://www.researchgate.net/publication/390271091).

## Who uses Uno?

Uno is currently used as a nonlinear optimization solver in: 
- [JuMP.jl](https://jump.dev/JuMP.jl/stable/installation/#Supported-solvers)
- [DNLP](https://github.com/cvxgrp/DNLP/pull/119), an extension of [CVXPY](https://www.cvxpy.org/) to general nonlinear programming
- [Vecchia.jl](https://github.com/cgeoga/Vecchia.jl), a package for Gaussian processes approximation
- [FelooPy](https://www.linkedin.com/posts/k-tafakkori_optimization101-operationsresearch-decisionscience-activity-7397646574035697664-AzmK), a user-friendly tool for coding, modeling, and solving decision problems
- [IMPL &copy; /IMPL-DATA &copy;](https://www.linkedin.com/posts/jeffrey-dean-kelly-a5420a6a_releases-cvanaretuno-activity-7388564004585160704-WSxz/) by [Industrial Algorithms Limited](https://www.industrialgorithms.ca/), a modeling and solving platform used in the process industries especially suited for economic, efficiency and emissions optimization and estimation

and more to come:
- [CasADi](https://github.com/casadi/casadi/issues/3908)
- [Pyomo](https://github.com/cvanaret/Uno/issues/319)
- [pyOptSparse](https://github.com/cvanaret/Uno/issues/318)
- [Minotaur](https://github.com/cvanaret/Uno/issues/107)
- [NEOS Server](https://neos-server.org/neos/solvers/)

## Installation instructions

See the [INSTALL](INSTALL.md) file for instructions on how to compile Uno from source or use the precompiled libraries and executables.

## Interfaces

### AMPL/nl files
Uno's AMPL executable can be compiled via the command `make uno_ampl` and requires the [AMPL Solver Library (ASL)](https://www.netlib.org/ampl/solvers/). For more details, see the [README.md](interfaces/AMPL/README.md).

### Julia
Uno can be used from Julia in two ways:

1. **Pure Julia interface**:
   [UnoSolver.jl](https://github.com/cvanaret/Uno/tree/main/interfaces/Julia) is the native Julia interface to [Uno](https://github.com/cvanaret/Uno).
   It provides direct integration with the Julia optimization ecosystem through:
   - a thin wrapper around the full C API,
   - an interface to [NLPModels.jl](https://github.com/JuliaSmoothOptimizers/NLPModels.jl) for solving problems following the NLPModels API, such as [CUTEst](https://github.com/JuliaSmoothOptimizers/CUTEst.jl), [ADNLPModels.jl](https://github.com/JuliaSmoothOptimizers/ADNLPModels.jl), or [ExaModels.jl](https://github.com/exanauts/ExaModels.jl),
   - an interface to [MathOptInterface.jl](https://github.com/jump-dev/MathOptInterface.jl) for handling [JuMP](https://github.com/jump-dev/JuMP.jl) models.

   Under the hood, `UnoSolver.jl` uses precompiled shared libraries from [Uno_jll.jl](https://github.com/JuliaBinaryWrappers/Uno_jll.jl) while exposing a high-level Julia API.
   More details can be found in the [README](https://github.com/cvanaret/Uno/tree/main/interfaces/Julia) of `UnoSolver.jl`.
   This is the recommended way of using Uno in Julia.

2. **AMPL interface**:
   Alternatively, the executable `uno_ampl` can be installed via [Uno_jll.jl](https://github.com/JuliaBinaryWrappers/Uno_jll.jl) and used through [AmplNLWriter.jl](https://juliahub.com/ui/Packages/General/AmplNLWriter.jl).
   An example can be found [here](https://discourse.julialang.org/t/the-uno-unifying-nonconvex-optimization-solver/115883/21).

### Python
[unopy](https://pypi.org/project/unopy/) is Uno's registered Python package. For more details, see [README.md](interfaces/Python/README.md).

### C
Uno's C interface is compiled as part of the Uno library. For more details, see its [README.md](interfaces/C/README.md).
It may be modified in future minor releases.

### Fortran
Uno provides a native Fortran interface built on top of its C API using `iso_c_binding`.
It closely mirrors the C interface and is designed as a lightweight wrapper with minimal overhead, making it suitable for integration into existing Fortran codes while retaining full access to Uno's features.
For more details, see its [README.md](interfaces/Fortran/README.md).

## Latest results (August 13, 2025)

Uno presets have been tested against state-of-the-art solvers on 429 small problems of the [CUTEst benchmark](https://arnold-neumaier.at/glopt/coconut/Benchmark/Library2_new_v1.html).
The figure below is a performance profile of Uno and state-of-the-art solvers filterSQP, IPOPT, SNOPT, MINOS, LANCELOT, LOQO and CONOPT; it shows how many problems are solved for a given budget of function evaluations (1 time, 2 times, 4 times, ..., $2^x$ times the number of objective evaluations of the best solver for each instance).

<p align="center">
   <img src="docs/figures/uno_performance_profile.png" alt="Performance profile of Uno" width="75%" />
</p>

All log files can be found [here](https://github.com/cvanaret/nonconvex_solver_comparison).

## How to cite Uno

We have submitted our paper to the Mathematical Programming Computation journal. The preprint is available on [ResearchGate](https://www.researchgate.net/publication/397446552_Implementing_a_unified_solver_for_nonlinearly_constrained_optimization).

Until it is published, you can use the following bibtex entry:

```
@unpublished{VanaretLeyffer2026,
  author = {Vanaret, Charlie and Leyffer, Sven},
  title = {Implementing a unified solver for nonlinearly constrained optimization},
  year = {2026},
  note = {Accepted to Mathematical Programming Computation on Feb 22, 2026}
}
```

## Credits

The theoretical abstract framework for unifying nonlinearly constrained optimization was developed by [Charlie Vanaret](https://github.com/cvanaret/) (Argonne National Laboratory & Zuse-Institut Berlin) and [Sven Leyffer](https://wiki.mcs.anl.gov/leyffer/index.php/Sven_Leyffer) (Argonne National Laboratory).
The interfaces and continuous integration infrastructure for Uno were developed and are maintained by [Alexis Montoison](https://github.com/amontoison) (Argonne National Laboratory) and Charlie Vanaret.
Uno itself was designed and implemented by Charlie Vanaret.
It is released under the MIT license (see the [license file](LICENSE)).

The contributors are (in alphabetical order):
[Oscar Dowson](https://github.com/odow), [Marcel Jacobse](https://github.com/mjacobse), [Arnav Kapoor](https://github.com/arnavk23), [David Kiessling](https://github.com/david0oo), [Rujia Liu](https://github.com/rujialiu), [Stefano Lovato](https://github.com/stefphd), [Manuel Schaich](https://github.com/worc4021), [Silvio Traversaro](https://github.com/traversaro).

The Uno logo was created by Charlie Vanaret based on a [saddle point icon by luimonts](https://thenounproject.com/icon/saddle-point-258207/) (CC BY 3.0).

# UnoSolver.jl

UnoSolver.jl is a wrapper for [Uno](https://github.com/cvanaret/Uno), a modern and modular solver for nonlinearly constrained optimization.

The package has three components:

* a thin wrapper around the complete C API,
* an interface to [NLPModels.jl](https://github.com/JuliaSmoothOptimizers/NLPModels.jl) for solving any optimization problem following the API, such as [CUTEst](https://github.com/JuliaSmoothOptimizers/CUTEst.jl) problems,
* an interface to [MathOptInterface.jl](https://github.com/jump-dev/MathOptInterface.jl) for handling [JuMP](https://github.com/jump-dev/JuMP.jl) models.

## Affiliation

This Julia interface is developed and maintained by [Alexis Montoison](https://github.com/amontoison) and [Charlie Vanaret](https://github.com/cvanaret).

## Installation

`UnoSolver.jl` is a registered Julia package, it can be installed and tested through the Julia package manager.

```julia
julia> using Pkg
julia> Pkg.add("UnoSolver")
julia> Pkg.test("UnoSolver")
```

## Examples

Below are examples showing how to use `UnoSolver.jl` with the interfaces for `NLPModels.jl` and `MathOptInterface.jl`.

```julia
using UnoSolver, CUTEst

nlp = CUTEstModel{Float64}("HS15")
stats = uno(nlp, preset="filtersqp", print_solution=true, logger="INFO")
model, solver = stats.model, stats.solver

primal_solution = stats.primal_solution
constraint_dual_solution = stats.constraint_dual_solution
lower_bound_dual_solution = stats.lower_bound_dual_solution
upper_bound_dual_solution = stats.upper_bound_dual_solution

timer = stats.cpu_time
solution_objective = stats.solution_objective
solution_primal_feasibility = stats.solution_primal_feasibility
solution_stationarity = stats.solution_stationarity
solution_complementarity = stats.solution_complementarity

niter = stats.number_iterations
nsub = stats.number_subproblem_solved_evaluations
optimization_status = stats.optimization_status
solution_status = stats.solution_status

number_objective_evaluations = stats.number_objective_evaluations
number_constraint_evaluations = stats.number_constraint_evaluations
number_objective_gradient_evaluations = stats.number_objective_gradient_evaluations
number_jacobian_evaluations = stats.number_jacobian_evaluations
number_hessian_evaluations = stats.number_hessian_evaluations
```

```julia
using UnoSolver, JuMP

jump_model = Model(() -> UnoSolver.Optimizer(preset="filtersqp"))
x0 = [-2, 1]
uvar = [0.5, Inf]
@variable(jump_model, x[i = 1:2] ≤ uvar[i], start = x0[i])
@objective(jump_model, Min, 100 * (x[2] - x[1]^2)^2 + (1 - x[1])^2)
@constraint(jump_model, x[1] * x[2] - 1 ≥ 0)
@constraint(jump_model, x[1] + x[2]^2 ≥ 0)

optimize!(jump_model)

termination_status(jump_model)  # solver termination status
objective_value(jump_model)     # objective value
value.(x)                       # primal solution
```

If you encounter any issues with the interface for JuMP problems, please [open an issue](https://github.com/cvanaret/Uno/issues) so we can fix it.
As a temporary workaround, you can use [NLPModelsJuMP.jl](https://github.com/JuliaSmoothOptimizers/NLPModelsJuMP.jl) to wrap a JuMP model into a `MathOptNLPModel`:

```julia
using UnoSolver, NLPModelsJuMP

nlp = MathOptNLPModel(jump_model)

model = uno_model(nlp)
solver = uno_solver()
uno_set_solver_preset(solver, "filtersqp")
uno_set_solver_bool_option(solver, "print_solution", true)
uno_optimize(solver, model)
stats = uno_statistics(solver, model)
```

## Linear solvers

`UnoSolver.jl` supports a number of linear solvers. If not specified by the user, the default linear solver is picked in this order (if available): MA57, MA27, MUMPS.

### LibHSL

We highly recommend downloading the latest release of [libHSL](https://licences.stfc.ac.uk/products/Software/HSL/LibHSL) and installing the official version of `HSL_jll.jl` into your current environment using:
```julia
import Pkg
Pkg.develop(path = "/full/path/to/HSL_jll.jl")
```

This optional dependency provides access to more reliable and powerful linear solvers. Currently, `UnoSolver.jl` supports `MA27` and `MA57`.
Pick a linear solver by setting the `linear_solver` attribute:
```julia
using JuMP, UnoSolver
import HSL_jll
model = Model(() -> UnoSolver.Optimizer(preset="ipopt"))
set_attribute(model, "linear_solver", "MA57")
```

### MUMPS

MUMPS can be used by setting the `linear_solver` attribute:
```julia
using JuMP, UnoSolver
model = Model(() -> UnoSolver.Optimizer(preset="ipopt"))
set_attribute(model, "linear_solver", "MUMPS")
```

## QP solvers

If not specified by the user, the default QP solver is BQPD.

### BQPD

BQPD can be used by setting the `QP_solver` attribute:
```julia
using JuMP, UnoSolver
model = Model(() -> UnoSolver.Optimizer(preset="filtersqp"))
set_attribute(model, "QP_solver", "BQPD")
```

## LP solvers

If not specified by the user, the default LP solver is BQPD.

### BQPD

BQPD can be used by setting the `LP_solver` attribute:
```julia
using JuMP, UnoSolver
model = Model(() -> UnoSolver.Optimizer(preset="filterslp"))
set_attribute(model, "LP_solver", "BQPD")
```

### HiGHS

HiGHS can be used by setting the `LP_solver` attribute:
```julia
using JuMP, UnoSolver
model = Model(() -> UnoSolver.Optimizer(preset="filterslp"))
set_attribute(model, "LP_solver", "HiGHS")
```

## BLAS and LAPACK demuxer

`Uno_jll.jl` is compiled with [libblastrampoline](https://github.com/JuliaLinearAlgebra/libblastrampoline) (LBT), a library that can switch between BLAS and LAPACK backends at runtime, such as OpenBLAS, Intel MKL, and Apple Accelerate.
The default BLAS and LAPACK backend used in the Julia interface `UnoSolver.jl` is [OpenBLAS](https://github.com/OpenMathLib/OpenBLAS).

### Display backends

You can check which backends are currently loaded with:

```julia
import LinearAlgebra
LinearAlgebra.BLAS.lbt_get_config()
```
If no `BLAS` or `LAPACK` library compiled with 32-bit integers (`LP64`) is available, `UnoSolver.jl` will automatically load a compatible version of `OpenBLAS`.
You can run the command again after `using UnoSolver` to verify which backend is in use.

### Sequential BLAS and LAPACK

If you have the LP64 reference versions of [BLAS and LAPACK](https://github.com/Reference-LAPACK/lapack) installed, you can switch to the sequential backends by running:

```julia
using ReferenceBLAS32_jll, LAPACK32_jll
LinearAlgebra.BLAS.lbt_forward(libblas32)
LinearAlgebra.BLAS.lbt_forward(liblapack32)
using UnoSolver
```

### MKL

If you have [MKL.jl](https://github.com/JuliaLinearAlgebra/MKL.jl) installed,
switch to MKL by adding `using MKL` to your code:

```julia
using MKL
using UnoSolver
```

### AppleAccelerate

If you are using macOS v13.4 or later and you have [AppleAccelerate.jl](https://github.com/JuliaLinearAlgebra/AppleAccelerate.jl) installed, add `using AppleAccelerate` to your code:

```julia
using AppleAccelerate
using UnoSolver
```

## Uno's Fortran interface: how to use Uno from Fortran

Uno provides a Fortran interface built on top of the Uno C API using the module `iso_c_binding`.

To balance completeness and Fortran usability, the interface is split into two files:

* [`uno_c.f90`](uno_c.f90)
* [`uno_fortran.f90`](uno_fortran.f90)

The file `uno_c.f90` defines low-level C bindings for all routines that do not involve C strings, together with all Uno constants, enumerations, and type definitions.
Functions whose signatures contain `char *` arguments or return values are intentionally excluded.

The file `uno_fortran.f90` complements this layer by providing Fortran-friendly wrappers for all string-based C API routines.
These wrappers handle the conversion between Fortran `character` variables and null-terminated C strings, as well as the associated memory management.

Used together, `uno_c.f90` and `uno_fortran.f90` provide complete access to the Uno C API.
Both files must be included when using Uno from Fortran and linked against the Uno library (`libuno`).

An example program is available in [`example_uno.f90`](example_uno.f90).

### Basic usage

Start by including the Fortran interface:

```fortran
include 'uno_c.f90'
...
contains
  include 'uno_fortran.f90'
...
```

### Using the interface as a Fortran module (optional)

You can also wrap the interface in a module for cleaner `use` statements:

```fortran
module uno
  include 'uno_c.f90'
contains
  include 'uno_fortran.f90'
end module
```

Then simply use it in your program:

```fortran
program my_program
  use uno
  ...
end program
```

This approach avoids `include` statements scattered in your code and allows standard module scoping.

**Remark**: We provide the Fortran interface as include files rather than a precompiled module to maximize portability.
Fortran `.mod` files are compiler-specific and can cause issues when cross-compiling or using different compilers.
By including the source directly, users avoid these problems and can build the interface consistently across platforms.

### Building an optimization model

Building an optimization model is incremental and starts with the variables:

```fortran
type(c_ptr) :: model
model = uno_create_model(problem_type, number_variables, &
                         variables_lower_bounds, variables_upper_bounds, &
                         base_indexing)
```

The following optional elements can be added to the model separately:

* the objective function and its gradient:

```fortran
logical(c_bool) :: success
success = uno_set_objective(model, optimization_sense, &
                            objective_function, objective_gradient)
```

* constraint functions and their Jacobian:

```fortran
logical(c_bool) :: success
success = uno_set_constraints(model, number_constraints, constraint_functions, &
                              constraints_lower_bounds, constraints_upper_bounds, &
                              number_jacobian_nonzeros, jacobian_row_indices, &
                              jacobian_column_indices, jacobian)
```

* the Lagrangian Hessian:

```fortran
logical(c_bool) :: success
success = uno_set_lagrangian_hessian(model, number_hessian_nonzeros, &
                                     hessian_triangular_part, &
                                     hessian_row_indices, hessian_column_indices, &
                                     lagrangian_hessian)
```

* a Jacobian operator:

```fortran
logical(c_bool) :: success
success = uno_set_jacobian_operator(model, jacobian_operator)
```

* a Jacobian-transposed operator:

```fortran
logical(c_bool) :: success
success = uno_set_jacobian_transposed_operator(model, jacobian_transposed_operator)
```

* a Hessian operator:

```fortran
logical(c_bool) :: success
success = uno_set_lagrangian_hessian_operator(model, lagrangian_hessian_operator)
```

* the Lagrangian sign convention (default is `UNO_MULTIPLIER_NEGATIVE`):

```fortran
logical(c_bool) :: success
success = uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention)
```

* user-defined data:

```fortran
logical(c_bool) :: success
success = uno_set_user_data(model, user_data)
```

* an initial primal point:

```fortran
logical(c_bool) :: success
success = uno_set_initial_primal_iterate(model, initial_primal_iterate)
```

* an initial dual point:

```fortran
logical(c_bool) :: success
success = uno_set_initial_dual_iterate(model, initial_dual_iterate)
```

The memory for the model is allocated by Uno and must be freed with:

```fortran
call uno_destroy_model(model)
```

### Creating an instance of the Uno solver

Create a solver instance with:

```fortran
type(c_ptr) :: solver
solver = uno_create_solver()
```

The memory for the solver is allocated by Uno must be freed with:

```fortran
call uno_destroy_solver(solver)
```

### Passing options to the Uno solver

Options can be passed individually:

```fortran
logical(c_bool) :: success
integer(uno_int) :: max_iterations = 1000
real(c_double) :: primal_tolerance = 1.0d-6
logical(c_bool) :: print_solution = .true.
character(len=*) :: hessian_model = "exact"

success = uno_set_solver_integer_option(solver, "max_iterations", max_iterations)
success = uno_set_solver_double_option(solver, "primal_tolerance", primal_tolerance)
success = uno_set_solver_bool_option(solver, "print_solution", print_solution)
success = uno_set_solver_string_option(solver, "hessian_model", hessian_model)
```

Loading options from a file:

```fortran
logical(c_bool) :: success
character(len=*) :: option_file = "uno.opt"

success = uno_load_solver_option_file(solver, option_file)
```

Getting option values:

```fortran
integer(uno_int) :: max_iterations
real(c_double) :: primal_tolerance
logical(c_bool) :: print_solution

max_iterations = uno_get_solver_integer_option(solver, "max_iterations")
primal_tolerance = uno_get_solver_double_option(solver, "primal_tolerance")
print_solution = uno_get_solver_bool_option(solver, "print_solution")
```

Setting a preset:

```fortran
logical(c_bool) :: success
success = uno_set_solver_preset(solver, "filtersqp")
```

### Solving the model

Solve the optimization problem with:

```fortran
call uno_optimize(solver, model)
```

### Inspecting the result

The following routines allow you to inspect the solution:

* optimization status:

```fortran
integer(uno_int) :: optimization_status
optimization_status = uno_get_optimization_status(solver)
```

* solution status:

```fortran
integer(uno_int) :: solution_status
solution_status = uno_get_solution_status(solver)
```

* objective value:

```fortran
real(c_double) :: objective
objective = uno_get_solution_objective(solver)
```

* primal solution:

```fortran
real(c_double), dimension(number_variables) :: primal_solution
call uno_get_primal_solution(solver, primal_solution)
```

* dual solutions:

```fortran
real(c_double), dimension(number_variables) :: lower_bound_dual_solution, upper_bound_dual_solution
real(c_double), dimension(number_constraints) :: constraint_dual_solution

call uno_get_constraint_dual_solution(solver, constraint_dual_solution)
call uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)
call uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)
```

* optimality measures:

```fortran
real(c_double) :: primal_feasibility, stationarity, complementarity
primal_feasibility = uno_get_solution_primal_feasibility(solver)
stationarity = uno_get_solution_stationarity(solver)
complementarity = uno_get_solution_complementarity(solver)
```

* solver statistics:

```fortran
integer(uno_int) :: number_iterations
real(c_double) :: cpu_time

number_iterations  = uno_get_number_iterations(solver)
cpu_time = uno_get_cpu_time(solver)
```

## Uno's AMPL interface

To solve an AMPL model in the [.nl format](https://en.wikipedia.org/wiki/Nl_(format)), move to the `build` directory and:
- run `cmake` with the path to the ASL library: `-DAMPLSOLVER=path`
- compile the executable ```make uno_ampl```
- run the command ```./uno_ampl model.nl [-AMPL] [option=value ...]``` where ```[option=value ...]``` is a list of options separated by spaces. If the `-AMPL` flag is supplied, the solution is written to the AMPL solution file `model.sol`

Options can be set in three different ways (with decreasing precedence):
- passing an option file (`option_file=file`) that contains `option value` on each line;
- setting a preset that mimics an existing solver (`preset=[filtersqp|ipopt]`);
- setting individual options (see the [default options](https://github.com/cvanaret/Uno/blob/main/docs/options.md)).
For an overview of the available strategies, type: ```./uno_ampl --strategies```:

A couple of CUTEst instances are available in the `/examples` directory.

## Uno's C interface: how to use Uno from C

Uno's C interface allows you to solve an optimization model described by callback functions.
The file `Uno_C_API.cpp` is compiled as part of `libuno` (static or shared) via `make`, and the header `Uno_C_API.h` is installed via `make install`.
An example is available in the file [example_hs015.c](example/example_hs015.c).

Start by including the Uno header:

```c
#include "Uno_C_API.h"
```

### Building an optimization model

Building an optimization model is incremental and starts with the information about the variables:

```c
void* model = uno_create_model(problem_type, number_variables,
   variables_lower_bounds, variables_upper_bounds, base_indexing);
```

The following optional elements can be added to the model separately:
- the objective function (and its gradient). It is 0 otherwise;
```c
uno_set_objective(model, optimization_sense, objective_function, objective_gradient);
```
- constraint functions (and their Jacobian);
```c
uno_set_constraints(model, number_constraints, constraint_functions,
   constraints_lower_bounds, constraints_upper_bounds, number_jacobian_nonzeros,
   jacobian_row_indices, jacobian_column_indices, jacobian);
```
- the Lagrangian Hessian;
```c
uno_set_lagrangian_hessian(model, number_hessian_nonzeros, hessian_triangular_part, 
   hessian_row_indices, hessian_column_indices, lagrangian_hessian);
```
- a Jacobian operator (performs Jacobian-vector products);
```c
uno_set_jacobian_operator(model, jacobian_operator);
```
- a Jacobian-transposed operator (performs Jacobian-transposed-vector products);
```c
uno_set_jacobian_transposed_operator(model, jacobian_transposed_operator);
```
- a Hessian operator (performs Hessian-vector products);
```c
uno_set_lagrangian_hessian_operator(model, lagrangian_hessian_operator);
```
- a Lagrangian sign convention (default is `UNO_MULTIPLIER_NEGATIVE`);
```c
uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention);
```
- user data of an arbitrary type (`void*`);
```c
uno_set_user_data(model, user_data);
```
- an initial primal point;
```c
uno_set_initial_primal_iterate(model, initial_primal_iterate);
```
- an initial dual point.
```c
uno_set_initial_dual_iterate(model, initial_dual_iterate);
```

*Each of these functions returns an integer that is 0 upon success and positive upon failure.*

The memory for the model is allocated by the C interface and must be freed by a call to the function:
```c
uno_destroy_model(model);
```

### Creating an instance of the Uno solver

Create an instance of the Uno solver with a simple function call.
```c
void* solver = uno_create_solver();
```

The memory for the solver is allocated by the C interface and must be freed by a call to the function:
```c
uno_destroy_solver(solver);
```

### Passing options to the Uno solver

Options can be passed to the Uno solver:
```c
uno_set_solver_integer_option(solver, "max_iterations", 1000);
uno_set_solver_double_option(solver, "primal_tolerance", 1.0e-6);
uno_set_solver_bool_option(solver, "print_solution", true);
uno_set_solver_string_option(solver, "hessian_model", "exact");
```

Loading options from a file (overwrites existing options):
```c
uno_load_solver_option_file(solver, "uno.opt");
```

Getting typed value of an option from the Uno solver:
```c
uno_int uno_get_solver_integer_option(solver, "max_iterations");
size_t uno_get_solver_unsigned_integer_option(solver, "max_iterations");
double uno_set_solver_double_option(solver, "primal_tolerance");
bool uno_get_solver_bool_option(solver, "print_solution");
const char* uno_get_solver_string_option(solver, "hessian_model");
```

Setting a preset has Uno mimic an existing solver:
```c
uno_set_solver_preset(solver, "filtersqp");
```

## Setting solver callbacks

Setting the user callbacks to the Uno solver:
```c
uno_set_solver_callbacks(solver, notify_acceptable_iterate_callback, user_termination_callback, user_data);
```

Setting the logger stream callback:
```c
uno_set_logger_stream_callback(logger_stream_callback, user_data);
```

and reset the logger stream to the standard output:
```c
uno_reset_logger_stream();
```

### Solving the model

The model can then be solved by Uno:
```c
uno_optimize(solver, model);
```

### Inspecting the result

A set of functions allows you to inspect the result of the optimization:
- the optimization status (`UNO_SUCCESS`, `UNO_ITERATION_LIMIT`, `UNO_TIME_LIMIT`, `UNO_EVALUATION_ERROR`, `UNO_ALGORITHMIC_ERROR`):
```c
uno_get_optimization_status(solver);
```
- the solution status (`UNO_NOT_OPTIMAL`, `UNO_FEASIBLE_KKT_POINT`, `UNO_FEASIBLE_FJ_POINT`, `UNO_INFEASIBLE_STATIONARY_POINT`, `UNO_FEASIBLE_SMALL_STEP`, `UNO_INFEASIBLE_SMALL_STEP`, `UNO_UNBOUNDED`):
```c
uno_int uno_get_solution_status(solver);
```
- the objective value of the solution:
```c
double uno_get_solution_objective(solver);
```
- the primal solution:
```c
void uno_get_primal_solution(solver, primal_solution);
```
- the dual solution associated with the general constraints:
```c
void uno_get_constraint_dual_solution(solver, constraint_dual_solution);
```
- the dual solution associated with the lower bounds:
```c
void uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution);
```
- the dual solution associated with the upper bounds:
```c
void uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution);
```
- the primal feasibility measure at the solution:
```c
double uno_get_solution_primal_feasibility(solver);
```
- the stationarity measure at the solution:
```c
double uno_get_solution_stationarity(solver);
```
- the complementarity measure at the solution:
```c
double uno_get_solution_complementarity(solver);
```

## Uno

Uno is a solver for nonlinearly constrained optimization that unifies Lagrange-Newton (essentially **SQP** and **interior-point**) methods.
It breaks them down into a set of common building blocks (e.g., strategies to compute descent directions and techniques to enforce globalization).

`unopy`, Uno's Python interface, allows you to solve an optimization model described by callback functions.

## Example

An implementation example of the Hock-Schittkowski model [hs015](https://vanderbei.princeton.edu/ampl/nlmodels/hs/hs015.mod) is available in the file [example_hs015.py](https://github.com/cvanaret/Uno/blob/main/interfaces/Python/example/example_hs015.py).

### Building an optimization model

Building an optimization model is incremental and starts with the information about the variables:

```python
model = unopy.Model(problem_type, number_variables,
   variables_lower_bounds, variables_upper_bounds, base_indexing)
```

The following optional elements can be added to the model separately:
- the objective function (and its gradient). It is 0 otherwise;
```python
model.set_objective(optimization_sense, objective_function, objective_gradient)
```
- constraint functions (and their Jacobian);
```python
model.set_constraints(number_constraints, constraint_functions,
   constraints_lower_bounds, constraints_upper_bounds, number_jacobian_nonzeros,
   jacobian_row_indices, jacobian_column_indices, jacobian)
```
- the Lagrangian Hessian;
```python
model.set_lagrangian_hessian(number_hessian_nonzeros, hessian_triangular_part, 
   hessian_row_indices, hessian_column_indices, lagrangian_hessian)
```
- a Jacobian operator (performs Jacobian-vector products);
```python
model.set_jacobian_operator(jacobian_operator)
```
- a Jacobian-transposed operator (performs Jacobian-transposed-vector products);
```python
model.set_jacobian_transposed_operator(jacobian_transposed_operator)
```
- a Hessian operator (performs Hessian-vector products);
```python
model.set_lagrangian_hessian_operator(lagrangian_hessian_operator)
```
- a Lagrangian sign convention (default is `unopy.MULTIPLIER_NEGATIVE`);
```python
model.set_lagrangian_sign_convention(lagrangian_sign_convention)
```
- user data of an arbitrary type;
```python
model.set_user_data(user_data)
```
- an initial primal point;
```python
model.set_initial_primal_iterate(initial_primal_iterate)
```
- an initial dual point.
```python
model.set_initial_dual_iterate(initial_dual_iterate)
```

*Each of these functions throws an exception upon failure.*

### Creating an instance of the Uno solver

Create an instance of the Uno solver with a simple function call:
```python
uno_solver = unopy.UnoSolver()
```

### Passing options to the Uno solver

Options can be passed to the Uno solver:
```python
uno_solver.set_option("print_solution", True)
```

Uno mimics the state-of-the-art solvers filterSQP and IPOPT via presets:
```python
uno_solver.set_preset("filtersqp")
# or
uno_solver.set_preset("ipopt")
```

### Solving the model

The model can then be solved by Uno:
```python
result = uno_solver.optimize(model)
```

### Inspecting the result

To inspect the result of the optimization, read the attributes of the `result` object:
- the optimization status (`UNO_SUCCESS`, `UNO_ITERATION_LIMIT`, `UNO_TIME_LIMIT`, `UNO_EVALUATION_ERROR`, `UNO_ALGORITHMIC_ERROR`): `result.optimization_status`
- the solution status (`UNO_NOT_OPTIMAL`, `UNO_FEASIBLE_KKT_POINT`, `UNO_FEASIBLE_FJ_POINT`, `UNO_INFEASIBLE_STATIONARY_POINT`, `UNO_FEASIBLE_SMALL_STEP`, `UNO_INFEASIBLE_SMALL_STEP`, `UNO_UNBOUNDED`): `result.solution_status`
- the objective value of the solution: `result.solution_objective`
- the primal solution: `result.primal_solution`
- the dual solution associated with the general constraints: `result.constraint_dual_solution`
- the dual solution associated with the lower bounds: `result.lower_bound_dual_solution`
- the dual solution associated with the upper bounds: `result.upper_bound_dual_solution`
- the primal feasibility residual at the solution: `result.solution_primal_feasibility`
- the stationarity residual at the solution: `result.solution_stationarity`
- the complementarity residual at the solution: `result.solution_complementarity`
- the number of (outer) iterations: `result.number_iterations`
- the CPU time (in seconds): `result.cpu_time`
- the number of objective evaluations: `result.number_objective_evaluations`
- the number of constraint evaluations: `result.number_constraint_evaluations`
- the number of objective gradient evaluations: `result.number_objective_gradient_evaluations`
- the number of Jacobian evaluations: `result.number_jacobian_evaluations`
- the number of Hessian evaluations: `result.number_hessian_evaluations`
- the number of subproblems solved: `result.number_subproblems_solved`

## How to cite Uno

We have submitted our paper to the Mathematical Programming Computation journal. The preprint is available on [ResearchGate](https://www.researchgate.net/publication/397446552_Implementing_a_unified_solver_for_nonlinearly_constrained_optimization).

Until it is published, you can use the following bibtex entry:

```
@unpublished{VanaretLeyffer2024,
  author = {Vanaret, Charlie and Leyffer, Sven},
  title = {Implementing a unified solver for nonlinearly constrained optimization},
  year = {2024},
  note = {Submitted to Mathematical Programming Computation}
}
```

# Wrapping headers

This directory contains a script `wrapper.jl` that can be used to automatically generate wrappers from the C headers of Uno.
This is done using [Clang.jl](https://github.com/JuliaInterop/Clang.jl).

# Usage

Activate and instantiate the project environment in this folder
to install the dependencies `Uno_jll.jl`, `Clang.jl` and `JuliaFormatter.jl`:
```julia
shell> cd interfaces/Julia/gen
shell> julia --project
julia> ]
(gen) pkg> instantiate
```

Then, regenerate the Julia wrappers with the following commands:
```julia
julia> include("wrapper.jl")
julia> main()
```

If you have already instantiated the environment, you can also run:
```bash
julia --project wrapper.jl
```

Note that if new constants are added to `Uno_C_API.h`, a manual update of `prologue.jl` is required.

! Copyright (c) 2026 Alexis Montoison and Charlie Vanaret
! Licensed under the MIT license. See LICENSE file in the project directory for details.

!==============================================================
! Fortran interfaces -- uno_c.f90
!==============================================================

use, intrinsic :: iso_c_binding

!---------------------------------------------
! uno_int
!---------------------------------------------
integer, parameter :: uno_int = c_int32_t

!---------------------------------------------
! Optimization sense
!---------------------------------------------
integer(uno_int), parameter :: UNO_MINIMIZE =  1
integer(uno_int), parameter :: UNO_MAXIMIZE = -1

!---------------------------------------------
! Lagrange multiplier sign convention
!---------------------------------------------
integer(uno_int), parameter :: UNO_MULTIPLIER_POSITIVE =  1
integer(uno_int), parameter :: UNO_MULTIPLIER_NEGATIVE = -1

!---------------------------------------------
! Problem type
!---------------------------------------------
character(len=2), parameter :: UNO_PROBLEM_LINEAR = "LP"
character(len=2), parameter :: UNO_PROBLEM_QUADRATIC = "QP"
character(len=3), parameter :: UNO_PROBLEM_NONLINEAR = "NLP"

!---------------------------------------------
! Base indexing style
!---------------------------------------------
integer(uno_int), parameter :: UNO_ZERO_BASED_INDEXING = 0
integer(uno_int), parameter :: UNO_ONE_BASED_INDEXING  = 1

!---------------------------------------------
! Triangular part
!---------------------------------------------
character(c_char), parameter :: UNO_LOWER_TRIANGLE = 'L'
character(c_char), parameter :: UNO_UPPER_TRIANGLE = 'U'

!---------------------------------------------
! Option type
!---------------------------------------------
integer(uno_int), parameter :: UNO_OPTION_TYPE_INTEGER   =  0
integer(uno_int), parameter :: UNO_OPTION_TYPE_DOUBLE    =  1
integer(uno_int), parameter :: UNO_OPTION_TYPE_BOOL      =  2
integer(uno_int), parameter :: UNO_OPTION_TYPE_STRING    =  3
integer(uno_int), parameter :: UNO_OPTION_TYPE_NOT_FOUND = -1

!---------------------------------------------
! Optimization status
!---------------------------------------------
integer(uno_int), parameter :: UNO_SUCCESS           = 0
integer(uno_int), parameter :: UNO_ITERATION_LIMIT   = 1
integer(uno_int), parameter :: UNO_TIME_LIMIT        = 2
integer(uno_int), parameter :: UNO_EVALUATION_ERROR  = 3
integer(uno_int), parameter :: UNO_ALGORITHMIC_ERROR = 4
integer(uno_int), parameter :: UNO_USER_TERMINATION  = 5

!---------------------------------------------
! Iterate status
!---------------------------------------------
integer(uno_int), parameter :: UNO_NOT_OPTIMAL                 = 0
integer(uno_int), parameter :: UNO_FEASIBLE_KKT_POINT          = 1
integer(uno_int), parameter :: UNO_FEASIBLE_FJ_POINT           = 2
integer(uno_int), parameter :: UNO_INFEASIBLE_STATIONARY_POINT = 3
integer(uno_int), parameter :: UNO_FEASIBLE_SMALL_STEP         = 4
integer(uno_int), parameter :: UNO_INFEASIBLE_SMALL_STEP       = 5
integer(uno_int), parameter :: UNO_UNBOUNDED                   = 6

!---------------------------------------------
! Uno version
!---------------------------------------------
integer(uno_int), parameter :: UNO_VERSION_MAJOR = 2
integer(uno_int), parameter :: UNO_VERSION_MINOR = 5
integer(uno_int), parameter :: UNO_VERSION_PATCH = 0

!---------------------------------------------
! uno_get_version
!---------------------------------------------
interface
   subroutine uno_get_version(major, minor, patch) &
      bind(C, name="uno_get_version")
      import :: uno_int
      integer(uno_int) :: major, minor, patch
   end subroutine uno_get_version
end interface

!---------------------------------------------
! uno_set_objective
!---------------------------------------------
interface
   function uno_set_objective(model, optimization_sense, objective_function, &
                              objective_gradient) result(success) &
      bind(C, name="uno_set_objective")
      import :: c_ptr, uno_int, c_funptr, c_bool
      type(c_ptr), value :: model
      integer(uno_int), value :: optimization_sense
      type(c_funptr), value :: objective_function
      type(c_funptr), value :: objective_gradient
      logical(c_bool) :: success
   end function uno_set_objective
end interface

!---------------------------------------------
! uno_set_constraints
!---------------------------------------------
interface
   function uno_set_constraints(model, number_constraints, constraint_functions,        &
                                constraints_lower_bounds, constraints_upper_bounds,     &
                                number_jacobian_nonzeros, jacobian_row_indices,         &
                                jacobian_column_indices, jacobian) result(success) &
      bind(C, name="uno_set_constraints")
      import :: c_ptr, uno_int, c_double, c_bool, c_funptr
      type(c_ptr), value :: model
      integer(uno_int), value :: number_constraints, number_jacobian_nonzeros
      type(c_funptr), value :: constraint_functions, jacobian
      real(c_double), dimension(*) :: constraints_lower_bounds, constraints_upper_bounds
      integer(uno_int), dimension(*) :: jacobian_row_indices, jacobian_column_indices
      logical(c_bool) :: success
   end function uno_set_constraints
end interface

!---------------------------------------------
! uno_set_jacobian_operator
!---------------------------------------------
interface
   function uno_set_jacobian_operator(model, jacobian_operator) result(success) &
      bind(C, name="uno_set_jacobian_operator")
      import :: c_ptr, c_bool, c_funptr
      type(c_ptr), value :: model
      type(c_funptr), value :: jacobian_operator
      logical(c_bool) :: success
   end function uno_set_jacobian_operator
end interface

!---------------------------------------------
! uno_set_jacobian_transposed_operator
!---------------------------------------------
interface
   function uno_set_jacobian_transposed_operator(model, jacobian_transposed_operator) result(success) &
      bind(C, name="uno_set_jacobian_transposed_operator")
      import :: c_ptr, c_bool, c_funptr
      type(c_ptr), value :: model
      type(c_funptr), value :: jacobian_transposed_operator
      logical(c_bool) :: success
   end function uno_set_jacobian_transposed_operator
end interface

!---------------------------------------------
! uno_set_lagrangian_hessian
!---------------------------------------------
interface
   function uno_set_lagrangian_hessian(model, number_hessian_nonzeros, hessian_triangular_part, &
                                       hessian_row_indices, hessian_column_indices, lagrangian_hessian) result(success) &
      bind(C, name="uno_set_lagrangian_hessian")
      import :: c_ptr, uno_int, c_double, c_bool, c_char, c_funptr
      type(c_ptr), value :: model
      integer(uno_int), value :: number_hessian_nonzeros
      character(c_char), value :: hessian_triangular_part
      integer(uno_int), dimension(*) :: hessian_row_indices, hessian_column_indices
      type(c_funptr), value :: lagrangian_hessian
      logical(c_bool) :: success
   end function uno_set_lagrangian_hessian
end interface

!---------------------------------------------
! uno_set_lagrangian_hessian_operator
!---------------------------------------------
interface
   function uno_set_lagrangian_hessian_operator(model, lagrangian_hessian_operator) result(success) &
      bind(C, name="uno_set_lagrangian_hessian_operator")
      import :: c_ptr, c_bool, c_funptr
      type(c_ptr), value :: model
      type(c_funptr), value :: lagrangian_hessian_operator
      logical(c_bool) :: success
   end function uno_set_lagrangian_hessian_operator
end interface

!---------------------------------------------
! uno_set_lagrangian_sign_convention
!---------------------------------------------
interface
   function uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention) result(success) &
      bind(C, name="uno_set_lagrangian_sign_convention")
      import :: c_ptr, uno_int, c_bool
      type(c_ptr), value :: model
      integer(uno_int), value :: lagrangian_sign_convention
      logical(c_bool) :: success
   end function uno_set_lagrangian_sign_convention
end interface

!---------------------------------------------
! uno_set_user_data
!---------------------------------------------
interface
   function uno_set_user_data(model, user_data) result(success) &
      bind(C, name="uno_set_user_data")
      import :: c_ptr, c_bool
      type(c_ptr), value :: model, user_data
      logical(c_bool) :: success
   end function uno_set_user_data
end interface

!---------------------------------------------
! uno_set_initial_primal_iterate_component
!---------------------------------------------
interface
   function uno_set_initial_primal_iterate_component(model, index, initial_primal_component) result(success) &
      bind(C, name="uno_set_initial_primal_iterate_component")
      import :: c_ptr, uno_int, c_double, c_bool
      type(c_ptr), value :: model
      integer(uno_int), value :: index
      real(c_double) :: initial_primal_component
      logical(c_bool) :: success
   end function uno_set_initial_primal_iterate_component
end interface

!---------------------------------------------
! uno_set_initial_dual_iterate_component
!---------------------------------------------
interface
   function uno_set_initial_dual_iterate_component(model, index, initial_dual_component) result(success) &
      bind(C, name="uno_set_initial_dual_iterate_component")
      import :: c_ptr, uno_int, c_double, c_bool
      type(c_ptr), value :: model
      integer(uno_int), value :: index
      real(c_double) :: initial_dual_component
      logical(c_bool) :: success
   end function uno_set_initial_dual_iterate_component
end interface

!---------------------------------------------
! uno_set_initial_primal_iterate
!---------------------------------------------
interface
   function uno_set_initial_primal_iterate(model, initial_primal_iterate) result(success) &
      bind(C, name="uno_set_initial_primal_iterate")
      import :: c_ptr, c_double, c_bool
      type(c_ptr), value :: model
      real(c_double), dimension(*) :: initial_primal_iterate
      logical(c_bool) :: success
   end function uno_set_initial_primal_iterate
end interface

!---------------------------------------------
! uno_set_initial_dual_iterate
!---------------------------------------------
interface
   function uno_set_initial_dual_iterate(model, initial_dual_iterate) result(success) &
      bind(C, name="uno_set_initial_dual_iterate")
      import :: c_ptr, c_double, c_bool
      type(c_ptr), value :: model
      real(c_double), dimension(*) :: initial_dual_iterate
      logical(c_bool) :: success
   end function uno_set_initial_dual_iterate
end interface

!---------------------------------------------
! uno_create_solver
!---------------------------------------------
interface
   function uno_create_solver() result(solver) &
      bind(C, name="uno_create_solver")
      import :: c_ptr
      type(c_ptr) :: solver
   end function uno_create_solver
end interface

!---------------------------------------------
! uno_set_solver_callbacks
!---------------------------------------------
interface
   function uno_set_solver_callbacks(solver, notify_acceptable_iterate_callback, &
                                     user_termination_callback, user_data) &
                                     result(success) &
      bind(C, name="uno_set_solver_callbacks")
      import :: c_ptr, c_funptr, c_bool
      type(c_ptr), value :: solver, user_data
      type(c_funptr), value :: notify_acceptable_iterate_callback, user_termination_callback
      logical(c_bool) :: success
   end function uno_set_solver_callbacks
end interface

!---------------------------------------------
! uno_set_logger_stream_callback
!---------------------------------------------
interface
   function uno_set_logger_stream_callback(logger_stream_callback, user_data) &
                                           result(success) &
      bind(C, name="uno_set_logger_stream_callback")
      import :: c_ptr, c_funptr, c_bool
      type(c_ptr), value :: user_data
      type(c_funptr), value :: logger_stream_callback
      logical(c_bool) :: success
   end function uno_set_logger_stream_callback
end interface

!---------------------------------------------
! uno_reset_logger_stream
!---------------------------------------------
interface
   function uno_reset_logger_stream() result(success) &
      bind(C, name="uno_reset_logger_stream")
      import :: c_bool
      logical(c_bool) :: success
   end function uno_reset_logger_stream
end interface

!---------------------------------------------
! uno_optimize
!---------------------------------------------
interface
   subroutine uno_optimize(solver, model) &
      bind(C, name="uno_optimize")
      import :: c_ptr
      type(c_ptr), value :: solver, model
   end subroutine uno_optimize
end interface

!---------------------------------------------
! uno_get_solution_status
!---------------------------------------------
interface
   function uno_get_optimization_status(solver) result(optimization_status) &
      bind(C, name="uno_get_optimization_status")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: optimization_status
   end function uno_get_optimization_status
end interface

!---------------------------------------------
! uno_get_solution_status
!---------------------------------------------
interface
   function uno_get_solution_status(solver) result(solution_status) &
      bind(C, name="uno_get_solution_status")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: solution_status
   end function uno_get_solution_status
end interface

!---------------------------------------------
! uno_get_solution_objective
!---------------------------------------------
interface
   function uno_get_solution_objective(solver) result(solution_objective) &
      bind(C, name="uno_get_solution_objective")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double) :: solution_objective
   end function uno_get_solution_objective
end interface

!---------------------------------------------
! uno_get_primal_solution_component
!---------------------------------------------
interface
   function uno_get_primal_solution_component(solver, index) result(primal_solution_component) &
      bind(C, name="uno_get_primal_solution_component")
      import :: c_ptr, uno_int, c_double
      type(c_ptr), value :: solver
      integer(uno_int), value :: index
      real(c_double) :: primal_solution_component
   end function uno_get_primal_solution_component
end interface

!---------------------------------------------
! uno_get_constraint_dual_solution_component
!---------------------------------------------
interface
   function uno_get_constraint_dual_solution_component(solver, index) result(constraint_dual_solution_component) &
      bind(C, name="uno_get_constraint_dual_solution_component")
      import :: c_ptr, uno_int, c_double
      type(c_ptr), value :: solver
      integer(uno_int), value :: index
      real(c_double) :: constraint_dual_solution_component
   end function uno_get_constraint_dual_solution_component
end interface

!---------------------------------------------
! uno_get_lower_bound_dual_solution_component
!---------------------------------------------
interface
   function uno_get_lower_bound_dual_solution_component(solver, index) result(lower_bound_dual_solution_component) &
      bind(C, name="uno_get_lower_bound_dual_solution_component")
      import :: c_ptr, uno_int, c_double
      type(c_ptr), value :: solver
      integer(uno_int), value :: index
      real(c_double) :: lower_bound_dual_solution_component
   end function uno_get_lower_bound_dual_solution_component
end interface

!---------------------------------------------
! uno_get_upper_bound_dual_solution_component
!---------------------------------------------
interface
   function uno_get_upper_bound_dual_solution_component(solver, index) result(upper_bound_dual_solution_component) &
      bind(C, name="uno_get_upper_bound_dual_solution_component")
      import :: c_ptr, uno_int, c_double
      type(c_ptr), value :: solver
      integer(uno_int), value :: index
      real(c_double) :: upper_bound_dual_solution_component
   end function uno_get_upper_bound_dual_solution_component
end interface

!---------------------------------------------
! uno_get_primal_solution
!---------------------------------------------
interface
   subroutine uno_get_primal_solution(solver, primal_solution) &
      bind(C, name="uno_get_primal_solution")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double), dimension(*) :: primal_solution
   end subroutine uno_get_primal_solution
end interface

!---------------------------------------------
! uno_get_constraint_dual_solution
!---------------------------------------------
interface
   subroutine uno_get_constraint_dual_solution(solver, constraint_dual_solution) &
      bind(C, name="uno_get_constraint_dual_solution")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double), dimension(*) :: constraint_dual_solution
   end subroutine uno_get_constraint_dual_solution
end interface

!---------------------------------------------
! uno_get_lower_bound_dual_solution
!---------------------------------------------
interface
   subroutine uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution) &
      bind(C, name="uno_get_lower_bound_dual_solution")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double), dimension(*) :: lower_bound_dual_solution
   end subroutine uno_get_lower_bound_dual_solution
end interface

!---------------------------------------------
! uno_get_upper_bound_dual_solution
!---------------------------------------------
interface
   subroutine uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution) &
      bind(C, name="uno_get_upper_bound_dual_solution")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double), dimension(*) :: upper_bound_dual_solution
   end subroutine uno_get_upper_bound_dual_solution
end interface

!---------------------------------------------
! uno_get_solution_primal_feasibility
!---------------------------------------------
interface
   function uno_get_solution_primal_feasibility(solver) result(solution_primal_feasibility) &
      bind(C, name="uno_get_solution_primal_feasibility")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double) :: solution_primal_feasibility
   end function uno_get_solution_primal_feasibility
end interface

!---------------------------------------------
! uno_get_solution_stationarity
!---------------------------------------------
interface
   function uno_get_solution_stationarity(solver) result(solution_stationarity) &
      bind(C, name="uno_get_solution_stationarity")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double) :: solution_stationarity
   end function uno_get_solution_stationarity
end interface

!---------------------------------------------
! uno_get_solution_complementarity
!---------------------------------------------
interface
   function uno_get_solution_complementarity(solver) result(solution_complementarity) &
      bind(C, name="uno_get_solution_complementarity")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double) :: solution_complementarity
   end function uno_get_solution_complementarity
end interface

!---------------------------------------------
! uno_get_number_iterations
!---------------------------------------------
interface
   function uno_get_number_iterations(solver) result(number_iterations) &
      bind(C, name="uno_get_number_iterations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_iterations
   end function uno_get_number_iterations
end interface

!---------------------------------------------
! uno_get_cpu_time
!---------------------------------------------
interface
   function uno_get_cpu_time(solver) result(cpu_time) &
      bind(C, name="uno_get_cpu_time")
      import :: c_ptr, c_double
      type(c_ptr), value :: solver
      real(c_double) :: cpu_time
   end function uno_get_cpu_time
end interface

!---------------------------------------------
! uno_get_number_objective_evaluations
!---------------------------------------------
interface
   function uno_get_number_objective_evaluations(solver) result(number_objective_evaluations) &
      bind(C, name="uno_get_number_objective_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_objective_evaluations
   end function uno_get_number_objective_evaluations
end interface

!---------------------------------------------
! uno_get_number_constraint_evaluations
!---------------------------------------------
interface
   function uno_get_number_constraint_evaluations(solver) result(number_constraint_evaluations) &
      bind(C, name="uno_get_number_constraint_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_constraint_evaluations
   end function uno_get_number_constraint_evaluations
end interface

!---------------------------------------------
! uno_get_number_objective_gradient_evaluations
!---------------------------------------------
interface
   function uno_get_number_objective_gradient_evaluations(solver) result(number_objective_gradient_evaluations) &
      bind(C, name="uno_get_number_objective_gradient_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_objective_gradient_evaluations
   end function uno_get_number_objective_gradient_evaluations
end interface

!---------------------------------------------
! uno_get_number_jacobian_evaluations
!---------------------------------------------
interface
   function uno_get_number_jacobian_evaluations(solver) result(number_jacobian_evaluations) &
      bind(C, name="uno_get_number_jacobian_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_jacobian_evaluations
   end function uno_get_number_jacobian_evaluations
end interface

!---------------------------------------------
! uno_get_number_hessian_evaluations
!---------------------------------------------
interface
   function uno_get_number_hessian_evaluations(solver) result(number_hessian_evaluations) &
      bind(C, name="uno_get_number_hessian_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_hessian_evaluations
   end function uno_get_number_hessian_evaluations
end interface

!---------------------------------------------
! uno_get_number_subproblem_solved_evaluations
!---------------------------------------------
interface
   function uno_get_number_subproblem_solved_evaluations(solver) result(number_subproblem_solved_evaluations) &
      bind(C, name="uno_get_number_subproblem_solved_evaluations")
      import :: c_ptr, uno_int
      type(c_ptr), value :: solver
      integer(uno_int) :: number_subproblem_solved_evaluations
   end function uno_get_number_subproblem_solved_evaluations
end interface

!---------------------------------------------
! uno_destroy_model
!---------------------------------------------
interface
   subroutine uno_destroy_model(model) &
      bind(C, name="uno_destroy_model")
      import :: c_ptr
      type(c_ptr), value :: model
   end subroutine uno_destroy_model
end interface

!---------------------------------------------
! uno_destroy_solver
!---------------------------------------------
interface
   subroutine uno_destroy_solver(solver) &
      bind(C, name="uno_destroy_solver")
      import :: c_ptr
      type(c_ptr), value :: solver
   end subroutine uno_destroy_solver
end interface

# Copyright (c) 2025: Charlie Vanaret and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# For help with this file, please contact `@odow` on GitHub.

using Test

import AmplNLWriter
import MathOptInterface as MOI
import MINLPTests
import Uno_jll

"""
    Optimizer()

Create a new `AmplNLWriter.Optimizer` object that uses Uno as the backing
solver.
"""
function Optimizer(options)
    return AmplNLWriter.Optimizer(Uno_jll.amplexe, options)
end

# Note: the HiGHS QP solver tolerates only positive semi-definite Hessians.
# We therefore run only on convex instances (for now)
Optimizer_Uno_filtersqp() = Optimizer(["logger=SILENT", "preset=filtersqp", "QP_solver=HiGHS", "max_iterations=10000"])

# This testset runs https://github.com/jump-dev/MINLPTests.jl
@testset "MINLPTests" begin
    primal_target = Dict(
        MINLPTests.FEASIBLE_PROBLEM => MOI.FEASIBLE_POINT,
        MINLPTests.INFEASIBLE_PROBLEM => MOI.INFEASIBLE_POINT,
    )
    primal_tol = 1e-4
    objective_tol = 1e-4
    # This function tests convex nonlinear programs. Test failures here should
    # never be allowed, because even local NLP solvers should find the global
    # optimum.
    MINLPTests.test_nlp_cvx_expr(Optimizer_Uno_filtersqp;
        exclude = [
            "102_010", "105_010", "201_011", "501_010", # negative curvature
            "110_010" # HiGHS cannot solve the first QP (https://github.com/ERGO-Code/HiGHS/issues/2489)
        ],
        primal_target,
        primal_tol,
        objective_tol)
end

# Script to parse Uno headers and generate Julia wrappers.
using Uno_jll
using Clang
using Clang.Generators
using JuliaFormatter

function main()
  # Use the header Uno_C_API.h provided by Uno_jll.jl
  # include_dir = joinpath(Uno_jll.artifact_dir, "include", "uno")
  include_dir = joinpath(@__DIR__, "..", "..", "C")
  headers = [joinpath(include_dir, "Uno_C_API.h")]

  options_path = joinpath(@__DIR__, "uno.toml")
  options = load_options(options_path)

  callbacks = ["ObjectiveGradient", "Objective", "Constraints",
               "JacobianOperator", "JacobianTransposedOperator", "HessianOperator",
               "JacobianSparsity", "Jacobian", "HessianSparsity", "Hessian",
               "NotifyAcceptableIterateUserCallback", "TerminationUserCallback",
               "LoggerStreamUserCallback"]
  options["general"]["output_ignorelist"] = [callbacks; "uno_int"]

  args = get_default_args()
  push!(args, "-I$include_dir")

  ctx = create_context(headers, args, options)
  build!(ctx)

  path = options["general"]["output_file_path"]
  wrappers = read(path, String)
  wrappers = replace(wrappers, r"^#.*\n?"m => "")
  for callback in callbacks
    wrappers = replace(wrappers, callback => "Ptr{Cvoid}")
  end
  wrappers = replace(wrappers, "uno_int" => "Int32")
  wrappers = "# Copyright (c) 2026 Alexis Montoison and Charlie Vanaret\n# Licensed under the MIT license. See LICENSE file in the project directory for details.\n\n" * wrappers
  write(path, wrappers)
  format_file(path, YASStyle())
  return nothing
end

# If we want to use the file as a script with `julia wrapper.jl`
if abspath(PROGRAM_FILE) == @__FILE__
  main()
end

# Version
haskey(ENV, "UNO_RELEASE") || error("The environment variable UNO_RELEASE is not defined.")
version = VersionNumber(ENV["UNO_RELEASE"])
version2 = ENV["UNO_RELEASE"]
package = "Uno"

platforms = [
   ("aarch64-apple-darwin-cxx11"  , "lib", "dylib"),
   ("aarch64-linux-gnu-cxx11"     , "lib", "so"   ),
#  ("aarch64-linux-musl-cxx11"    , "lib", "so"   ),
#  ("powerpc64le-linux-gnu-cxx11" , "lib", "so"   ),
   ("x86_64-apple-darwin-cxx11"   , "lib", "dylib"),
   ("x86_64-linux-gnu-cxx11"      , "lib", "so"   ),
#  ("x86_64-linux-musl-cxx11"     , "lib", "so"   ),
#  ("x86_64-unknown-freebsd-cxx11", "lib", "so"   ),
   ("x86_64-w64-mingw32-cxx11"    , "bin", "dll"  ),
]

for (platform, libdir, ext) in platforms

  tarball_name = "$package.v$version.$platform.tar.gz"

  if isfile("products/$(tarball_name)")
    # Unzip the tarball generated by BinaryBuilder.jl
    isdir("products/$platform") && rm("products/$platform", recursive=true)
    mkdir("products/$platform")
    run(`tar -xzf products/$(tarball_name) -C products/$platform`)

    if isfile("products/$platform/deps.tar.gz")
      # Unzip the tarball of the dependencies
      run(`tar -xzf products/$platform/deps.tar.gz -C products/$platform`)

      # Copy the license of each dependency
      for folder in readdir("products/$platform/deps/licenses")
       cp("products/$platform/deps/licenses/$folder", "products/$platform/share/licenses/$folder")
      end
      rm("products/$platform/deps/licenses", recursive=true)

      # Copy the shared library of each dependency
      for file in readdir("products/$platform/deps")
        cp("products/$platform/deps/$file", "products/$platform/$libdir/$file")
      end

      # Remove the folder used to unzip the tarball of the dependencies
      rm("products/$platform/deps", recursive=true)
      rm("products/$platform/deps.tar.gz", recursive=true)

      # Create the archives *_binaries
      isfile("$(package)_binaries.$version2.$platform.tar.gz") && rm("$(package)_binaries.$version2.$platform.tar.gz")
      isfile("$(package)_binaries.$version2.$platform.zip") && rm("$(package)_binaries.$version2.$platform.zip")
      cd("products/$platform")

      # Create a folder with the version number of the package
      mkdir("$(package)_binaries.$version2")
      for folder in ("lib", "bin", "share", "include")
        cp(folder, "$(package)_binaries.$version2/$folder")
      end

      cd("$(package)_binaries.$version2")
      if ext == "dll"
        run(`zip -r --symlinks ../../../$(package)_binaries.$version2.$platform.zip lib bin share include`)
      else
        run(`tar -czf ../../../$(package)_binaries.$version2.$platform.tar.gz lib bin share include`)
      end
      cd("../../..")

      # Remove the folder used to unzip the tarball generated by BinaryBuilder.jl
      rm("products/$platform", recursive=true)
    else
      @warn("The tarball deps.tar.gz is missing in $(tarball_name)!")
    end
  # else
  #   @warn("The tarball for the platform $platform was not generated!")
  end
end

program example_uno
    include 'uno_c.f90'
    integer(uno_int) :: major, minor, patch
    integer(uno_int), parameter :: number_variables = 2, number_constraints = 2
    integer(uno_int), parameter :: number_jacobian_nonzeros = 4, number_hessian_nonzeros = 3
    real(c_double), dimension(number_variables) :: x0, variables_lower_bounds, variables_upper_bounds
    real(c_double), dimension(number_constraints) :: y0, constraints_lower_bounds, constraints_upper_bounds
    integer(uno_int), dimension(number_jacobian_nonzeros) :: jacobian_row_indices, jacobian_column_indices
    integer(uno_int), dimension(number_hessian_nonzeros) :: hessian_row_indices, hessian_column_indices
    type(c_ptr) :: model, solver
    real(c_double) :: solution_objective
    real(c_double), dimension(number_variables) :: primal_solution, lower_bound_dual_solution, upper_bound_dual_solution
    real(c_double), dimension(number_constraints) :: constraint_dual_solution
    real(c_double) :: solution_primal_feasibility, solution_stationarity, solution_complementarity
    integer(uno_int) :: optimization_status, iterate_status, option_type
    logical(c_bool) :: success, print_solution = .true.
    integer(uno_int) :: number_iterations, max_iterations = 1000
    real(c_double) ::  cpu_time, dual_tolerance, primal_tolerance = 1.0d-6
    character(:), allocatable :: logger
    character(len=*), parameter :: hessian_model = "exact"
    character(len=*), parameter :: problem_type = UNO_PROBLEM_NONLINEAR
    integer(uno_int), parameter :: base_indexing = UNO_ONE_BASED_INDEXING
    integer(uno_int), parameter :: optimization_sense = UNO_MINIMIZE
    character(len=1), parameter :: hessian_triangular_part = UNO_LOWER_TRIANGLE
    integer(uno_int), parameter :: lagrangian_sign_convention = UNO_MULTIPLIER_NEGATIVE
    type(c_funptr) :: objective, gradient, constraints, jacobian, lagrangian_hessian
    type(c_funptr) :: jacobian_operator, jacobian_transposed_operator, lagrangian_hessian_operator

    !---------------------------------------------------
    ! Versions
    !---------------------------------------------------
    call uno_get_version(major, minor, patch)
    print *, 'Uno version: ', major, '.', minor, '.', patch

    !---------------------------------------------------
    ! Variables
    !---------------------------------------------------
    variables_lower_bounds = [-HUGE(1.0d0), -HUGE(1.0d0)]
    variables_upper_bounds = [0.5d0, HUGE(1.0d0)]
    x0 = [-2.0d0, 1.0d0]

    !---------------------------------------------------
    ! Constraints
    !---------------------------------------------------
    constraints_lower_bounds = [1.0d0, 0.0d0]
    constraints_upper_bounds = [HUGE(1.0d0), HUGE(1.0d0)]
    y0 = [0.0d0, 0.0d0]

    !---------------------------------------------------
    ! Jacobian
    !---------------------------------------------------
    jacobian_row_indices = [1, 2, 1, 2]
    jacobian_column_indices = [1, 1, 2, 2]

    !---------------------------------------------------
    ! Hessian
    !---------------------------------------------------
    hessian_row_indices = [1, 2, 2]
    hessian_column_indices = [1, 1, 2]

    !---------------------------------------------------
    ! Callbacks for Uno
    !---------------------------------------------------
    objective = c_funloc(objective_hs15)
    gradient = c_funloc(gradient_hs15)
    constraints = c_funloc(constraints_hs15)
    jacobian = c_funloc(jacobian_hs15)
    jacobian_operator = c_funloc(jacobian_operator_hs15)
    jacobian_transposed_operator = c_funloc(jacobian_transposed_operator_hs15)
    lagrangian_hessian = c_funloc(lagrangian_hessian_hs15)
    lagrangian_hessian_operator = c_funloc(lagrangian_hessian_operator_hs15)

    !---------------------------------------------------
    ! Model creation
    !---------------------------------------------------
    model = uno_create_model(problem_type, number_variables, variables_lower_bounds, variables_upper_bounds, base_indexing)

    success = uno_set_objective(model, optimization_sense, objective, gradient)
    success = uno_set_constraints(model, number_constraints, constraints, constraints_lower_bounds, constraints_upper_bounds, &
                                  number_jacobian_nonzeros, jacobian_row_indices, jacobian_column_indices, jacobian)
    success = uno_set_jacobian_operator(model, jacobian_operator)
    success = uno_set_jacobian_transposed_operator(model, jacobian_transposed_operator)
    ! success = uno_set_lagrangian_hessian_operator(model, lagrangian_hessian_operator)
    ! success = uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention)
    success = uno_set_initial_primal_iterate(model, x0)
    success = uno_set_initial_dual_iterate(model, y0)

    !---------------------------------------------------
    ! Solver creation
    !---------------------------------------------------
    solver = uno_create_solver()
    success = uno_set_solver_integer_option(solver, "max_iterations", max_iterations)
    success = uno_set_solver_double_option(solver, "primal_tolerance", primal_tolerance)
    success = uno_set_solver_bool_option(solver, "print_solution", print_solution)
    success = uno_set_solver_string_option(solver, "hessian_model", hessian_model)
    success = uno_set_solver_preset(solver, "filtersqp")

    !---------------------------------------------------
    ! Run 1: solve with no Hessian. Uno defaults to L-BFGS Hessian for NLPs
    !---------------------------------------------------
    call uno_optimize(solver, model)
    solution_objective = uno_get_solution_objective(solver)
    print *, 'Solution objective = ', solution_objective

    !---------------------------------------------------
    ! Run 2: solve with exact Hessian
    !---------------------------------------------------
    success = uno_set_lagrangian_hessian(model, number_hessian_nonzeros, hessian_triangular_part, hessian_row_indices, &
                                         hessian_column_indices, lagrangian_hessian)
    success = uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention)
    call uno_optimize(solver, model)

    !---------------------------------------------------
    ! Get options
    !---------------------------------------------------
    max_iterations = uno_get_solver_integer_option(solver, "max_iterations")
    print *, 'max_iterations = ', max_iterations

    dual_tolerance = uno_get_solver_double_option(solver, "dual_tolerance")
    print *, 'dual_tolerance = ', dual_tolerance

    print_solution = uno_get_solver_bool_option(solver, "print_solution")
    print *, 'print_solution = ', print_solution

    logger = uno_get_solver_string_option(solver, "logger")
    print *, 'logger = ', logger

    option_type = uno_get_solver_option_type(solver, "linear_solver")
    print *, 'option_type for the option linear_solver = ', option_type

    !---------------------------------------------------
    ! Get solution
    !---------------------------------------------------
    number_iterations = uno_get_number_iterations(solver)
    print *, 'number_iterations = ', number_iterations

    cpu_time = uno_get_cpu_time(solver)
    print *, 'cpu_time = ', cpu_time

    optimization_status = uno_get_optimization_status(solver)
    print *, 'optimization_status = ', optimization_status

    iterate_status = uno_get_solution_status(solver)
    print *, 'iterate_status = ', iterate_status

    solution_objective = uno_get_solution_objective(solver)
    print *, 'Solution objective = ', solution_objective

    call uno_get_primal_solution(solver, primal_solution)
    print *, 'Primal solution = ', primal_solution

    call uno_get_constraint_dual_solution(solver, constraint_dual_solution)
    print *, 'Constraint dual solution = ', constraint_dual_solution

    call uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)
    print *, 'Lower bound dual solution = ', lower_bound_dual_solution

    call uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)
    print *, 'Upper bound dual solution = ', upper_bound_dual_solution

    solution_primal_feasibility = uno_get_solution_primal_feasibility(solver)
    print *, 'Primal feasibility at solution = ', solution_primal_feasibility

    solution_stationarity = uno_get_solution_stationarity(solver)
    print *, 'Stationarity at solution = ', solution_stationarity

    solution_complementarity = uno_get_solution_complementarity(solver)
    print *, 'Complementarity at solution = ', solution_complementarity

    !---------------------------------------------------
    ! Cleanup
    !---------------------------------------------------
    call uno_destroy_solver(solver)
    call uno_destroy_model(model)

contains
    include 'uno_fortran.f90'

    ! Objective
    function objective_hs15(number_variables, x, objective_value, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables
        real(c_double), intent(in) :: x(*)
        real(c_double), intent(out) :: objective_value
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        objective_value = 100.0d0 * (x(2) - x(1)**2)**2 + (1.0d0 - x(1))**2
        res = 0
    end function objective_hs15

    ! Gradient
    function gradient_hs15(number_variables, x, gradient, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables
        real(c_double), intent(in) :: x(*)
        real(c_double), intent(out) :: gradient(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        gradient(1) = 400.0d0 * x(1)**3 - 400.0d0 * x(1) * x(2) + 2.0d0 * x(1) - 2.0d0
        gradient(2) = 200.0d0 * (x(2) - x(1)**2)
        res = 0
    end function gradient_hs15

    ! Constraints
    function constraints_hs15(number_variables, number_constraints, x, constraint_values, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables, number_constraints
        real(c_double), intent(in) :: x(*)
        real(c_double), intent(out) :: constraint_values(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        constraint_values(1) = x(1) * x(2)
        constraint_values(2) = x(1) + x(2)**2
        res = 0
    end function constraints_hs15

    ! Jacobian
    function jacobian_hs15(number_variables, number_jacobian_nonzeros, x, jacobian_values, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables, number_jacobian_nonzeros
        real(c_double), intent(in) :: x(*)
        real(c_double), intent(out) :: jacobian_values(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        jacobian_values(1) = x(2)
        jacobian_values(2) = 1.0d0
        jacobian_values(3) = x(1)
        jacobian_values(4) = 2.0d0 * x(2)
        res = 0
    end function jacobian_hs15

    ! Jacobian operator
    function jacobian_operator_hs15(number_variables, number_constraints, x, evaluate_at_x, &
                                    vector, result, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables, number_constraints
        real(c_double), intent(in) :: x(*)
        logical(c_bool), value :: evaluate_at_x
        real(c_double), intent(in) :: vector(*)
        real(c_double), intent(out) :: result(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        result(1) = x(2) * vector(1) + 1.0d0 * vector(2)
        result(2) = x(1) * vector(1) + 2.0d0 * x(2) * vector(2)
        res = 0
    end function jacobian_operator_hs15

    ! Jacobian transposed operator
    function jacobian_transposed_operator_hs15(number_variables, number_constraints, x, evaluate_at_x, &
                                               vector, result, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables, number_constraints
        real(c_double), intent(in) :: x(*)
        logical(c_bool), value :: evaluate_at_x
        real(c_double), intent(in) :: vector(*)
        real(c_double), intent(out) :: result(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        result(1) = x(2) * vector(1) + x(1) * vector(2)
        result(2) = 1.0d0 * vector(1) + 2.0d0 * x(2) * vector(2)
        res = 0
    end function jacobian_transposed_operator_hs15

    ! Lagrangian Hessian
    function lagrangian_hessian_hs15(number_variables, number_constraints, number_hessian_nonzeros, &
                                     x, objective_multiplier, multipliers, hessian_values, user_data) result(res) &
        bind(C)
        integer(uno_int), value :: number_variables, number_constraints, number_hessian_nonzeros
        real(c_double), intent(in) :: x(*), multipliers(*)
        real(c_double), intent(out) :: hessian_values(*)
        real(c_double), value :: objective_multiplier
        type(c_ptr), value :: user_data
        integer(uno_int) :: res

        hessian_values(1) = objective_multiplier * (1200.0d0 * x(1)**2 - 400.0d0 * x(2) + 2.0d0)
        hessian_values(2) = -400.0d0 * objective_multiplier * x(1) - multipliers(1)
        hessian_values(3) = 200.0d0 * objective_multiplier - 2.0d0 * multipliers(2)
        res = 0
    end function lagrangian_hessian_hs15

    ! Lagrangian Hessian operator
    function lagrangian_hessian_operator_hs15(number_variables, number_constraints, x, evaluate_at_x, &
                                              objective_multiplier, multipliers, vector, result, user_data) result(res) bind(C)
        integer(uno_int), value :: number_variables, number_constraints
        real(c_double), intent(in) :: x(*)
        logical(c_bool), value :: evaluate_at_x
        real(c_double), value :: objective_multiplier
        real(c_double), intent(in) :: multipliers(*), vector(*)
        real(c_double), intent(out) :: result(*)
        type(c_ptr), value :: user_data
        integer(uno_int) :: res
        real(c_double) :: hessian11, hessian12, hessian22

        hessian11 = objective_multiplier * (1200.0d0 * x(1)**2 - 400.0d0 * x(2) + 2.0d0)
        hessian12 = -400.0d0 * objective_multiplier * x(1) - multipliers(1)
        hessian22 = 200.0d0 * objective_multiplier - 2.0d0 * multipliers(2)
        result(1) = hessian11 * vector(1) + hessian12 * vector(2)
        result(2) = hessian12 * vector(1) + hessian22 * vector(2)
        res = 0
    end function lagrangian_hessian_operator_hs15

end program example_uno

# Optimization sense
const UNO_MINIMIZE = Cint(1)
const UNO_MAXIMIZE = Cint(-1)

# Lagrange multiplier sign convention
const UNO_MULTIPLIER_POSITIVE = Cint(1)
const UNO_MULTIPLIER_NEGATIVE = Cint(-1)

# Problem type: "LP" = linear problem, "QP" = quadratic problem, "NLP" = nonlinear problem
const UNO_PROBLEM_LINEAR    = "LP"
const UNO_PROBLEM_QUADRATIC = "QP"
const UNO_PROBLEM_NONLINEAR = "NLP"

# Base indexing style: 0-based (C) or 1-based (Fortran)
const UNO_ZERO_BASED_INDEXING = Cint(0)
const UNO_ONE_BASED_INDEXING  = Cint(1)

# Triangular part: 'L' = lower, 'U' = upper
const UNO_LOWER_TRIANGLE = Cchar('L')
const UNO_UPPER_TRIANGLE = Cchar('U')

# Option type: 0 = integer, 1 = double, 2 = boolean, 3 = string, -1 = not found
const UNO_OPTION_TYPE_INTEGER   = Cint(0)
const UNO_OPTION_TYPE_DOUBLE    = Cint(1)
const UNO_OPTION_TYPE_BOOL      = Cint(2)
const UNO_OPTION_TYPE_STRING    = Cint(3)
const UNO_OPTION_TYPE_NOT_FOUND = Cint(-1)

# Optimization status
const UNO_SUCCESS           = Cint(0)
const UNO_ITERATION_LIMIT   = Cint(1)
const UNO_TIME_LIMIT        = Cint(2)
const UNO_EVALUATION_ERROR  = Cint(3)
const UNO_ALGORITHMIC_ERROR = Cint(4)
const UNO_USER_TERMINATION  = Cint(5)

# Iterate status
const UNO_NOT_OPTIMAL                 = Cint(0)
const UNO_FEASIBLE_KKT_POINT          = Cint(1)
const UNO_FEASIBLE_FJ_POINT           = Cint(2)
const UNO_INFEASIBLE_STATIONARY_POINT = Cint(3)
const UNO_FEASIBLE_SMALL_STEP         = Cint(4)
const UNO_INFEASIBLE_SMALL_STEP       = Cint(5)
const UNO_UNBOUNDED                   = Cint(6)

# Copyright (c) 2018-2025: Charlie Vanaret and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# For help with this file, please contact `@odow` on GitHub.

using Test

import AmplNLWriter
import MathOptInterface as MOI
import MINLPTests
import Uno_jll

"""
    Optimizer()

Create a new `AmplNLWriter.Optimizer` object that uses Uno as the backing
solver.
"""
function Optimizer(options)
    return AmplNLWriter.Optimizer(Uno_jll.amplexe, options)
end

Optimizer_Uno_ipopt() = Optimizer(["logger=SILENT", "preset=ipopt", "linear_solver=MUMPS", "unbounded_objective_threshold=-1e15"])

# This testset runs https://github.com/jump-dev/MINLPTests.jl
@testset "MINLPTests" begin
    primal_target = Dict(
        MINLPTests.FEASIBLE_PROBLEM => MOI.FEASIBLE_POINT,
        # If Uno starts writing a .sol file with an infeasible point, change
        # this to `=> MOI.INFEASIBLE_POINT`
        MINLPTests.INFEASIBLE_PROBLEM => MOI.NO_SOLUTION,
    )
    objective_tol = 1e-4
    primal_tol = 1e-4
    # This function tests (potentially) non-convex nonlinear programs. The tests
    # are meant to be "easy" in the sense that most NLP solvers can find the
    # same global minimum, but a test failure can sometimes be allowed.
    MINLPTests.test_nlp_expr(
        Optimizer_Uno_ipopt;
        exclude = [
            # Okay to exclude forever: AmplNLWriter does not support
            # user-defined functions.
            "006_010",
            # Remove once https://github.com/cvanaret/Uno/issues/38 is fixed
            "007_010",
        ],
        primal_target, objective_tol, primal_tol
    )
    # This function tests convex nonlinear programs. Test failures here should
    # never be allowed, because even local NLP solvers should find the global
    # optimum.
    MINLPTests.test_nlp_cvx_expr(Optimizer_Uno_ipopt; primal_target, objective_tol, primal_tol)
end

# This testset runs the full gamut of MOI.Test.runtests. There are a number of
# tests in here with weird edge cases, so a variety of exclusions are expected.
@testset "MathOptInterface.test" begin
    optimizer = MOI.instantiate(
        Optimizer_Uno_ipopt;
        with_cache_type = Float64,
        with_bridge_type = Float64,
    )
    MOI.Test.runtests(
        optimizer,
        MOI.Test.Config(
            # These are pretty loose tolerances so that all tests pass. There
            # are few tests with weird numerics. If tests fail because of
            # tolerances, it might be okay to make these looser, or you could
            # tighten the tolerances used by Uno.
            atol = 1e-4,
            rtol = 1e-4,
            optimal_status = MOI.LOCALLY_SOLVED,
            infeasible_status = MOI.LOCALLY_INFEASIBLE,
            exclude = Any[
                # It's okay to exclude BasisStatus, since AmplNLWriter doesn't
                # support this information, so too with ObjectiveBound, since
                # Uno is a local NLP solver.
                MOI.VariableBasisStatus,
                MOI.ConstraintBasisStatus,
                MOI.ObjectiveBound,
            ],
        );
        exclude = [
            # ==================================================================
            # The following tests are bugs.
            #
            # We should fix issues in Uno, and then try removing these lines.
            #
            # These tests return OTHER_LIMIT instead of LOCALLY_INFEASIBLE. It
            # might be acceptable to leave this as-is, but it would be better to
            # fix.
            r"^test_conic_NormInfinityCone_INFEASIBLE$",
            r"^test_conic_NormOneCone_INFEASIBLE$",
            r"^test_conic_linear_INFEASIBLE$",
            r"^test_conic_linear_INFEASIBLE_2$",
            r"^test_linear_INFEASIBLE$",
            r"^test_linear_INFEASIBLE_2$",
            r"^test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_",
            # ==================================================================
            # The following tests are okay to exclude forever.
            #
            # Uno does not support integrality, and AmplNLWriter has no way of
            # telling if a particular binary supports integers or not (it
            # defaults to assuming yes).
            "Indicator",
            r"[Ii]nteger",
            "Semicontinuous",
            "Semiinteger",
            "SOS1",
            "SOS2",
            "ZeroOne",
            r"^test_cpsat_",
            r"^test_attribute_SolverVersion$",
            r"^test_nonlinear_invalid$",
            r"^test_basic_VectorNonlinearFunction_",
        ],
    )
end

# Copyright (c) 2025: Alexis Montoison, Charlie Vanaret, other contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE file or at https://opensource.org/licenses/MIT.

function uno_version()
    major = Ref{Cint}()
    minor = Ref{Cint}()
    patch = Ref{Cint}()
    uno_get_version(major, minor, patch)
    return VersionNumber(major[], minor[], patch[])
end

mutable struct Model{M}
  # Reference to the internal C model of Uno
  c_model::Ptr{Cvoid}
  # Number of variables
  nvar::Int
  # Number of constraints
  ncon::Int
  # Callbacks
  eval_objective::Function
  eval_constraints::Union{Function,Nothing}
  eval_gradient::Function
  eval_jacobian::Union{Function,Nothing}
  eval_hessian::Union{Function,Nothing}
  eval_Jv::Union{Function,Nothing}
  eval_Jtv::Union{Function,Nothing}
  eval_Hv::Union{Function,Nothing}
  # User data
  user_model::M
end

function uno_objective(number_variables::Cint, x::Ptr{Float64}, objective_value::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _f = _user_data.eval_objective(_user_data.user_model, _x)::Float64
  unsafe_store!(objective_value, _f)
  return Cint(0)
end

function uno_constraints(number_variables::Cint, number_constraints::Cint, x::Ptr{Float64}, constraint_values::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _c = unsafe_wrap(Array, constraint_values, number_constraints)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_constraints(_user_data.user_model, _c, _x)
  return Cint(0)
end

function uno_objective_gradient(number_variables::Cint, x::Ptr{Float64}, gradient::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _g = unsafe_wrap(Array, gradient, number_variables)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_gradient(_user_data.user_model, _g, _x)
  return Cint(0)
end

function uno_jacobian(number_variables::Cint, number_jacobian_nonzeros::Cint, x::Ptr{Float64}, jacobian::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _jvals = unsafe_wrap(Array, jacobian, number_jacobian_nonzeros)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_jacobian(_user_data.user_model, _jvals, _x)
  return Cint(0)
end

function uno_lagrangian_hessian(number_variables::Cint, number_constraints::Cint, number_hessian_nonzeros::Cint, x::Ptr{Float64}, objective_multiplier::Float64, multipliers::Ptr{Float64}, hessian::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _multipliers = unsafe_wrap(Array, multipliers, number_constraints)
  _hvals = unsafe_wrap(Array, hessian, number_hessian_nonzeros)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_hessian(_user_data.user_model, _hvals, _x, _multipliers, objective_multiplier)
  return Cint(0)
end

function uno_jacobian_operator(number_variables::Cint, number_constraints::Cint, x::Ptr{Float64}, evaluate_at_x::Bool, vector::Ptr{Float64}, result::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _v = unsafe_wrap(Array, vector, number_variables)
  _Jv = unsafe_wrap(Array, result, number_constraints)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_Jv(_user_data.user_model, _Jv, _x, _v, evaluate_at_x)
  return Cint(0)
end

function uno_jacobian_transposed_operator(number_variables::Cint, number_constraints::Cint, x::Ptr{Float64}, evaluate_at_x::Bool, vector::Ptr{Float64}, result::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _v = unsafe_wrap(Array, vector, number_constraints)
  _Jtv = unsafe_wrap(Array, result, number_variables)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_Jtv(_user_data.user_model, _Jtv, _x, _v, evaluate_at_x)
  return Cint(0)
end

function uno_lagrangian_hessian_operator(number_variables::Cint, number_constraints::Cint, x::Ptr{Float64}, evaluate_at_x::Bool, objective_multiplier::Float64, multipliers::Ptr{Float64}, vector::Ptr{Float64}, result::Ptr{Float64}, user_data::Ptr{Cvoid})
  _x = unsafe_wrap(Array, x, number_variables)
  _multipliers = unsafe_wrap(Array, multipliers, number_constraints)
  _v = unsafe_wrap(Array, vector, number_variables)
  _Hv = unsafe_wrap(Array, result, number_variables)
  _user_data = unsafe_pointer_to_objref(user_data)::Model
  _user_data.eval_Hv(_user_data.user_model, _Hv, _x, objective_multiplier, _multipliers, _v, evaluate_at_x)
  return Cint(0)
end

function uno_destroy_model(model::Model)
  if model.c_model != C_NULL
    uno_destroy_model(model.c_model)
    model.c_model = C_NULL
  end
end

Base.unsafe_convert(::Type{Ptr{Cvoid}}, model::Model) = model.c_model

function uno_model(
  problem_type::String,
  minimize::Bool,
  nvar::Int,
  ncon::Int,
  lvar::Vector{Float64},
  uvar::Vector{Float64},
  lcon::Vector{Float64},
  ucon::Vector{Float64},
  jrows::Vector{Cint},
  jcols::Vector{Cint},
  nnzj::Int,
  hrows::Vector{Cint},
  hcols::Vector{Cint},
  nnzh::Int,
  eval_objective::Function,
  eval_constraints::Union{Function,Nothing},
  eval_gradient::Function,
  eval_jacobian::Union{Function,Nothing},
  eval_hessian::Union{Function,Nothing},
  eval_Jv::Union{Function,Nothing},
  eval_Jtv::Union{Function,Nothing},
  eval_Hv::Union{Function,Nothing},
  user_model=nothing,
  hessian_triangle::Char='L',
  lagrangian_sign::Int=1,
  x0::Union{Vector{Float64},Nothing}=nothing,
  y0::Union{Vector{Float64},Nothing}=nothing,
)
  @assert nvar == length(lvar) == length(uvar)
  @assert ncon == length(lcon) == length(ucon)
  @assert nnzj == length(jrows) == length(jcols)
  @assert nnzh == length(hrows) == length(hcols)
  @assert isnothing(x0) || nvar == length(x0)
  @assert isnothing(y0) || ncon == length(y0)

  # "LP" for linear problem, "QP" for quadratic problem, "NLP" for nonlinear problem
  @assert problem_type == "LP" || problem_type == "QP" || problem_type == "NLP"
  optimization_sense = minimize ? Cint(1) : Cint(-1)

  base_indexing = Cint(1)  # Fortran-style indexing
  c_model = uno_create_model(problem_type, Cint(nvar), lvar, uvar, base_indexing)
  (c_model == C_NULL) && error("Failed to construct Uno model for some unknown reason.")
  model = Model(c_model, nvar, ncon, eval_objective, eval_constraints, eval_gradient,
                eval_jacobian, eval_hessian, eval_Jv, eval_Jtv, eval_Hv, user_model)

  user_data = pointer_from_objref(model)::Ptr{Cvoid}
  flag = uno_set_user_data(c_model, user_data)
  flag || error("Failed to set user data via uno_set_user_data.")

  eval_objective_c = @cfunction(uno_objective, Cint, (Cint, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
  eval_gradient_c = @cfunction(uno_objective_gradient, Cint, (Cint, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
  flag = uno_set_objective(c_model, optimization_sense, eval_objective_c, eval_gradient_c)
  flag || error("Failed to set objective and gradient via uno_set_objective.")

  if !isnothing(eval_hessian)
    eval_hessian_c = @cfunction(uno_lagrangian_hessian, Cint, (Cint, Cint, Cint, Ptr{Float64}, Float64, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
    flag = uno_set_lagrangian_hessian(c_model, Cint(nnzh), hessian_triangle, hrows, hcols, eval_hessian_c)
    flag || error("Failed to set Lagrangian Hessian via uno_set_lagrangian_hessian.")
  end

  if !isnothing(eval_Hv)
    eval_Hv_c = @cfunction(uno_lagrangian_hessian_operator, Cint, (Cint, Cint, Ptr{Float64}, Bool, Float64, Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
    flag = uno_set_lagrangian_hessian_operator(c_model, eval_Hv_c)
    flag || error("Failed to set Hessian operator via uno_set_lagrangian_hessian_operator.")
  end

  flag = uno_set_lagrangian_sign_convention(c_model, Cint(lagrangian_sign))
  flag || error("Failed to set Lagrangian sign convention via uno_set_lagrangian_sign_convention.")

  if ncon > 0
    @assert !isnothing(eval_constraints) && !isnothing(eval_jacobian)
    eval_constraints_c = @cfunction(uno_constraints, Cint, (Cint, Cint, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
    eval_jacobian_c = @cfunction(uno_jacobian, Cint, (Cint, Cint, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
    flag = uno_set_constraints(c_model, Cint(ncon), eval_constraints_c, lcon, ucon, Cint(nnzj), jrows, jcols, eval_jacobian_c)
    flag || error("Failed to set constraints and Jacobian via uno_set_constraints.")

    if !isnothing(eval_Jv)
      eval_Jv_c = @cfunction(uno_jacobian_operator, Cint, (Cint, Cint, Ptr{Float64}, Bool, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
      flag = uno_set_jacobian_operator(c_model, eval_Jv_c)
      flag || error("Failed to set Jacobian operator via uno_set_jacobian_operator.")
    end

    if !isnothing(eval_Jtv)
      eval_Jtv_c = @cfunction(uno_jacobian_transposed_operator, Cint, (Cint, Cint, Ptr{Float64}, Bool, Ptr{Float64}, Ptr{Float64}, Ptr{Cvoid}))
      flag = uno_set_jacobian_transposed_operator(c_model, eval_Jtv_c)
      flag || error("Failed to set transposed Jacobian operator via uno_set_jacobian_transposed_operator.")
    end

    if !isnothing(y0)
      uno_set_initial_dual_iterate(c_model, y0)
    end
  end

  if !isnothing(x0)
    uno_set_initial_primal_iterate(c_model, x0)
  end

  finalizer(uno_destroy_model, model)
  return model
end

function uno_model(
  problem_type::String,
  minimize::Bool,
  nvar::Int,
  lvar::Vector{Float64},
  uvar::Vector{Float64},
  hrows::Vector{Cint},
  hcols::Vector{Cint},
  nnzh::Int,
  eval_objective::Function,
  eval_gradient::Function,
  eval_hessian::Union{Function,Nothing},
  eval_Hv::Union{Function,Nothing},
  user_model=nothing,
  hessian_triangle::Char='L',
  lagrangian_sign::Int=1,
  x0::Union{Vector{Float64},Nothing}=nothing,
)
  return uno_model(
    problem_type,
    minimize,
    nvar,
    0,
    lvar,
    uvar,
    Float64[],
    Float64[],
    Cint[],
    Cint[],
    0,
    hrows,
    hcols,
    nnzh,
    eval_objective,
    nothing,
    eval_gradient,
    nothing,
    eval_hessian,
    nothing,
    nothing,
    eval_Hv,
    user_model,
    hessian_triangle,
    lagrangian_sign,
    x0,
    nothing,
  )
end

function uno_set_initial_primal_iterate(model::Model, initial_primal_iterate::Vector{Float64})
  @assert model.nvar == length(initial_primal_iterate)
  GC.@preserve model begin
    flag = uno_set_initial_primal_iterate(model.c_model, initial_primal_iterate)
  end
  flag || error("Failed to set initial primal iterate via uno_set_initial_primal_iterate.")
  return
end

function uno_set_initial_dual_iterate(model::Model, initial_dual_iterate::Vector{Float64})
  @assert model.ncon == length(initial_dual_iterate)
  GC.@preserve model begin
    flag = uno_set_initial_dual_iterate(model.c_model, initial_dual_iterate)
  end
  flag || error("Failed to set initial dual iterate via uno_set_initial_dual_iterate.")
  return
end

mutable struct Solver
  # Reference to the internal C solver of Uno
  c_solver::Ptr{Cvoid}
end

function uno_get_solver_string_option(solver::Solver, option_name::String)
  option_value = uno_get_solver_string_option(solver.c_solver, option_name)
  return unsafe_string(option_value)
end

function uno_destroy_solver(solver::Solver)
  if solver.c_solver != C_NULL
    uno_destroy_solver(solver.c_solver)
    solver.c_solver = C_NULL
  end
end

Base.unsafe_convert(::Type{Ptr{Cvoid}}, solver::Solver) = solver.c_solver

function uno_solver(; kwargs...)
  c_solver = uno_create_solver()
  (c_solver == C_NULL) && error("Failed to construct Uno solver for some unknown reason.")
  solver = Solver(c_solver)

  # pass options to Uno
  if haskey(kwargs, :preset)
    uno_set_solver_preset(solver, kwargs[:preset])
  end
  for (k, v) in kwargs
    (k == :preset) && continue
    if v isa String
      @assert uno_set_solver_string_option(c_solver, string(k), v)
    elseif v isa Float64
      @assert uno_set_solver_double_option(c_solver, string(k), v)
    elseif v isa Bool
      @assert uno_set_solver_bool_option(c_solver, string(k), v)
    elseif v isa Integer
      @assert uno_set_solver_integer_option(c_solver, string(k), Cint(v))
    else
      @warn "$k does not seem to be a valid Uno option."
    end
  end

  finalizer(uno_destroy_solver, solver)
  return solver
end

mutable struct Statistics{M}
  model::Model{M}
  solver::Solver

  primal_solution::Vector{Float64}
  constraint_dual_solution::Vector{Float64}
  lower_bound_dual_solution::Vector{Float64}
  upper_bound_dual_solution::Vector{Float64}

  cpu_time::Float64
  solution_objective::Float64
  solution_primal_feasibility::Float64
  solution_stationarity::Float64
  solution_complementarity::Float64

  optimization_status::Cint
  solution_status::Cint
  number_iterations::Cint
  number_subproblem_solved_evaluations::Cint
  number_objective_evaluations::Cint
  number_constraint_evaluations::Cint
  number_objective_gradient_evaluations::Cint
  number_jacobian_evaluations::Cint
  number_hessian_evaluations::Cint
end

function uno_statistics(model::Model, solver::Solver)
  primal_solution = Vector{Float64}(undef, model.nvar)
  UnoSolver.uno_get_primal_solution(solver, primal_solution)
  constraint_dual_solution = Vector{Float64}(undef, model.ncon)
  UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)
  lower_bound_dual_solution = Vector{Float64}(undef, model.nvar)
  UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)
  upper_bound_dual_solution = Vector{Float64}(undef, model.nvar)
  UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

  cpu_time = UnoSolver.uno_get_cpu_time(solver)
  solution_objective = UnoSolver.uno_get_solution_objective(solver)
  solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
  solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
  solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

  optimization_status = UnoSolver.uno_get_optimization_status(solver)
  solution_status = UnoSolver.uno_get_solution_status(solver)
  number_iterations = UnoSolver.uno_get_number_iterations(solver)
  number_subproblem_solved_evaluations = UnoSolver.uno_get_number_subproblem_solved_evaluations(solver)
  number_objective_evaluations = UnoSolver.uno_get_number_objective_evaluations(solver)
  number_constraint_evaluations = UnoSolver.uno_get_number_constraint_evaluations(solver)
  number_objective_gradient_evaluations = UnoSolver.uno_get_number_objective_gradient_evaluations(solver)
  number_jacobian_evaluations = UnoSolver.uno_get_number_jacobian_evaluations(solver)
  number_hessian_evaluations = UnoSolver.uno_get_number_hessian_evaluations(solver)

  stats = Statistics(model, solver, primal_solution, constraint_dual_solution, lower_bound_dual_solution, upper_bound_dual_solution,
                     cpu_time, solution_objective, solution_primal_feasibility, solution_stationarity, solution_complementarity,
                     optimization_status, solution_status, number_iterations, number_subproblem_solved_evaluations,
                     number_objective_evaluations, number_constraint_evaluations, number_objective_gradient_evaluations,
                     number_jacobian_evaluations, number_hessian_evaluations)
end

function uno(
  problem_type::String,
  minimize::Bool,
  nvar::Int,
  ncon::Int,
  lvar::Vector{Float64},
  uvar::Vector{Float64},
  lcon::Vector{Float64},
  ucon::Vector{Float64},
  jrows::Vector{Cint},
  jcols::Vector{Cint},
  nnzj::Int,
  hrows::Vector{Cint},
  hcols::Vector{Cint},
  nnzh::Int,
  eval_objective::Function,
  eval_constraints::Union{Function,Nothing},
  eval_gradient::Function,
  eval_jacobian::Union{Function,Nothing},
  eval_hessian::Union{Function,Nothing},
  eval_Jv::Union{Function,Nothing},
  eval_Jtv::Union{Function,Nothing},
  eval_Hv::Union{Function,Nothing},
  user_model=nothing,
  hessian_triangle::Char='L',
  lagrangian_sign::Int=1,
  x0::Union{Vector{Float64},Nothing}=nothing,
  y0::Union{Vector{Float64},Nothing}=nothing;
  kwargs...
)
  model = uno_model(problem_type, minimize, nvar, ncon, lvar, uvar, lcon, ucon, jrows,
                    jcols, nnzj, hrows, hcols, nnzh, eval_objective, eval_constraints,
                    eval_gradient, eval_jacobian, eval_hessian, eval_Jv, eval_Jtv,
                    eval_Hv, user_model, hessian_triangle, lagrangian_sign, x0, y0)
  solver = uno_solver(; kwargs...)
  uno_optimize(solver, model)
  stats = uno_statistics(model, solver)
  return stats
end

function uno(
  problem_type::String,
  minimize::Bool,
  nvar::Int,
  lvar::Vector{Float64},
  uvar::Vector{Float64},
  hrows::Vector{Cint},
  hcols::Vector{Cint},
  nnzh::Int,
  eval_objective::Function,
  eval_gradient::Function,
  eval_hessian::Union{Function,Nothing},
  eval_Hv::Union{Function,Nothing},
  user_model=nothing,
  hessian_triangle::Char='L',
  lagrangian_sign::Int=1,
  x0::Union{Vector{Float64},Nothing}=nothing;
  kwargs...
)
  return uno(
    problem_type,
    minimize,
    nvar,
    0,
    lvar,
    uvar,
    Float64[],
    Float64[],
    Cint[],
    Cint[],
    0,
    hrows,
    hcols,
    nnzh,
    eval_objective,
    nothing,
    eval_gradient,
    nothing,
    eval_hessian,
    nothing,
    nothing,
    eval_Hv,
    user_model,
    hessian_triangle,
    lagrangian_sign,
    x0,
    nothing;
    kwargs...
  )
end

# Copyright (c) 2018-2025: Charlie Vanaret and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# For help with this file, please contact `@odow` on GitHub.

using Test

import AmplNLWriter
import MathOptInterface as MOI
import MINLPTests
import Uno_jll

"""
    Optimizer()

Create a new `AmplNLWriter.Optimizer` object that uses Uno as the backing
solver.
"""
function Optimizer(options)
    return AmplNLWriter.Optimizer(Uno_jll.amplexe, options)
end

Optimizer_Uno_filterslp() = Optimizer(["logger=SILENT", "preset=filterslp", "LP_solver=HiGHS", "max_iterations=10000", "unbounded_objective_threshold=-1e15", "dual_tolerance=1e-6"])

# This testset runs https://github.com/jump-dev/MINLPTests.jl
@testset "MINLPTests" begin
    primal_target = Dict(
        MINLPTests.FEASIBLE_PROBLEM => MOI.FEASIBLE_POINT,
        # If Uno starts writing a .sol file with an infeasible point, change
        # this to `=> MOI.INFEASIBLE_POINT`
        MINLPTests.INFEASIBLE_PROBLEM => MOI.NO_SOLUTION,
    )
    # This function tests (potentially) non-convex nonlinear programs. The tests
    # are meant to be "easy" in the sense that most NLP solvers can find the
    # same global minimum, but a test failure can sometimes be allowed.
    MINLPTests.test_nlp_expr(
        Optimizer_Uno_filterslp;
        exclude = [
            "001_010",  # Local solution
            "003_014",  # Local solution
            "008_010",  # Local solution
            # no gradient at the initial point
            "005_010",
            # Okay to exclude forever: AmplNLWriter does not support
            # user-defined functions.
            "006_010",
            # Remove once https://github.com/cvanaret/Uno/issues/38 is fixed
            "007_010",
        ],
        primal_target,
        objective_tol = 1e-4,
        primal_tol = 1e-3,
    )
    # This function tests convex nonlinear programs. Test failures here should
    # never be allowed, because even local NLP solvers should find the global
    # optimum.
    MINLPTests.test_nlp_cvx_expr(
        Optimizer_Uno_filterslp; 
        primal_target,
        objective_tol = 1e-4,
        primal_tol = 1e-3,
        exclude = ["501_010", "501_011"],  # Iteration limit
    )
end

# Copyright (c) 2013: Iain Dunning, Miles Lubin, and contributors
# 2025: Modified for MadNLP.jl and UnoSolver.jl by Alexis Montoison
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# !!! warning
#
#     The contents of this file are experimental.
#
#     Until this message is removed, breaking changes to the functions and
#     types, including their deletion, may be introduced in any minor or patch
#     release of Uno.

@enum(
    _FunctionType,
    _kFunctionTypeVariableIndex,
    _kFunctionTypeScalarAffine,
    _kFunctionTypeScalarQuadratic,
)

function _function_type_to_set(::Type{T}, k::_FunctionType) where {T}
    if k == _kFunctionTypeVariableIndex
        return MOI.VariableIndex
    elseif k == _kFunctionTypeScalarAffine
        return MOI.ScalarAffineFunction{T}
    else
        @assert k == _kFunctionTypeScalarQuadratic
        return MOI.ScalarQuadraticFunction{T}
    end
end

_function_info(::MOI.VariableIndex) = _kFunctionTypeVariableIndex
_function_info(::MOI.ScalarAffineFunction) = _kFunctionTypeScalarAffine
_function_info(::MOI.ScalarQuadraticFunction) = _kFunctionTypeScalarQuadratic

@enum(
    _BoundType,
    _kBoundTypeLessThan,
    _kBoundTypeGreaterThan,
    _kBoundTypeEqualTo,
    _kBoundTypeInterval,
)

_set_info(s::MOI.LessThan) = _kBoundTypeLessThan, -Inf, s.upper
_set_info(s::MOI.GreaterThan) = _kBoundTypeGreaterThan, s.lower, Inf
_set_info(s::MOI.EqualTo) = _kBoundTypeEqualTo, s.value, s.value
_set_info(s::MOI.Interval) = _kBoundTypeInterval, s.lower, s.upper

function _bound_type_to_set(::Type{T}, k::_BoundType) where {T}
    if k == _kBoundTypeEqualTo
        return MOI.EqualTo{T}
    elseif k == _kBoundTypeLessThan
        return MOI.LessThan{T}
    elseif k == _kBoundTypeGreaterThan
        return MOI.GreaterThan{T}
    else
        @assert k == _kBoundTypeInterval
        return MOI.Interval{T}
    end
end

mutable struct QPBlockData{T}
    objective::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}
    objective_function_type::_FunctionType
    constraints::Vector{
        Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    }
    g_L::Vector{T}
    g_U::Vector{T}
    mult_g::Vector{Union{Nothing,T}}
    function_type::Vector{_FunctionType}
    bound_type::Vector{_BoundType}
    parameters::Dict{Int64,T}

    function QPBlockData{T}() where {T}
        return new(
            zero(MOI.ScalarQuadraticFunction{T}),
            _kFunctionTypeScalarAffine,
            Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}[],
            T[],
            T[],
            Union{Nothing,T}[],
            _FunctionType[],
            _BoundType[],
            Dict{Int64,T}(),
        )
    end
end

function _value(variable::MOI.VariableIndex, x::AbstractVector, p::Dict)
    if _is_parameter(variable)
        return p[variable.value]
    else
        return x[variable.value]
    end
end

function eval_function(
    f::MOI.ScalarQuadraticFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::T where {T}
    y = f.constant
    for term in f.affine_terms
        y += term.coefficient * _value(term.variable, x, p)
    end
    for term in f.quadratic_terms
        v1 = _value(term.variable_1, x, p)
        v2 = _value(term.variable_2, x, p)
        if term.variable_1 == term.variable_2
            y += term.coefficient * v1 * v2 / 2
        else
            y += term.coefficient * v1 * v2
        end
    end
    return y
end

function eval_function(
    f::MOI.ScalarAffineFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::T where {T}
    y = f.constant
    for term in f.terms
        y += term.coefficient * _value(term.variable, x, p)
    end
    return y
end

function eval_dense_gradient(
    ∇f::AbstractVector{T},
    f::MOI.ScalarQuadraticFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::Nothing where {T}
    for term in f.affine_terms
        if !_is_parameter(term.variable)
            ∇f[term.variable.value] += term.coefficient
        end
    end
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1)
            v = _value(term.variable_2, x, p)
            ∇f[term.variable_1.value] += term.coefficient * v
        end
        if term.variable_1 != term.variable_2 && !_is_parameter(term.variable_2)
            v = _value(term.variable_1, x, p)
            ∇f[term.variable_2.value] += term.coefficient * v
        end
    end
    return
end

function eval_dense_gradient(
    ∇f::AbstractVector{T},
    f::MOI.ScalarAffineFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::Nothing where {T}
    for term in f.terms
        if !_is_parameter(term.variable)
            ∇f[term.variable.value] += term.coefficient
        end
    end
    return
end

function append_sparse_gradient_structure!(
    f::MOI.ScalarQuadraticFunction,
    J,
    row,
)
    for term in f.affine_terms
        if !_is_parameter(term.variable)
            push!(J, (row, term.variable.value))
        end
    end
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1)
            push!(J, (row, term.variable_1.value))
        end
        if term.variable_1 != term.variable_2 && !_is_parameter(term.variable_2)
            push!(J, (row, term.variable_2.value))
        end
    end
    return
end

function append_sparse_gradient_structure!(f::MOI.ScalarAffineFunction, J, row)
    for term in f.terms
        if !_is_parameter(term.variable)
            push!(J, (row, term.variable.value))
        end
    end
    return
end

function eval_sparse_gradient(
    ∇f::AbstractVector{T},
    f::MOI.ScalarQuadraticFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::Int where {T}
    i = 0
    for term in f.affine_terms
        if !_is_parameter(term.variable)
            i += 1
            ∇f[i] = term.coefficient
        end
    end
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1)
            v = _value(term.variable_2, x, p)
            i += 1
            ∇f[i] = term.coefficient * v
        end
        if term.variable_1 != term.variable_2 && !_is_parameter(term.variable_2)
            v = _value(term.variable_1, x, p)
            i += 1
            ∇f[i] = term.coefficient * v
        end
    end
    return i
end

function eval_sparse_gradient(
    ∇f::AbstractVector{T},
    f::MOI.ScalarAffineFunction{T},
    x::AbstractVector{T},
    p::Dict{Int64,T},
)::Int where {T}
    i = 0
    for term in f.terms
        if !_is_parameter(term.variable)
            i += 1
            ∇f[i] = term.coefficient
        end
    end
    return i
end

function append_sparse_hessian_structure!(f::MOI.ScalarQuadraticFunction, H)
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1) && !_is_parameter(term.variable_2)
            push!(H, (term.variable_1.value, term.variable_2.value))
        end
    end
    return
end

append_sparse_hessian_structure!(::MOI.ScalarAffineFunction, H) = nothing

function eval_sparse_hessian(
    ∇²f::AbstractVector{T},
    f::MOI.ScalarQuadraticFunction{T},
    σ::T,
)::Int where {T}
    i = 0
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1) && !_is_parameter(term.variable_2)
            i += 1
            ∇²f[i] = term.coefficient * σ
        end
    end
    return i
end

function eval_sparse_hessian(
    ∇²f::AbstractVector{T},
    f::MOI.ScalarAffineFunction{T},
    σ::T,
)::Int where {T}
    return 0
end

function eval_Jv_product(
    f::MOI.ScalarAffineFunction{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
    p::Dict{Int64,T},
    i::Int,
)::Nothing where {T}
    for term in f.terms
        if !_is_parameter(term.variable)
            y[i] += term.coefficient * w[term.variable.value]
        end
    end
    return
end

function eval_Jv_product(
    f::MOI.ScalarQuadraticFunction{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
    p::Dict{Int64,T},
    i::Int,
)::Nothing where {T}
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1)
            val = _value(term.variable_2, x, p)
            y[i] += term.coefficient * val * w[term.variable_1.value]
        end
        if term.variable_1 != term.variable_2 && !_is_parameter(term.variable_2)
            val = _value(term.variable_1, x, p)
            y[i] += term.coefficient * val * w[term.variable_2.value]
        end
    end
    for term in f.affine_terms
        if !_is_parameter(term.variable)
            y[i] += term.coefficient * w[term.variable.value]
        end
    end
    return
end

function eval_Jtv_product(
    f::MOI.ScalarAffineFunction{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
    p::Dict{Int64,T},
    i::Int,
)::Nothing where {T}
    wi = w[i]
    for term in f.terms
        if !_is_parameter(term.variable)
            y[term.variable.value] += wi * term.coefficient
        end
    end
    return
end

function eval_Jtv_product(
    f::MOI.ScalarQuadraticFunction{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
    p::Dict{Int64,T},
    i::Int,
)::Nothing where {T}
    wi = w[i]
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1)
            y[term.variable_1.value] += wi * term.coefficient * _value(term.variable_2, x, p)
        end
        if term.variable_1 != term.variable_2 && !_is_parameter(term.variable_2)
            y[term.variable_2.value] += wi * term.coefficient * _value(term.variable_1, x, p)
        end
    end
    for term in f.affine_terms
        if !_is_parameter(term.variable)
            y[term.variable.value] += wi * term.coefficient
        end
    end
    return
end

function eval_Hv_product(
    f::MOI.ScalarAffineFunction{T},
    H::AbstractVector{T},
    x::AbstractVector{T},
    v::AbstractVector{T},
    α::T,
)::Nothing where {T}
    return
end

function eval_Hv_product(
    f::MOI.ScalarQuadraticFunction{T},
    H::AbstractVector{T},
    x::AbstractVector{T},
    v::AbstractVector{T},
    α::T,
)::Nothing where {T}
    for term in f.quadratic_terms
        if !_is_parameter(term.variable_1) && !_is_parameter(term.variable_2)
            H[term.variable_1.value] += α * term.coefficient * v[term.variable_2.value]
            if term.variable_1 != term.variable_2
                H[term.variable_2.value] += α * term.coefficient * v[term.variable_1.value]
            end
        end
    end
    return
end

Base.length(block::QPBlockData) = length(block.bound_type)

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ObjectiveFunction{F},
    f::F,
) where {T,F<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}}
    block.objective = convert(MOI.ScalarAffineFunction{T}, f)
    block.objective_function_type = _function_info(f)
    return
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}},
    f::MOI.ScalarQuadraticFunction{T},
) where {T}
    block.objective = f
    block.objective_function_type = _function_info(f)
    return
end

function MOI.get(block::QPBlockData{T}, ::MOI.ObjectiveFunctionType) where {T}
    return _function_type_to_set(T, block.objective_function_type)
end

function MOI.get(block::QPBlockData{T}, ::MOI.ObjectiveFunction{F}) where {T,F}
    return convert(F, block.objective)
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.ListOfConstraintTypesPresent,
) where {T}
    constraints = Set{Tuple{Type,Type}}()
    for i in 1:length(block)
        F = _function_type_to_set(T, block.function_type[i])
        S = _bound_type_to_set(T, block.bound_type[i])
        push!(constraints, (F, S))
    end
    return collect(constraints)
end

function MOI.is_valid(
    block::QPBlockData{T},
    ci::MOI.ConstraintIndex{F,S},
) where {
    T,
    F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T},MOI.Interval{T}},
}
    return 1 <= ci.value <= length(block)
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.ListOfConstraintIndices{F,S},
) where {
    T,
    F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T},MOI.Interval{T}},
}
    ret = MOI.ConstraintIndex{F,S}[]
    for i in 1:length(block)
        if _bound_type_to_set(T, block.bound_type[i]) != S
            continue
        elseif _function_type_to_set(T, block.function_type[i]) != F
            continue
        end
        push!(ret, MOI.ConstraintIndex{F,S}(i))
    end
    return ret
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.NumberOfConstraints{F,S},
) where {
    T,
    F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T},MOI.Interval{T}},
}
    return length(MOI.get(block, MOI.ListOfConstraintIndices{F,S}()))
end

function MOI.add_constraint(
    block::QPBlockData{T},
    f::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    set::Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T},MOI.Interval{T}},
) where {T}
    push!(block.constraints, f)
    bound_type, l, u = _set_info(set)
    push!(block.g_L, l)
    push!(block.g_U, u)
    push!(block.mult_g, nothing)
    push!(block.bound_type, bound_type)
    push!(block.function_type, _function_info(f))
    return MOI.ConstraintIndex{typeof(f),typeof(set)}(length(block.bound_type))
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{F,S},
) where {T,F,S}
    return convert(F, block.constraints[c.value])
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,S},
) where {T,F,S}
    row = c.value
    if block.bound_type[row] == _kBoundTypeEqualTo
        return MOI.EqualTo(block.g_L[row])
    elseif block.bound_type[row] == _kBoundTypeLessThan
        return MOI.LessThan(block.g_U[row])
    elseif block.bound_type[row] == _kBoundTypeGreaterThan
        return MOI.GreaterThan(block.g_L[row])
    else
        @assert block.bound_type[row] == _kBoundTypeInterval
        return MOI.Interval(block.g_L[row], block.g_U[row])
    end
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,MOI.LessThan{T}},
    set::MOI.LessThan{T},
) where {T,F}
    row = c.value
    block.g_U[row] = set.upper
    return
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,MOI.GreaterThan{T}},
    set::MOI.GreaterThan{T},
) where {T,F}
    row = c.value
    block.g_L[row] = set.lower
    return
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,MOI.EqualTo{T}},
    set::MOI.EqualTo{T},
) where {T,F}
    row = c.value
    block.g_L[row] = set.value
    block.g_U[row] = set.value
    return
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,MOI.Interval{T}},
    set::MOI.Interval{T},
) where {T,F}
    row = c.value
    block.g_L[row] = set.lower
    block.g_U[row] = set.upper
    return
end

function MOI.get(
    block::QPBlockData{T},
    ::MOI.ConstraintDualStart,
    c::MOI.ConstraintIndex{F,S},
) where {T,F,S}
    return block.mult_g[c.value]
end

function MOI.set(
    block::QPBlockData{T},
    ::MOI.ConstraintDualStart,
    c::MOI.ConstraintIndex{F,S},
    value,
) where {T,F,S}
    block.mult_g[c.value] = value
    return
end

function MOI.eval_objective(
    block::QPBlockData{T},
    x::AbstractVector{T},
) where {T}
    return eval_function(block.objective, x, block.parameters)
end

function MOI.eval_objective_gradient(
    block::QPBlockData{T},
    ∇f::AbstractVector{T},
    x::AbstractVector{T},
) where {T}
    ∇f .= zero(T)
    eval_dense_gradient(∇f, block.objective, x, block.parameters)
    return
end

function MOI.eval_constraint(
    block::QPBlockData{T},
    g::AbstractVector{T},
    x::AbstractVector{T},
) where {T}
    for (i, constraint) in enumerate(block.constraints)
        g[i] = eval_function(constraint, x, block.parameters)
    end
    return
end

function MOI.jacobian_structure(block::QPBlockData)
    J = Tuple{Int,Int}[]
    for (row, constraint) in enumerate(block.constraints)
        append_sparse_gradient_structure!(constraint, J, row)
    end
    return J
end

function MOI.eval_constraint_jacobian(
    block::QPBlockData{T},
    J::AbstractVector{T},
    x::AbstractVector{T},
) where {T}
    i = 1
    for constraint in block.constraints
        ∇f = view(J, i:length(J))
        i += eval_sparse_gradient(∇f, constraint, x, block.parameters)
    end
    return i
end

function MOI.hessian_lagrangian_structure(block::QPBlockData)
    H = Tuple{Int,Int}[]
    append_sparse_hessian_structure!(block.objective, H)
    for constraint in block.constraints
        append_sparse_hessian_structure!(constraint, H)
    end
    return H
end

function MOI.eval_hessian_lagrangian(
    block::QPBlockData{T},
    H::AbstractVector{T},
    x::AbstractVector{T},
    σ::T,
    μ::AbstractVector{T},
) where {T}
    i = 1
    i += eval_sparse_hessian(H, block.objective, σ)
    for (row, constraint) in enumerate(block.constraints)
        ∇²f = view(H, i:length(H))
        i += eval_sparse_hessian(∇²f, constraint, μ[row])
    end
    return i
end

function MOI.eval_constraint_jacobian_product(
    block::QPBlockData{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
) where {T}
    for (i, constraint) in enumerate(block.constraints)
        eval_Jv_product(constraint, y, x, w, block.parameters, i)
    end
    return
end

function MOI.eval_constraint_jacobian_transpose_product(
    block::QPBlockData{T},
    y::AbstractVector{T},
    x::AbstractVector{T},
    w::AbstractVector{T},
) where {T}
    for (i, constraint) in enumerate(block.constraints)
        eval_Jtv_product(constraint, y, x, w, block.parameters, i)
    end
    return
end

function MOI.eval_hessian_lagrangian_product(
    block::QPBlockData{T},
    H::AbstractVector{T},
    x::AbstractVector{T},
    v::AbstractVector{T},
    σ::T,
    μ::AbstractVector{T},
) where {T}
    eval_Hv_product(block.objective, H, x, v, σ)
    for (i, constraint) in enumerate(block.constraints)
        eval_Hv_product(constraint, H, x, v, μ[i])
    end
    return
end

using BinaryBuilder, Pkg

haskey(ENV, "UNO_RELEASE") || error("The environment variable UNO_RELEASE is not defined.")
haskey(ENV, "UNO_COMMIT") || error("The environment variable UNO_COMMIT is not defined.")
haskey(ENV, "UNO_URL") || error("The environment variable UNO_URL is not defined.")

name = "Uno"
version = VersionNumber(ENV["UNO_RELEASE"])

# Collection of sources required to complete build
sources = [
    GitSource(ENV["UNO_URL"], ENV["UNO_COMMIT"]),
    # v2025.9.18
    GitSource("https://github.com/ralna/spral.git",
              "e68988612dbd920323cee44c9cb8c6134847a990"),
    # v5.8.2
    ArchiveSource("https://mumps-solver.org/MUMPS_5.8.2.tar.gz",
                  "eb515aa688e6dbab414bb6e889ff4c8b23f1691a843c68da5230a33ac4db7039"),
]

# Bash recipe for building across all platforms
script = raw"""
# Export dependencies
mkdir ${prefix}/deps
cd ${libdir}
for file in $(ls .); do
   if [[ -f $file ]]; then
      if [[ -z $(ls -la $file | grep 'artifacts') ]]; then
         cp -P ${file} ${prefix}/deps/${file}
      else
         cp -L ${file} ${prefix}/deps/${file}
      fi
   fi
done

cd ${prefix}
cp -rL share/licenses deps/licenses
mkdir deps/licenses/MUMPS
cp $WORKSPACE/srcdir/MUMPS_5.8.2/LICENSE deps/licenses/MUMPS/LICENSE
mkdir deps/licenses/spral
cp $WORKSPACE/srcdir/spral/LICENCE deps/licenses/spral/LICENCE
chmod -R u=rwx deps
tar -czvf deps.tar.gz deps
rm -r deps

# Update Ninja
cp ${host_prefix}/bin/ninja /usr/bin/ninja

# Compile MUMPS
mkdir -p ${libdir}
cd $WORKSPACE/srcdir/MUMPS*

makefile="Makefile.G95.SEQ"
cp Make.inc/${makefile} Makefile.inc

# Add `-fallow-argument-mismatch` if supported
: >empty.f
FFLAGS=()
if gfortran -c -fallow-argument-mismatch empty.f >/dev/null 2>&1; then
    FFLAGS+=("-fallow-argument-mismatch")
fi
rm -f empty.*

if [[ "${target}" == *apple* ]]; then
    SONAME="-install_name"
else
    SONAME="-soname"
fi

make_args+=(OPTF="-O3"
            OPTL="-O3"
            OPTC="-O3"
            CDEFS=-DAdd_
            LMETISDIR=${libdir}
            IMETIS=-I${includedir}
            LMETIS="-L${libdir} -lmetis"
            ORDERINGSF="-Dpord -Dmetis"
            LIBEXT_SHARED=".${dlext}"
            SHARED_OPT="-shared"
            SONAME="${SONAME}"
            CC="$CC ${CFLAGS[@]}"
            FC="gfortran ${FFLAGS[@]}"
            FL="gfortran"
            RANLIB="echo"
            LIBBLAS="-L${libdir} -lopenblas"
            LAPACK="-L${libdir} -lopenblas")

make -j${nproc} dshared "${make_args[@]}"

mkdir ${includedir}/libseq
cp include/*.h ${includedir}
cp libseq/*.h ${includedir}/libseq
cp lib/*.${dlext} ${libdir}

# Compile SPRAL
cd $WORKSPACE/srcdir/spral

if [[ "${target}" == *mingw* ]]; then
  HWLOC="hwloc-15"
else
  HWLOC="hwloc"
fi

meson setup builddir --cross-file="${MESON_TARGET_TOOLCHAIN}" \
                     --prefix=$prefix \
                     -Dlibhwloc=$HWLOC \
                     -Dlibblas=openblas \
                     -Dliblapack=openblas \
                     -Dtests=false \
                     -Dexamples=false

meson compile -C builddir
meson install -C builddir

# Compile Uno
cd $WORKSPACE/srcdir/Uno
mkdir -p build
cd build

if [[ "${target}" == *apple* ]] || [[ "${target}" == *freebsd* ]]; then
    OMP=omp
else
    OMP=gomp
fi

cmake \
    -DCMAKE_INSTALL_PREFIX=${prefix} \
    -DCMAKE_PREFIX_PATH=${libdir} \
    -DCMAKE_TOOLCHAIN_FILE=${CMAKE_TARGET_TOOLCHAIN} \
    -DCMAKE_BUILD_TYPE=Release \
    -DAMPLSOLVER=${libdir}/libasl.${dlext} \
    -DHIGHS=${libdir}/libhighs.${dlext} \
    -DBQPD=${prefix}/lib/libbqpd.a \
    -DHSL=${libdir}/libhsl.${dlext} \
    -DSPRAL=${libdir}/libspral.${dlext} \
    -DMUMPS_INCLUDE_DIR=${includedir} \
    -DMETIS_INCLUDE_DIR=${includedir} \
    -DMUMPS_LIBRARY="${libdir}/libdmumps.${dlext}" \
    -DMUMPS_COMMON_LIBRARY="${libdir}/libmumps_common.${dlext}" \
    -DMUMPS_PORD_LIBRARY="${libdir}/libpord.${dlext}" \
    -DMUMPS_MPISEQ_LIBRARY="${libdir}/libmpiseq.${dlext}" \
    -DBLAS_LIBRARIES="${libdir}/libopenblas.${dlext}" \
    -DLAPACK_LIBRARIES="${libdir}/libopenblas.${dlext}" \
    -DBUILD_STATIC_LIBS=ON \
    -DBUILD_SHARED_LIBS=ON \
    ..

make uno_ampl -j${nproc}
make install

# Uno
install_license ${WORKSPACE}/srcdir/Uno/LICENSE
"""

# These are the platforms we will build for by default, unless further
# platforms are passed in on the command line
platforms = supported_platforms()
platforms = expand_gfortran_versions(platforms)

# The products that we will ensure are always built
products = [
   LibraryProduct("libspral", :libspral),
   LibraryProduct("libdmumps", :libdmumps),
   ExecutableProduct("uno_ampl", :amplexe),
   LibraryProduct("libuno", :libuno),
   FileProduct("lib/libuno.a", :libuno_a),
]

# Dependencies that must be installed before this package can be built
dependencies = [
    HostBuildDependency(PackageSpec(name="Ninja_jll", uuid="76642167-d241-5cee-8c94-7a494e8cb7b7")),
    BuildDependency(PackageSpec(name="BQPD_jll", uuid="1325ac01-0a49-589f-8355-43321054aaab")),
    Dependency(PackageSpec(name="HiGHS_jll", uuid="8fd58aa0-07eb-5a78-9b36-339c94fd15ea"), compat="=1.12.0"),
    Dependency(PackageSpec(name="HSL_jll", uuid="017b0a0e-03f4-516a-9b91-836bbd1904dd")),
    Dependency(PackageSpec(name="METIS_jll", uuid="d00139f3-1899-568f-a2f0-47f597d42d70")),
    Dependency(PackageSpec(name="ASL_jll", uuid="ae81ac8f-d209-56e5-92de-9978fef736f9"), compat="0.1.3"),
    Dependency(PackageSpec(name="OpenBLAS32_jll", uuid="656ef2d0-ae68-5445-9ca0-591084a874a2")),
    Dependency(PackageSpec(name="Hwloc_jll", uuid="e33a78d0-f292-5ffc-b300-72abe9b543c8")),
    # For OpenMP we use libomp from `LLVMOpenMP_jll` where we use LLVM as compiler (BSD systems),
    # and libgomp from `CompilerSupportLibraries_jll` everywhere else.
    Dependency(PackageSpec(name="CompilerSupportLibraries_jll", uuid="e66e0078-7015-5450-92f7-15fbd957f2ae"); platforms=filter(!Sys.isbsd, platforms)),
    Dependency(PackageSpec(name="LLVMOpenMP_jll", uuid="1d63c593-3942-5779-bab2-d838dc0a180e"); platforms=filter(Sys.isbsd, platforms)),
    HostBuildDependency(PackageSpec(name="CMake_jll", uuid="3f4e10e2-61f2-5801-8945-23b9d642d0e6")),
]

build_tarballs(
    ARGS,
    name,
    version,
    sources,
    script,
    platforms,
    products,
    dependencies;
    julia_compat = "1.6",
    preferred_gcc_version = v"10.2.0",
    clang_use_lld=false,
)

# Copyright (c) 2025: Charlie Vanaret and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using JuMP, AmplNLWriter, Uno_jll

function Optimizer(options)
    return AmplNLWriter.Optimizer(Uno_jll.amplexe, options)
end

Optimizer_Uno_filtersqp() = Optimizer(["logger=SILENT", "preset=filtersqp", "QP_solver=BQPD", "max_iterations=10000", "unbounded_objective_threshold=-1e15"])

function test_hs015()
    model = Model(() -> Optimizer_Uno_filtersqp())

    @variable(model, x, start = -2.)
    @variable(model, y, start = 1.)

    @objective(model, Min, 100*(y - x^2)^2 + (1 - x)^2)

    c1 = @constraint(model, x*y >= 1)
    c2 = @constraint(model, x + y^2 >= 0)
    c3 = @constraint(model, x <= 0.5)

    optimize!(model)

    tolerance = 1e-6
    @assert abs(objective_value(model) - 306.5) <= tolerance
    @assert abs(value(x) - 0.5) <= tolerance
    @assert abs(value(y) - 2.) <= tolerance
    @assert abs(dual(c1) - 700.) <= tolerance
    @assert abs(dual(c2) - 0.) <= tolerance
    @assert abs(dual(c3) - (-1751.)) <= tolerance
end

function test_isolated()
    model = Model(() -> Optimizer_Uno_filtersqp())

    x0 = [3., 2.]
    @variable(model, x[i=1:2], start = x0[i])

    @objective(model, Min, x[1] + x[2])

    c1 = @constraint(model, -x[1]^2 + x[2] - 1 >= 0)
    c2 = @constraint(model, -x[1]^2 - x[2] - 1 >= 0)
    c3 = @constraint(model, x[1] - x[2]^2 - 1 >= 0)
    c4 = @constraint(model, -x[1] - x[2]^2 - 1 >= 0)

    optimize!(model)

    tolerance = 1e-6
    @assert abs(objective_value(model) - 0.) <= tolerance
    @assert abs(value(x[1]) - 0.) <= tolerance
    @assert abs(value(x[2]) - 0.) <= tolerance
    @assert abs(dual(c1) - 1.) <= tolerance
    @assert abs(dual(c2) - 1.) <= tolerance
    @assert abs(dual(c3) - 1.) <= tolerance
    @assert abs(dual(c4) - 1.) <= tolerance
end

function test_nactive()
    model = Model(() -> Optimizer_Uno_filtersqp())

    x0 = [-20., 10.]
    @variable(model, x[i=1:2], start = x0[i])

    @objective(model, Min, x[1])

    c1 = @constraint(model, 0.5*(-x[1] - x[2]^2 - 1) >= 0)
    c2 = @constraint(model, x[1] - x[2]^2 >= 0)
    c3 = @constraint(model, -x[1] + x[2]^2 >= 0)

    optimize!(model)

    tolerance = 1e-6
    @assert abs(objective_value(model) - 0.) <= tolerance
    @assert abs(value(x[1]) - 0.) <= tolerance
    @assert abs(value(x[2]) - 0.) <= tolerance
    @assert abs(dual(c1) - 1.) <= tolerance
    @assert abs(dual(c2) - 0.5) <= tolerance
    @assert abs(dual(c3) - 0.) <= tolerance
end

function test_unique()
    model = Model(() -> Optimizer_Uno_filtersqp())

    x0 = [3., 2.]
    @variable(model, x[i=1:2], start = x0[i])

    @objective(model, Min, x[1] + x[2])

    c1 = @constraint(model, x[2] - x[1]^2 - 1 >= 0)
    c2 = @constraint(model, 0.3*(1 - exp(x[2])) >= 0)

    optimize!(model)

    tolerance = 1e-6
    @assert abs(objective_value(model) - 1.) <= tolerance
    @assert abs(value(x[1]) - 0.) <= tolerance
    @assert abs(value(x[2]) - 1.) <= tolerance
    @assert abs(dual(c1) - 0.8154845) <= tolerance
    @assert abs(dual(c2) - 1.) <= tolerance
end

test_hs015()
test_isolated()
test_nactive()
test_unique()

# Note that this script can accept some limited command-line arguments, run
# `julia build_tarballs.jl --help` to see a usage message.
using BinaryBuilder, Pkg

haskey(ENV, "UNO_RELEASE") || error("The environment variable UNO_RELEASE is not defined.")
haskey(ENV, "UNO_COMMIT") || error("The environment variable UNO_COMMIT is not defined.")
haskey(ENV, "UNO_URL") || error("The environment variable UNO_URL is not defined.")

name = "Uno"
version = VersionNumber(ENV["UNO_RELEASE"])

# Collection of sources required to complete build
sources = [
    GitSource(ENV["UNO_URL"], ENV["UNO_COMMIT"]),
]

# The remainder of the file is similar to the content found at the following link:
# https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/U/Uno/build_tarballs.jl
script = raw"""
cd $WORKSPACE/srcdir/Uno
mkdir -p build
cd build

if [[ "${target}" == *mingw* ]]; then
    LBT=blastrampoline-5
else
    LBT=blastrampoline
fi

if [[ "${target}" == *apple* ]] || [[ "${target}" == *freebsd* ]]; then
    OMP=omp
else
    OMP=gomp
fi

cmake \
    -DCMAKE_INSTALL_PREFIX=${prefix} \
    -DCMAKE_PREFIX_PATH=${libdir} \
    -DCMAKE_TOOLCHAIN_FILE=${CMAKE_TARGET_TOOLCHAIN} \
    -DCMAKE_BUILD_TYPE=Debug \
    -DAMPLSOLVER=${libdir}/libasl.${dlext} \
    -DHIGHS=${libdir}/libhighs.${dlext} \
    -DBQPD=${prefix}/lib/libbqpd.a \
    -DHSL=${libdir}/libhsl.${dlext} \
    -DBLA_VENDOR="libblastrampoline" \
    -DMUMPS_INCLUDE_DIR=${includedir} \
    -DMETIS_INCLUDE_DIR=${includedir} \
    -DMUMPS_LIBRARY="${libdir}/libdmumps.${dlext}" \
    -DMUMPS_COMMON_LIBRARY="${libdir}/libmumps_common.${dlext}" \
    -DMUMPS_PORD_LIBRARY="${libdir}/libpord.${dlext}" \
    -DMUMPS_MPISEQ_LIBRARY="${libdir}/libmpiseq.${dlext}" \
    -DSPRAL="${libdir}/libspral.${dlext}" \
    -DBLAS_LIBRARIES="${libdir}/lib${LBT}.${dlext}" \
    -DLAPACK_LIBRARIES="${libdir}/lib${LBT}.${dlext}" \
    -DBUILD_STATIC_LIBS=ON \
    -DBUILD_SHARED_LIBS=ON \
    ..

make uno_ampl -j${nproc}
make install

# Uno
install_license ${WORKSPACE}/srcdir/Uno/LICENSE

# BQPD
cp ${prefix}/share/licenses/BQPD/LICENSE ${WORKSPACE}/srcdir/Uno/LICENSE_BQPD
install_license ${WORKSPACE}/srcdir/Uno/LICENSE_BQPD
"""

platforms = supported_platforms()
filter!(p -> !(Sys.isfreebsd(p) && arch(p) == "aarch64"), platforms)
platforms = expand_cxxstring_abis(platforms)
platforms = expand_gfortran_versions(platforms)

products = [
    # This LibraryProduct may be useful once Uno provides a C API. We omit it for now.
    # LibraryProduct("libuno", :libuno),
    # We call this amplexe to match the convention of other JLL packages (like Ipopt_jll) that provide AMPL wrappers
    ExecutableProduct("uno_ampl", :amplexe),
    LibraryProduct("libuno", :libuno),
    FileProduct("lib/libuno.a", :libuno_a),
]

dependencies = [
    BuildDependency(PackageSpec(name="BQPD_jll", uuid="1325ac01-0a49-589f-8355-43321054aaab")),
    Dependency(PackageSpec(name="HiGHS_jll", uuid="8fd58aa0-07eb-5a78-9b36-339c94fd15ea"), compat="1.12.0"),
    Dependency(PackageSpec(name="HSL_jll", uuid="017b0a0e-03f4-516a-9b91-836bbd1904dd")),
    Dependency(PackageSpec(name="METIS_jll", uuid="d00139f3-1899-568f-a2f0-47f597d42d70")),
    Dependency(PackageSpec(name="ASL_jll", uuid="ae81ac8f-d209-56e5-92de-9978fef736f9"), compat="0.1.3"),
    Dependency(PackageSpec(name="MUMPS_seq_jll", uuid="d7ed1dd3-d0ae-5e8e-bfb4-87a502085b8d")),
    Dependency(PackageSpec(name="SPRAL_jll", uuid="319450e9-13b8-58e8-aa9f-8fd1420848ab")),
    Dependency(PackageSpec(name="libblastrampoline_jll", uuid="8e850b90-86db-534c-a0d3-1478176c7d93"), compat="5.4.0"),
    # For OpenMP we use libomp from `LLVMOpenMP_jll` where we use LLVM as compiler (BSD systems),
    # and libgomp from `CompilerSupportLibraries_jll` everywhere else.
    Dependency(PackageSpec(name="CompilerSupportLibraries_jll", uuid="e66e0078-7015-5450-92f7-15fbd957f2ae"); platforms=filter(!Sys.isbsd, platforms)),
    Dependency(PackageSpec(name="LLVMOpenMP_jll", uuid="1d63c593-3942-5779-bab2-d838dc0a180e"); platforms=filter(Sys.isbsd, platforms)),

    # We need at least 3.29 (Ygg version), or 3.30 upstream version for LBT support,
    # so always pull the most recent CMake version.
    HostBuildDependency(PackageSpec(name="CMake_jll", uuid="3f4e10e2-61f2-5801-8945-23b9d642d0e6")),
]

build_tarballs(
    ARGS,
    name,
    version,
    sources,
    script,
    platforms,
    products,
    dependencies;
    julia_compat = "1.9",
    preferred_gcc_version = v"10.2.0",
    clang_use_lld=false,
)

@testset "preset = filtersqp" begin
    @testset "uno_model -- uno_solver -- uno_optimize -- HS15 -- L-BFGS Hessian" begin
        nlp = CUTEstModel{Float64}("HS15")
        model = uno_model(nlp)
        solver = uno_solver(preset="filtersqp", print_solution=true, hessian_model="LBFGS")
        uno_optimize(solver, model)

        optimization_status = UnoSolver.uno_get_optimization_status(solver)
        solution_status = UnoSolver.uno_get_solution_status(solver)
        solution_objective = UnoSolver.uno_get_solution_objective(solver)
        solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
        solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
        solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

        primal_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_primal_solution(solver, primal_solution)

        constraint_dual_solution = Vector{Float64}(undef, nlp.meta.ncon)
        UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

        lower_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

        upper_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

        for i in 1:nlp.meta.nvar
            @test primal_solution[i] == UnoSolver.uno_get_primal_solution_component(solver, i-1)
            @test lower_bound_dual_solution[i] == UnoSolver.uno_get_lower_bound_dual_solution_component(solver, i-1)
            @test upper_bound_dual_solution[i] == UnoSolver.uno_get_upper_bound_dual_solution_component(solver, i-1)
        end

        for j in 1:nlp.meta.ncon
            @test constraint_dual_solution[j] == UnoSolver.uno_get_constraint_dual_solution_component(solver, j-1)
        end

        finalize(nlp)
    end

    @testset "uno_model -- uno_solver -- uno_optimize -- HS15 -- exact Hessian" begin
        nlp = CUTEstModel{Float64}("HS15")
        model = uno_model(nlp)
        solver = uno_solver(preset="filtersqp", print_solution=true, hessian_model="exact")
        uno_optimize(solver, model)

        optimization_status = UnoSolver.uno_get_optimization_status(solver)
        solution_status = UnoSolver.uno_get_solution_status(solver)
        solution_objective = UnoSolver.uno_get_solution_objective(solver)
        solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
        solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
        solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

        primal_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_primal_solution(solver, primal_solution)

        constraint_dual_solution = Vector{Float64}(undef, nlp.meta.ncon)
        UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

        lower_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

        upper_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

        for i in 1:nlp.meta.nvar
            @test primal_solution[i] == UnoSolver.uno_get_primal_solution_component(solver, i-1)
            @test lower_bound_dual_solution[i] == UnoSolver.uno_get_lower_bound_dual_solution_component(solver, i-1)
            @test upper_bound_dual_solution[i] == UnoSolver.uno_get_upper_bound_dual_solution_component(solver, i-1)
        end

        for j in 1:nlp.meta.ncon
            @test constraint_dual_solution[j] == UnoSolver.uno_get_constraint_dual_solution_component(solver, j-1)
        end

        finalize(nlp)
    end

    @testset "uno -- CUTEst" begin
        nlp = CUTEstModel{Float64}("BYRDSPHR")
        stats = uno(nlp, preset="filtersqp", print_solution=true)
        model, solver = stats.model, stats.solver

        optimization_status = UnoSolver.uno_get_optimization_status(solver)
        solution_status = UnoSolver.uno_get_solution_status(solver)
        solution_objective = UnoSolver.uno_get_solution_objective(solver)
        solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
        solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
        solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

        primal_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_primal_solution(solver, primal_solution)

        constraint_dual_solution = Vector{Float64}(undef, nlp.meta.ncon)
        UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

        lower_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

        upper_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
        UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

        for i in 1:nlp.meta.nvar
            @test stats.primal_solution[i] == UnoSolver.uno_get_primal_solution_component(solver, i-1)
            @test stats.lower_bound_dual_solution[i] == UnoSolver.uno_get_lower_bound_dual_solution_component(solver, i-1)
            @test stats.upper_bound_dual_solution[i] == UnoSolver.uno_get_upper_bound_dual_solution_component(solver, i-1)
        end

        for j in 1:nlp.meta.ncon
            @test stats.constraint_dual_solution[j] == UnoSolver.uno_get_constraint_dual_solution_component(solver, j-1)
        end

        finalize(nlp)
    end
end

@testset "preset = ipopt" begin
    for linear_solver in ("MUMPS", "SSIDS", "MA27", "MA57")
        (linear_solver == "SSIDS") && (!haskey(ENV, "OMP_CANCELLATION") || !haskey(ENV, "OMP_PROC_BIND")) && continue
        (linear_solver == "MA27" || linear_solver == "MA57") && !(@ccall HSL_jll.libhsl.LIBHSL_isfunctional()::Bool) && continue

        @testset "linear solver = $linear_solver" begin

            @testset "uno_model -- uno_solver -- uno_optimize -- HS15 -- exact Hessian" begin
                println("Solving with linear solver ", linear_solver)
                nlp = CUTEstModel{Float64}("HS15")
                model = uno_model(nlp)
                solver = uno_solver(preset="ipopt", print_solution=true, linear_solver=linear_solver, hessian_model="exact")
                uno_optimize(solver, model)

                optimization_status = UnoSolver.uno_get_optimization_status(solver)
                solution_status = UnoSolver.uno_get_solution_status(solver)
                solution_objective = UnoSolver.uno_get_solution_objective(solver)
                solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
                solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
                solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

                primal_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_primal_solution(solver, primal_solution)

                constraint_dual_solution = Vector{Float64}(undef, nlp.meta.ncon)
                UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

                lower_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

                upper_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

                for i in 1:nlp.meta.nvar
                    @test primal_solution[i] == UnoSolver.uno_get_primal_solution_component(solver, i-1)
                    @test lower_bound_dual_solution[i] == UnoSolver.uno_get_lower_bound_dual_solution_component(solver, i-1)
                    @test upper_bound_dual_solution[i] == UnoSolver.uno_get_upper_bound_dual_solution_component(solver, i-1)
                end

                for j in 1:nlp.meta.ncon
                    @test constraint_dual_solution[j] == UnoSolver.uno_get_constraint_dual_solution_component(solver, j-1)
                end

                finalize(nlp)
            end

            @testset "uno -- CUTEst" begin
                nlp = CUTEstModel{Float64}("BYRDSPHR")
                stats = uno(nlp, preset="ipopt", linear_solver=linear_solver, print_solution=true)
                model, solver = stats.model, stats.solver

                optimization_status = UnoSolver.uno_get_optimization_status(solver)
                solution_status = UnoSolver.uno_get_solution_status(solver)
                solution_objective = UnoSolver.uno_get_solution_objective(solver)
                solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
                solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
                solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)

                primal_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_primal_solution(solver, primal_solution)

                constraint_dual_solution = Vector{Float64}(undef, nlp.meta.ncon)
                UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

                lower_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

                upper_bound_dual_solution = Vector{Float64}(undef, nlp.meta.nvar)
                UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

                for i in 1:nlp.meta.nvar
                    @test stats.primal_solution[i] == UnoSolver.uno_get_primal_solution_component(solver, i-1)
                    @test stats.lower_bound_dual_solution[i] == UnoSolver.uno_get_lower_bound_dual_solution_component(solver, i-1)
                    @test stats.upper_bound_dual_solution[i] == UnoSolver.uno_get_upper_bound_dual_solution_component(solver, i-1)
                end

                for j in 1:nlp.meta.ncon
                    @test stats.constraint_dual_solution[j] == UnoSolver.uno_get_constraint_dual_solution_component(solver, j-1)
                end

                finalize(nlp)
            end
        end
    end
end

! Copyright (c) 2026 Alexis Montoison and Charlie Vanaret
! Licensed under the MIT license. See LICENSE file in the project directory for details.

!==============================================================
! Fortran interfaces -- uno_fortran.f90
!==============================================================

!---------------------------------------------
! uno_create_model
!---------------------------------------------
function uno_create_model(problem_type, number_variables, variables_lower_bounds, &
                          variables_upper_bounds, base_indexing) result(model)
   character(len=*) :: problem_type
   integer(uno_int), value :: number_variables, base_indexing
   real(c_double), dimension(*) :: variables_lower_bounds, variables_upper_bounds
   type(c_ptr) :: model
   character(c_char), allocatable :: problem_type_c(:)
   integer :: i, n

   interface
      function uno_create_model_c(problem_type, number_variables, variables_lower_bounds, &
                                  variables_upper_bounds, base_indexing) result(model) &
         bind(C, name="uno_create_model")
         import :: c_char, uno_int, c_double, c_ptr
         character(c_char), dimension(*) :: problem_type
         integer(uno_int), value :: number_variables, base_indexing
         real(c_double), dimension(*) :: variables_lower_bounds, variables_upper_bounds
         type(c_ptr) :: model
      end function uno_create_model_c
   end interface

   n = len_trim(problem_type)
   allocate(problem_type_c(n+1))
   do i = 1, n
      problem_type_c(i) = problem_type(i:i)
   end do
   problem_type_c(n+1) = c_null_char
   model = uno_create_model_c(problem_type_c, number_variables, variables_lower_bounds, variables_upper_bounds, base_indexing)
   deallocate(problem_type_c)
end function uno_create_model

!---------------------------------------------
! uno_set_solver_integer_option
!---------------------------------------------
function uno_set_solver_integer_option(solver, option_name, option_value) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   integer(uno_int), value :: option_value
   logical(c_bool) :: success
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_set_solver_integer_option_c(solver, option_name, option_value) result(success) &
         bind(C, name="uno_set_solver_integer_option")
         import :: c_ptr, c_char, uno_int, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         integer(uno_int), value :: option_value
         logical(c_bool) :: success
      end function uno_set_solver_integer_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   option_name_c(n+1) = c_null_char
   success = uno_set_solver_integer_option_c(solver, option_name_c, option_value)
   deallocate(option_name_c)
end function uno_set_solver_integer_option

!---------------------------------------------
! uno_set_solver_double_option
!---------------------------------------------
function uno_set_solver_double_option(solver, option_name, option_value) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   real(c_double), value :: option_value
   logical(c_bool) :: success
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_set_solver_double_option_c(solver, option_name, option_value) result(success) &
         bind(C, name="uno_set_solver_double_option")
         import :: c_ptr, c_char, c_double, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         real(c_double), value :: option_value
         logical(c_bool) :: success
      end function uno_set_solver_double_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   option_name_c(n+1) = c_null_char
   success = uno_set_solver_double_option_c(solver, option_name_c, option_value)
   deallocate(option_name_c)
end function uno_set_solver_double_option

!---------------------------------------------
! uno_set_solver_bool_option
!---------------------------------------------
function uno_set_solver_bool_option(solver, option_name, option_value) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   logical(c_bool), value :: option_value
   logical(c_bool) :: success
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_set_solver_bool_option_c(solver, option_name, option_value) result(success) &
         bind(C, name="uno_set_solver_bool_option")
         import :: c_ptr, c_char, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         logical(c_bool), value :: option_value
         logical(c_bool) :: success
      end function uno_set_solver_bool_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   option_name_c(n+1) = c_null_char
   success = uno_set_solver_bool_option_c(solver, option_name_c, option_value)
   deallocate(option_name_c)
end function uno_set_solver_bool_option

!---------------------------------------------
! uno_set_solver_string_option
!---------------------------------------------
function uno_set_solver_string_option(solver, option_name, option_value) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   character(len=*) :: option_value
   logical(c_bool) :: success
   character(c_char), allocatable :: option_name_c(:)
   character(c_char), allocatable :: option_value_c(:)
   integer :: i, n

   interface
      function uno_set_solver_string_option_c(solver, option_name, option_value) result(success) &
         bind(C, name="uno_set_solver_string_option")
         import :: c_ptr, c_char, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         character(c_char), dimension(*) :: option_value
         logical(c_bool) :: success
      end function uno_set_solver_string_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   option_name_c(n+1) = c_null_char
   n = len_trim(option_value)
   allocate(option_value_c(n+1))
   do i = 1, n
      option_value_c(i) = option_value(i:i)
   end do
   option_value_c(n+1) = c_null_char
   success = uno_set_solver_string_option_c(solver, option_name_c, option_value_c)
   deallocate(option_name_c)
   deallocate(option_value_c)
end function uno_set_solver_string_option

!---------------------------------------------
! uno_get_solver_option_type
!---------------------------------------------
function uno_get_solver_option_type(solver, option_name) result(option_type)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   integer(uno_int) :: option_type
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_get_solver_option_type_c(solver, option_name) result(option_type) &
         bind(C, name="uno_get_solver_option_type")
         import :: c_ptr, c_char, uno_int
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         integer(uno_int) :: option_type
      end function uno_get_solver_option_type_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   option_name_c(n+1) = c_null_char
   option_type = uno_get_solver_option_type_c(solver, option_name_c)
   deallocate(option_name_c)
end function uno_get_solver_option_type

!---------------------------------------------
! uno_load_solver_option_file
!---------------------------------------------
function uno_load_solver_option_file(solver, file_name) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: file_name
   logical(c_bool) :: success
   character(c_char), allocatable :: file_name_c(:)
   integer :: i, n

   interface
      function uno_load_solver_option_file_c(solver, file_name) result(success) &
         bind(C, name="uno_load_solver_option_file")
         import :: c_ptr, c_char, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: file_name
         logical(c_bool) :: success
      end function uno_load_solver_option_file_c
   end interface

   n = len_trim(file_name)
   allocate(file_name_c(n+1))
   do i = 1, n
      file_name_c(i) = file_name(i:i)
   end do
   file_name_c(n+1) = c_null_char
   success = uno_load_solver_option_file_c(solver, file_name_c)
   deallocate(file_name_c)
end function uno_load_solver_option_file

!---------------------------------------------
! uno_set_solver_preset
!---------------------------------------------
function uno_set_solver_preset(solver, preset_name) result(success)
   type(c_ptr), value :: solver
   character(len=*) :: preset_name
   logical(c_bool) :: success
   character(c_char), allocatable :: preset_name_c(:)
   integer :: i, n

   interface
      function uno_set_solver_preset_c(solver, preset_name) result(success) &
         bind(C, name="uno_set_solver_preset")
         import :: c_ptr, c_char, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: preset_name
         logical(c_bool) :: success
      end function uno_set_solver_preset_c
   end interface

   n = len_trim(preset_name)
   allocate(preset_name_c(n+1))
   do i = 1, n
      preset_name_c(i) = preset_name(i:i)
   end do
   preset_name_c(n+1) = c_null_char
   success = uno_set_solver_preset_c(solver, preset_name_c)
   deallocate(preset_name_c)
end function uno_set_solver_preset

!---------------------------------------------
! uno_get_solver_integer_option
!---------------------------------------------
function uno_get_solver_integer_option(solver, option_name) result(solver_integer_option)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   integer(uno_int) :: solver_integer_option
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_get_solver_integer_option_c(solver, option_name) result(solver_integer_option) &
         bind(C, name="uno_get_solver_integer_option")
         import :: c_ptr, c_char, uno_int
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         integer(uno_int) :: solver_integer_option
      end function uno_get_solver_integer_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   solver_integer_option = uno_get_solver_integer_option_c(solver, option_name_c)
   deallocate(option_name_c)
end function uno_get_solver_integer_option

!---------------------------------------------
! uno_get_solver_double_option
!---------------------------------------------
function uno_get_solver_double_option(solver, option_name) result(solver_double_option)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   real(c_double) :: solver_double_option
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_get_solver_double_option_c(solver, option_name) result(solver_double_option) &
         bind(C, name="uno_get_solver_double_option")
         import :: c_ptr, c_char, c_double
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         real(c_double) :: solver_double_option
      end function uno_get_solver_double_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   solver_double_option = uno_get_solver_double_option_c(solver, option_name_c)
   deallocate(option_name_c)
end function uno_get_solver_double_option

!---------------------------------------------
! uno_get_solver_bool_option
!---------------------------------------------
function uno_get_solver_bool_option(solver, option_name) result(solver_bool_option)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   logical(c_bool) :: solver_bool_option
   character(c_char), allocatable :: option_name_c(:)
   integer :: i, n

   interface
      function uno_get_solver_bool_option_c(solver, option_name) result(solver_bool_option) &
         bind(C, name="uno_get_solver_bool_option")
         import :: c_ptr, c_char, c_bool
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         logical(c_bool) :: solver_bool_option
      end function uno_get_solver_bool_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   solver_bool_option = uno_get_solver_bool_option_c(solver, option_name_c)
   deallocate(option_name_c)
end function uno_get_solver_bool_option

!---------------------------------------------
! uno_get_solver_string_option
!---------------------------------------------
function uno_get_solver_string_option(solver, option_name) result(solver_string_option)
   type(c_ptr), value :: solver
   character(len=*) :: option_name
   character(:), allocatable :: solver_string_option
   character(c_char), allocatable :: option_name_c(:)
   type(c_ptr) :: ptr_solver_string_option_c
   integer :: i, n
   character(c_char), pointer :: solver_string_option_c(:)

   interface
      function uno_get_solver_string_option_c(solver, option_name) result(solver_string_option) &
         bind(C, name="uno_get_solver_string_option")
         import :: c_ptr, c_char
         type(c_ptr), value :: solver
         character(c_char), dimension(*) :: option_name
         type(c_ptr) :: solver_string_option
      end function uno_get_solver_string_option_c
   end interface

   n = len_trim(option_name)
   allocate(option_name_c(n+1))
   do i = 1, n
      option_name_c(i) = option_name(i:i)
   end do
   ptr_solver_string_option_c = uno_get_solver_string_option_c(solver, option_name_c)
   call c_f_pointer(ptr_solver_string_option_c, solver_string_option_c, [0])
   n = 0
   do while (solver_string_option_c(n+1) /= c_null_char)
      n = n + 1
   end do
   allocate(character(len=n)::solver_string_option)
   do i = 1, n
      solver_string_option(i:i) = solver_string_option_c(i)
   end do
   deallocate(option_name_c)
end function uno_get_solver_string_option

# julia +1.7 --color=yes build_tarballs_utils.jl x86_64-linux-gnu-libgfortran5-cxx11,x86_64-apple-darwin-libgfortran5-cxx11,x86_64-w64-mingw32-libgfortran5-cxx11,aarch64-linux-gnu-libgfortran5-cxx11,aarch64-apple-darwin-libgfortran5-cxx11 --verbose --deploy="amontoison/UnoUtils_jll.jl"
#
# Note: the following variables is needed for cross-compilation on Mac platforms in the .bashrc
# export BINARYBUILDER_AUTOMATIC_APPLE="true"
using BinaryBuilder, Pkg

name = "UnoUtils"
version = v"2026.3.10"

# Collection of sources
sources = [
    # METIS v3.1.0
    GitSource("https://github.com/amontoison/METIS.git",
              "e827ffed17d56a4ac1add9cc33342c453a06c209"),
    FileSource("https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/M/METIS/METIS%405/bundled/patches/0001-mingw-w64-does-not-have-sys-resource-h.patch",
               "0ce0028dcb2205856aaf6f811a2fb80ec3d10290dd146cd3f060ba758de8d96f"),
    FileSource("https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/M/METIS/METIS%405/bundled/patches/0002-mingw-w64-do-not-use-reserved-double-underscored-names.patch",
               "5b49cc2f2d35f35c5946bc24d1a3ac408a09e6763b7a3250a6db5256dfea8293"),
    FileSource("https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/M/METIS/METIS%405/bundled/patches/0003-WIN32-Install-RUNTIME-to-bin.patch",
               "643ff86b8c587f718b0ba45d8a7f9d0f45484d32f2bbf7832f9350363d0998bd"),
    FileSource("https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/M/METIS/METIS%405/bundled/patches/0004-Fix-GKLIB_PATH-default-for-out-of-tree-builds.patch",
               "7d5977fc16d29bb0dc584b974e2270acdf34125e5f8a474588a4ec6ed57f1c9a"),
    FileSource("https://raw.githubusercontent.com/JuliaPackaging/Yggdrasil/refs/heads/master/M/METIS/METIS%405/bundled/patches/005-add-ifndefs.patch",
               "714dbe001a50882779e528f6170eca36f14a92df969dea8b2fbeef57026685b7"),    
    # BLAS / LAPACK v3.12.1
    GitSource("https://github.com/Reference-LAPACK/lapack.git",
              "6ec7f2bc4ecf4c4a93496aa2fa519575bc0e39ca"),
    # OpenBLAS v0.3.31
    # ArchiveSource("https://github.com/OpenMathLib/OpenBLAS/releases/download/v0.3.31/OpenBLAS-0.3.31.tar.gz",
    #               "6dd2a63ac9d32643b7cc636eab57bf4e57d0ed1fff926dfbc5d3d97f2d2be3a6"),
    # MUMPS v5.8.2
    ArchiveSource("https://mumps-solver.org/MUMPS_5.8.2.tar.gz",
                  "eb515aa688e6dbab414bb6e889ff4c8b23f1691a843c68da5230a33ac4db7039"),
    # HiGHS v1.12.0
    GitSource("https://github.com/ERGO-Code/HiGHS.git",
              "755a8e027a99a8d4ecf153a8dde4b2a767cdf384"),
    # HiGHS v1.13.1
    # GitSource("https://github.com/ERGO-Code/HiGHS.git",
    #           "1d267d97c16928bb5f86fcb2cba2d20f94c8720c"),
    #
    # SPRAL v2025.9.18
    GitSource("https://github.com/ralna/spral.git",
              "e68988612dbd920323cee44c9cb8c6134847a990"),
    # Hwloc v2.13.0
    ArchiveSource("https://download.open-mpi.org/release/hwloc/v2.13/hwloc-2.13.0.tar.bz2",
                  "52e936afb6ebd80f171f763fcf14f7b1f5ce98b125af5dd2f328b873b1fd0dab"),
    # Package compiler for Windows
    ArchiveSource("https://github.com/JuliaLang/PackageCompiler.jl/releases/download/v1.0.0/x86_64-8.1.0-release-posix-seh-rt_v6-rev0.tar.gz",
                  "fe3f401bc936fbe6af940b26c5e0f266f762a3416f979c706e599b24082dc5c7"),
]

# Bash recipe for building across all platforms
script = raw"""
# Remove system CMake to use the jll version
apk del cmake

# Update Ninja
cp ${host_prefix}/bin/ninja /usr/bin/ninja

## ----- Compile METIS -----
cd $WORKSPACE/srcdir/METIS
if [ $target = "x86_64-w64-mingw32" ] || [ $target = "i686-w64-mingw32" ]; then
    atomic_patch -p1 $WORKSPACE/srcdir/0001-mingw-w64-does-not-have-sys-resource-h.patch
    atomic_patch -p1 $WORKSPACE/srcdir/0002-mingw-w64-do-not-use-reserved-double-underscored-names.patch
    atomic_patch -p1 $WORKSPACE/srcdir/0003-WIN32-Install-RUNTIME-to-bin.patch
    atomic_patch -p1 $WORKSPACE/srcdir/0004-Fix-GKLIB_PATH-default-for-out-of-tree-builds.patch
fi
atomic_patch -p1 $WORKSPACE/srcdir/005-add-ifndefs.patch
mkdir -p build
cd build
cmake .. \
    -DCMAKE_INSTALL_PREFIX=$prefix \
    -DCMAKE_TOOLCHAIN_FILE="${CMAKE_TARGET_TOOLCHAIN}" \
    -DCMAKE_VERBOSE_MAKEFILE=1 \
    -DGKLIB_PATH=$WORKSPACE/srcdir/METIS/GKlib \
    -DSHARED=0
make -j${nproc}
make install

## ----- Compile BLAS / LAPACK -----
cd $WORKSPACE/srcdir/lapack
mkdir build
cd build
cmake .. \
 -DCBLAS=ON \
 -DLAPACKE=OFF \
 -DCMAKE_INSTALL_PREFIX=${prefix} \
 -DCMAKE_TOOLCHAIN_FILE="${CMAKE_TARGET_TOOLCHAIN}" \
 -DCMAKE_BUILD_TYPE=Release \
 -DBUILD_SHARED_LIBS=OFF \
 -DBUILD_INDEX64_EXT_API=OFF \
 -DTEST_FORTRAN_COMPILER=OFF
make -j$(nproc)
make install

## ----- Compile OpenBLAS -----
# cd ${WORKSPACE}/srcdir/OpenBLAS*/

# # We always want threading
# flags=(USE_THREAD=1 GEMM_MULTITHREADING_THRESHOLD=400 NO_AFFINITY=1)
# if [[ "${CONSISTENT_FPCSR}" == "true" ]]; then
#     flags+=(CONSISTENT_FPCSR=1)
# fi

# # We are cross-compiling
# flags+=(CROSS=1 PREFIX=/ "CROSS_SUFFIX=${target}-")

# # We need to use our basic objconv, not a prefixed one:
# flags+=(OBJCONV=objconv)

# LIBPREFIX=libopenblas
# flags+=("LIBPREFIX=${LIBPREFIX}")

# # If we're building for x86_64 Windows gcc7+, we need to disable usage of
# # certain AVX-512 registers (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65782)
# if [[ ${target} == x86_64-w64-mingw32 ]] && [[ $(gcc --version | head -1 | awk '{ print $3 }') =~ (7|8).* ]]; then
#     CFLAGS="${CFLAGS} -fno-asynchronous-unwind-tables"
# fi

# # Because we use this OpenBLAS within Julia, and often want to bundle our
# # libgfortran and other friends alongside, we need an RPATH of '$ORIGIN',
# # so set it here.
# if [[ ${target} == *linux* ]] || [[ ${target} == *freebsd* ]]; then
#     export LDFLAGS="${LDFLAGS} '-Wl,-rpath,\$\$ORIGIN' -Wl,-z,origin"
# elif [[ ${target} == *apple* ]]; then
#     export LDFLAGS="${LDFLAGS} -Wl,-rpath,@loader_path/"
# fi

# # Choose our make parallelism.
# flags+=(-j${nproc})

# # The Makefile will otherwise override our choice
# export MAKE_NB_JOBS=0

# # Build the actual library
# make "${flags[@]}"

# # Install the library
# make "${flags[@]}" "PREFIX=$prefix" install

## ----- Compile MUMPS -----
cd $WORKSPACE/srcdir/MUMPS*

makefile="Makefile.G95.SEQ"
cp Make.inc/${makefile} Makefile.inc

# Add `-fallow-argument-mismatch` if supported
: >empty.f
FFLAGS=()
if gfortran -c -fallow-argument-mismatch empty.f >/dev/null 2>&1; then
    FFLAGS+=("-fallow-argument-mismatch")
fi
rm -f empty.*

make_args+=(OPTF="-fPIC -O3"
            OPTL="-fPIC -O3"
            OPTC="-fPIC -O3"
            CDEFS=-DAdd_
            LMETISDIR=${libdir}
            IMETIS=-I${includedir}
            LMETIS="-L${libdir} -lmetis"
            ORDERINGSF="-Dpord -Dmetis"
            CC="$CC ${CFLAGS[@]}"
            FC="gfortran ${FFLAGS[@]}"
            FL="gfortran"
            RANLIB="echo"
            LIBBLAS="-L${libdir} -lblas"
            LAPACK="-L${libdir} -llapack")

make -j${nproc} d "${make_args[@]}"
cp include/*.h ${includedir}
cp lib/*.a ${prefix}/lib

## ----- Compile Hwloc -----
cd $WORKSPACE/srcdir/hwloc-*
if [[ "${target}" == *-apple-darwin* ]]; then
    ./configure --prefix=${prefix} --build=${MACHTYPE} --host=${target} --disable-static --enable-shared
else
    ./configure --prefix=${prefix} --build=${MACHTYPE} --host=${target} --enable-static --disable-shared
fi
make -j${nproc}
make install

## ----- Compile SPRAL -----
cd $WORKSPACE/srcdir/spral

meson setup builddir --cross-file="${MESON_TARGET_TOOLCHAIN}" \
                     --prefix=$prefix \
                     -Ddefault_library=static \
                     -Dlibhwloc=hwloc \
                     -Dlibblas=blas \
                     -Dliblapack=lapack \
                     -Dtests=false \
                     -Dexamples=false

meson compile -C builddir
meson install -C builddir

## ----- Compile HiGHS -----
cd $WORKSPACE/srcdir/HiGHS
mkdir build
cd build
cmake .. \
    -DCMAKE_INSTALL_PREFIX=${prefix} \
    -DCMAKE_TOOLCHAIN_FILE=${CMAKE_TARGET_TOOLCHAIN} \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_SHARED_LIBS=OFF \
    -DZLIB=OFF \
    -DHIPO=ON \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DBUILD_CXX_EXE=OFF \
    -DMETIS_ROOT=${prefix} \
    -DBLAS_LIBRARIES=${prefix}/lib/libblas.a \
    -DCMAKE_POSITION_INDEPENDENT_CODE=ON

if [[ "${target}" == *-linux* ]]; then
        make -j ${nproc}
else
    if [[ "${target}" == *-mingw* ]]; then
        cmake --build . --config Release
    else
        cmake --build . --config Release --parallel
    fi
fi
make install

if [[ "${target}" == *-mingw* ]]; then
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libstdc++.a ${prefix}/lib/libstdc++.a
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libgfortran.a ${prefix}/lib/libgfortran.a
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libquadmath.a ${prefix}/lib/libquadmath.a
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libstdc++.a ${prefix}/lib/libgomp.a
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libstdc++.a ${prefix}/lib/libgcc.a
    cp $WORKSPACE/srcdir/mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libstdc++.a ${prefix}/lib/libgcc_eh.a
fi

# Clean
rm -r ${prefix}/bin
rm ${prefix}/lib/libsmumps.a

# Compile some shared libraries for Windows
if [ $target = "x86_64-w64-mingw32" ] || [ $target = "i686-w64-mingw32" ]; then
    ## METIS
    cd $WORKSPACE/srcdir/METIS
    mkdir -p build_shared
    cd build_shared
    cmake .. \
        -DCMAKE_INSTALL_PREFIX=$prefix \
        -DCMAKE_TOOLCHAIN_FILE="${CMAKE_TARGET_TOOLCHAIN}" \
        -DCMAKE_VERBOSE_MAKEFILE=1 \
        -DGKLIB_PATH=$WORKSPACE/srcdir/METIS/GKlib \
        -DSHARED=1
    make -j${nproc}
    make install
fi
"""

# These are the platforms we will build for by default, unless further
# platforms are passed in on the command line
platforms = supported_platforms()
platforms = expand_gfortran_versions(platforms)

# The products that we will ensure are always built
products = [
    FileProduct("lib/libmetis.a", :libmetis_a),
    FileProduct("lib/libblas.a", :libblas_a),
    FileProduct("lib/libcblas.a", :libcblas_a),
    FileProduct("lib/liblapack.a", :liblapack_a),
    # FileProduct("lib/libopenblas.a", :libopenblas_a),
    FileProduct("lib/libpord.a", :libpord_a),
    FileProduct("lib/libmpiseq.a", :libmpiseq_a),
    FileProduct("lib/libmumps_common.a", :libmumps_common_a),
    FileProduct("lib/libdmumps.a", :libdmumps_a),
    FileProduct("lib/libhighs.a", :libhighs_a),
    FileProduct("lib/libspral.a", :libspral_a),
    # FileProduct("lib/libhwloc.a", :libhwloc_a),
]

# Dependencies that must be installed before this package can be built
dependencies = [
    HostBuildDependency(PackageSpec(name="Ninja_jll", uuid="76642167-d241-5cee-8c94-7a494e8cb7b7")),
    HostBuildDependency(PackageSpec(name="CMake_jll", uuid="3f4e10e2-61f2-5801-8945-23b9d642d0e6")),
    Dependency(PackageSpec(name="LLVMOpenMP_jll", uuid="1d63c593-3942-5779-bab2-d838dc0a180e"); platforms=filter(Sys.isbsd, platforms)),
]

build_tarballs(
    ARGS,
    name,
    version,
    sources,
    script,
    platforms,
    products,
    dependencies;
    julia_compat = "1.6",
    preferred_gcc_version = v"10.2.0",
    clang_use_lld=false,
)

# Copyright (c) 2013: Iain Dunning, Miles Lubin, and contributors
# 2025: Adapted for UnoSolver.jl by Alexis Montoison and Charlie Vanaret
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMOIWrapper

using UnoSolver
using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_MOI_Test()
    model = MOI.instantiate(
        UnoSolver.Optimizer;
        with_cache_type = Float64,
        with_bridge_type = Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            atol = 1e-4,
            rtol = 1e-4,
            infeasible_status = MOI.LOCALLY_INFEASIBLE,
            optimal_status = MOI.LOCALLY_SOLVED,
            exclude = Any[
                MOI.ConstraintBasisStatus,
                MOI.DualObjectiveValue,
                MOI.ObjectiveBound,
            ],
        );
        exclude = [
            # TODO(odow): this seems like a MOI.supports bug
            r"^test_model_ModelFilter_AbstractConstraintAttribute$",
            # These tests hit IterationLimit instead of solving.
            r"^test_constraint_qcp_duplicate_off_diagonal$",
            r"^test_quadratic_constraint_GreaterThan$",
            r"^test_quadratic_constraint_LessThan$",
            r"^test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_Interval_upper$",
            # These tests hit LocallyInfeasible instead of solving
            r"^test_quadratic_SecondOrderCone_basic$",
            r"^test_quadratic_nonconvex_constraint_basic$",
        ],
    )
    return
end

function test_Name()
    model = UnoSolver.Optimizer()
    @test MOI.supports(model, MOI.Name())
    @test MOI.get(model, MOI.Name()) == ""
    MOI.set(model, MOI.Name(), "Model")
    @test MOI.get(model, MOI.Name()) == "Model"
    return
end

function test_ConstraintDualStart()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 2)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
        MOI.LessThan(1.5),
    )
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
    @test MOI.supports(model, MOI.NLPBlockDualStart())
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    @test MOI.get(model, MOI.NLPBlockDualStart()) === nothing
    MOI.set(model, MOI.ConstraintDualStart(), c, 2.0)
    MOI.set(model, MOI.NLPBlockDualStart(), [1.0, 2.0])
    @test MOI.get(model, MOI.ConstraintDualStart(), c) == 2.0
    @test MOI.get(model, MOI.NLPBlockDualStart()) == [1.0, 2.0]
    MOI.set(model, MOI.ConstraintDualStart(), c, nothing)
    MOI.set(model, MOI.NLPBlockDualStart(), nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    @test MOI.get(model, MOI.NLPBlockDualStart()) === nothing
    return
end

function test_ConstraintDualStart_ScalarNonlinearFunction()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.Interval(0.0, 0.8))
    f = MOI.ScalarNonlinearFunction(:sin, Any[1.0*x[1]-1.0*x[2]])
    c = MOI.add_constraint(model, f, MOI.EqualTo(0.5))
    g = 1.0 * x[1] + 1.0 * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(g)}(), g)
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    MOI.set(model, MOI.ConstraintDualStart(), c, 1.15)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === 1.15
    MOI.set(model, MOI.ConstraintDualStart(), c, nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    return
end

function test_solve_time()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    MOI.add_variable(model)
    @test isnan(MOI.get(model, MOI.SolveTimeSec()))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.SolveTimeSec()) >= 0.0
    return
end

function test_barrier_iterations()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    f = (x - 1.0)^2 + 2.0 * x + 3.0
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.add_constraint(model, 1.0 * x, MOI.LessThan(0.5))
    @test MOI.get(model, MOI.BarrierIterations()) == 0
    MOI.optimize!(model)
    @test MOI.get(model, MOI.BarrierIterations()) > 0
    return
end

# Model structure for test_check_derivatives_for_naninf()
struct Issue136 <: MOI.AbstractNLPEvaluator end
MOI.initialize(::Issue136, ::Vector{Symbol}) = nothing
MOI.features_available(::Issue136) = [:Grad, :Jac]
MOI.eval_objective(::Issue136, x) = x[1]
MOI.eval_constraint(::Issue136, g, x) = (g[1] = x[1]^(1 / 3))
MOI.eval_objective_gradient(::Issue136, grad_f, x) = (grad_f[1] = 1.0)
MOI.jacobian_structure(::Issue136) = Tuple{Int64,Int64}[(1, 1)]
function MOI.eval_constraint_jacobian(::Issue136, J, x)
    J[1] = (1 / 3) * x[1]^(1 / 3 - 1)
    return
end

function test_empty_optimize()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    @test MOI.get(model, MOI.RawStatusString()) == "Optimize not called"
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INVALID_MODEL
    @test MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.RawStatusString()) == "The model has no variable"
    return
end

"""
    test_get_model()

Test various getters for ConstraintFunction etc. We need this test because the
normal MOI ones require the solver to support VariableName and ConstraintName.
"""
function test_get_model()
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: w, x, y, z
        minobjective: 1.0 * x * x + 2.0 * y + 3.0
        w in Interval(-1.0, 1.0)
        x >= 1.0
        y <= 2.0
        z == 3.0
        1.0 * x >= 1.0
        2.0 * y <= 4.0
        3.0 * z == 9.0
        4.0 * w in Interval(-10.1, 11.1)
        1.0 * x * x + x >= 1.0
        2.0 * y * y + y <= 8.0
        3.0 * z * z + z == 27.0
        """,
    )
    uno = UnoSolver.Optimizer()
    index_map = MOI.copy_to(uno, model)
    attr = MOI.ListOfConstraintTypesPresent()
    @test sort(MOI.get(model, attr); by = string) ==
          sort(MOI.get(uno, attr); by = string)
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        cis = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        @test length(cis) == 1
        f_model = MOI.get(model, MOI.ConstraintFunction(), cis[1])
        s_model = MOI.get(model, MOI.ConstraintSet(), cis[1])
        cis = MOI.get(uno, MOI.ListOfConstraintIndices{F,S}())
        @test length(cis) == MOI.get(uno, MOI.NumberOfConstraints{F,S}()) == 1
        f_uno = MOI.get(uno, MOI.ConstraintFunction(), cis[1])
        s_uno = MOI.get(uno, MOI.ConstraintSet(), cis[1])
        @test s_model == s_uno
        if F == MOI.VariableIndex
            @test index_map[f_model] == f_uno
        else
            @test ≈(
                MOI.Utilities.substitute_variables(x -> index_map[x], f_model),
                f_uno,
            )
        end
    end
    F_model = MOI.get(model, MOI.ObjectiveFunctionType())
    F_uno = MOI.get(uno, MOI.ObjectiveFunctionType())
    @test F_model == F_uno
    obj_model = MOI.get(model, MOI.ObjectiveFunction{F_model}())
    obj_uno = MOI.get(uno, MOI.ObjectiveFunction{F_uno}())
    @test ≈(
        MOI.Utilities.substitute_variables(x -> index_map[x], obj_model),
        obj_uno,
    )
    return
end

function test_parameter_number_of_variables()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    return
end

function test_parameter_is_valid()
    model = UnoSolver.Optimizer()
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.is_valid(model, p)
    @test MOI.is_valid(model, ci)
    @test !MOI.is_valid(model, typeof(p)(p.value + 1))
    @test !MOI.is_valid(model, typeof(ci)(ci.value + 1))
    return
end

function test_parameter_list_of_variable_indices()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [x, p]
    # Now reversed
    model = UnoSolver.Optimizer()
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [p, x]
    return
end

function test_scalar_nonlinear_function_is_valid()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    F, S = MOI.ScalarNonlinearFunction, MOI.EqualTo{Float64}
    @test MOI.is_valid(model, MOI.ConstraintIndex{F,S}(1)) == false
    f = MOI.ScalarNonlinearFunction(:sin, Any[x])
    c = MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    @test c isa MOI.ConstraintIndex{F,S}
    @test MOI.is_valid(model, c) == true
    return
end

function test_scalar_nonlinear_function_nlp_block()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:^, Any[x, 4])
    MOI.add_constraint(model, f, MOI.LessThan(1.0))
    MOI.optimize!(model)
    block = MOI.get(model, MOI.NLPBlock())
    @test !block.has_objective
    @test block.evaluator isa MOI.Nonlinear.Evaluator
    return
end

function test_parameter()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    x = MOI.add_variable(model)
    fi = MOI.ScalarNonlinearFunction(:-, Any[x, p])
    f = MOI.ScalarNonlinearFunction(:^, Any[fi, 2])
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [p, x]
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 1
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1
    MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(-2.5))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ -2.5
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ -2.5
    return
end

function test_parameter_replace_parameters()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    x = MOI.add_variable(model)
    t = MOI.add_variable(model)
    lhs = MOI.ScalarNonlinearFunction(
        :+,
        Any[
            x,
            p,
            1.0*x,
            1.0*p,
            1.0*x*x,
            1.0*p*x,
            MOI.ScalarNonlinearFunction(:^, Any[1.0*x-p, 2]),
        ],
    )
    f = MOI.ScalarNonlinearFunction(:-, Any[lhs, t])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(t)}(), t)
    MOI.add_constraint(model, f, MOI.LessThan(0.0))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 1.0
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ -0.25
    return
end

function test_parameter_reverse()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    fi = MOI.ScalarNonlinearFunction(:-, Any[x, p])
    f = MOI.ScalarNonlinearFunction(:^, Any[fi, 2])
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [x, p]
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 1
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1
    MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(-2.5))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ -2.5
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ -2.5
    return
end

function test_parameter_scalar_affine_objective()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    # f = (x - p)^2 + x + p + 1.0
    f = (1.0 * x - 1.0 * p) * (1.0 * x - 1.0 * p) + x + p + 1.0
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1.5
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 2.0
    @test MOI.get(model, MOI.ObjectiveValue()) ≈ (1.5 - 2.0)^2 + 4.5
    MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(2.2))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1.7
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 2.2
    @test MOI.get(model, MOI.ObjectiveValue()) ≈ (1.7 - 2.2)^2 + 4.9
    MOI.add_constraint(model, x, MOI.LessThan(1.5))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1.5
    @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 2.2
    @test MOI.get(model, MOI.ObjectiveValue()) ≈ (1.5 - 2.2)^2 + 4.7
    return
end

# Uno is dead-lock in this test!
# function test_parameter_variable_index_objective()
#     model = UnoSolver.Optimizer()
#     MOI.set(model, MOI.Silent(), true)
#     x = MOI.add_variable(model)
#     p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
#     t = MOI.add_variable(model)
#     MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
#     MOI.set(model, MOI.ObjectiveFunction{typeof(t)}(), t)
#     # f = (x - p)^2 + x + p + 1.0
#     f = (1.0 * x - 1.0 * p) * (1.0 * x - 1.0 * p) + x + p + 1.0
#     MOI.add_constraint(model, f - t, MOI.LessThan(0.0))
#     MOI.optimize!(model)
#     @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1.5
#     @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 2.0
#     @test MOI.get(model, MOI.ObjectiveValue()) ≈ (1.5 - 2.0)^2 + 4.5
#     MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(2.2))
#     MOI.optimize!(model)
#     @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 1.7
#     @test MOI.get(model, MOI.VariablePrimal(), p) ≈ 2.2
#     @test MOI.get(model, MOI.ObjectiveValue()) ≈ (1.7 - 2.2)^2 + 4.9
#     return
# end

function test_ListOfSupportedNonlinearOperators()
    model = UnoSolver.Optimizer()
    ops = MOI.get(model, MOI.ListOfSupportedNonlinearOperators())
    @test ops isa Vector{Symbol}
    @test :|| in ops
    @test :ifelse in ops
    @test :sin in ops
    @test !(:f in ops)
    f(x) = x^2
    MOI.set(model, MOI.UserDefinedFunction(:f, 1), (f,))
    @test :f in MOI.get(model, MOI.ListOfSupportedNonlinearOperators())
    return
end

function test_ad_backend()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    attr = MOI.AutomaticDifferentiationBackend()
    @test MOI.supports(model, attr)
    @test MOI.get(model, attr) == MOI.Nonlinear.SparseReverseMode()
    MOI.optimize!(model)
    @test model.inner isa UnoSolver.Model
    MOI.set(model, attr, MOI.Nonlinear.ExprGraphOnly())
    @test MOI.get(model, attr) == MOI.Nonlinear.ExprGraphOnly()
    @test model.inner === nothing
    f = MOI.ScalarNonlinearFunction(:^, Any[x, 4])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test_throws ErrorException MOI.optimize!(model)
    return
end

function test_mixing_new_old_api()
    # new then old
    model = UnoSolver.Optimizer()
    MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    bounds = MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0])
    block_data = MOI.NLPBlockData(bounds, MOI.Test.HS071(true), true)
    err = ErrorException("Cannot mix the new and legacy nonlinear APIs")
    @test_throws err MOI.set(model, MOI.NLPBlock(), block_data)
    # old then new
    model = UnoSolver.Optimizer()
    bounds = MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0])
    block_data = MOI.NLPBlockData(bounds, MOI.Test.HS071(true), true)
    MOI.set(model, MOI.NLPBlock(), block_data)
    err = ErrorException("Cannot mix the new and legacy nonlinear APIs")
    @test_throws err MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    return
end

function test_nlp_model_objective_function_type()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:sqrt, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    @test F == MOI.ScalarNonlinearFunction
    return
end

function test_nlp_model_set_set()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:sqrt, Any[x])
    c = MOI.add_constraint(model, f, MOI.LessThan(2.0))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.LessThan(2.0)
    MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(3.0))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.LessThan(3.0)
    return
end

function test_VariablePrimalStart()
    attr = MOI.VariablePrimalStart()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    @test MOI.supports(model, attr, typeof(x))
    @test MOI.get(model, attr, x) === nothing
    MOI.set(model, attr, x, 1.0)
    @test MOI.get(model, attr, x) == 1.0
    p, _ = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    @test_throws(
        MOI.GetAttributeNotAllowed{typeof(attr)},
        MOI.get(model, attr, p),
    )
    @test_throws(
        MOI.SetAttributeNotAllowed{typeof(attr)},
        MOI.set(model, attr, p, 1.0),
    )
    return
end

function test_RawOptimizerAttribute()
    model = UnoSolver.Optimizer()
    attr = MOI.RawOptimizerAttribute("print_solution")
    @test_throws MOI.GetAttributeNotAllowed{typeof(attr)} MOI.get(model, attr)
    @test MOI.supports(model, attr)
    MOI.set(model, attr, 0)
    @test MOI.get(model, attr) == 0
    return
end

function test_empty_nlp_evaluator()
    model = UnoSolver.Optimizer()
    block = MOI.get(model, MOI.NLPBlock())
    evaluator = block.evaluator
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :JacVec, :HessVec]
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess, :JacVec, :HessVec])
    x = Float64[]
    @test MOI.eval_constraint(evaluator, Float64[], x) === nothing
    @test MOI.jacobian_structure(evaluator) == Tuple{Int,Int}[]
    @test MOI.hessian_lagrangian_structure(evaluator) == Tuple{Int,Int}[]
    @test MOI.eval_constraint_jacobian(evaluator, Float64[], x) === nothing
    H, mu = Float64[], Float64[]
    @test MOI.eval_hessian_lagrangian(evaluator, H, x, 1.0, mu) === nothing
    return
end

function test_NLPBlockDualStart()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 4)
    MOI.set.(model, MOI.VariablePrimalStart(), x, 1.0)
    block = MOI.NLPBlockData(
        MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0]),
        MOI.Test.HS071(false),
        true,
    )
    MOI.set(model, MOI.NLPBlock(), block)
    MOI.set(model, MOI.NLPBlockDualStart(), [1.0, -1.0])
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.NLPBlockDual()), [0.0, 0.0]; atol = 1e-6)
    return
end

function test_function_type_to_func()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == MOI.VariableIndex
    return
end

function test_error_adding_option()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    name, value = "print_solution", :yes
    MOI.set(model, MOI.RawOptimizerAttribute(name), value)
    @test_throws(
        ErrorException(
            "Unable to add option `\"$name\"` with the value " *
            "`$value::$(typeof(value))`. The value must be a `::String`, a `::Float64`, an `::Integer`, or a `::Bool`.",
        ),
        MOI.optimize!(model),
    )
    return
end

function test_scalar_nonlinear_function_attributes()
    model = UnoSolver.Optimizer()
    x = MOI.add_variable(model)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{Float64}
    @test isempty(MOI.get(model, MOI.ListOfConstraintTypesPresent()))
    @test isempty(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    c = MOI.add_constraint(model, f, MOI.LessThan(1.0))
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c]
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    return
end

function test_vector_nonlinear_oracle()
    set = MOI.VectorNonlinearOracle(;
        dimension = 5,
        l = [0.0, 0.0],
        u = [0.0, 0.0],
        eval_f = (ret, x) -> begin
            sleep(0.5)  # to make timing test more robust
            @test length(ret) == 2
            @test length(x) == 5
            ret[1] = x[1]^2 - x[4]
            ret[2] = x[2]^2 + x[3]^3 - x[5]
            return
        end,
        jacobian_structure = [(1, 1), (2, 2), (2, 3), (1, 4), (2, 5)],
        eval_jacobian = (ret, x) -> begin
            sleep(0.5)  # to make timing test more robust
            @test length(ret) == 5
            @test length(x) == 5
            ret[1] = 2 * x[1]
            ret[2] = 2 * x[2]
            ret[3] = 3 * x[3]^2
            ret[4] = -1.0
            ret[5] = -1.0
            return
        end,
        hessian_lagrangian_structure = [(1, 1), (2, 2), (3, 3)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            sleep(1.0)  # to make timing test more robust
            @test length(ret) == 3
            @test length(x) == 5
            @test length(u) == 2
            ret[1] = 2 * u[1]
            ret[2] = 2 * u[2]
            ret[3] = 6 * x[3] * u[2]
            return
        end,
    )
    @test occursin("VectorNonlinearOracle{Float64}(;", sprint(show, set))
    @test MOI.dimension(set) == 5
    @test MOI.copy(set) == set
    @test MOI.copy(set) !== set
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 3)
    MOI.add_constraints.(model, x, MOI.EqualTo.(1.0:3.0))
    y = MOI.add_variables(model, 2)
    MOI.optimize!(model)
    f = MOI.VectorOfVariables([x; y])
    F, S = MOI.VectorOfVariables, MOI.VectorNonlinearOracle{Float64}
    @test MOI.supports_constraint(model, F, S)
    @test !((F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent()))
    @test isempty(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
    @test model.inner !== nothing
    c = MOI.add_constraint(model, f, set)
    @test model.inner === nothing
    @test MOI.is_valid(model, c)
    @test !MOI.is_valid(model, typeof(c)(c.value - 1))
    @test !MOI.is_valid(model, typeof(c)(c.value + 1))
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c]
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    MOI.optimize!(model)
    x_v = MOI.get.(model, MOI.VariablePrimal(), x)
    y_v = MOI.get.(model, MOI.VariablePrimal(), y)
    @test isapprox(y_v, [x_v[1]^2, x_v[2]^2 + x_v[3]^3], atol = 1e-5)
    @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ [x_v; y_v]
    @test MOI.get(model, MOI.ConstraintDual(), c) ≈ zeros(5)
    # Test timers with plenty of buffer to avoid a flakey test
    for (_, cache) in model.vector_nonlinear_oracle_constraints
        @test 0.9 < cache.eval_f_timer < 3
        @test 0.9 < cache.eval_jacobian_timer < 5
        @test 0.9 < cache.eval_hessian_lagrangian_timer < 5
    end
    # Test that optimize! resets the timers. Upper bounds are chosen such that
    # they're violated if times from both solves were added together.
    MOI.optimize!(model)
    for (_, cache) in model.vector_nonlinear_oracle_constraints
        @test 0.9 < cache.eval_f_timer < 3
        @test 0.9 < cache.eval_jacobian_timer < 5
        @test 0.9 < cache.eval_hessian_lagrangian_timer < 5
    end
    MOI.set(model, MOI.RawOptimizerAttribute("max_iterations"), 0)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.INFEASIBLE_POINT
    return
end

function test_vector_nonlinear_oracle_two()
    set = MOI.VectorNonlinearOracle(;
        dimension = 5,
        l = [0.0, 0.0],
        u = [0.0, 0.0],
        eval_f = (ret, x) -> begin
            ret[1] = x[1]^2 - x[4]
            ret[2] = x[2]^2 + x[3]^3 - x[5]
            return
        end,
        jacobian_structure = [(1, 1), (2, 2), (2, 3), (1, 4), (2, 5)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = 2 * x[1]
            ret[2] = 2 * x[2]
            ret[3] = 3 * x[3]^2
            ret[4] = -1.0
            ret[5] = -1.0
            return
        end,
        hessian_lagrangian_structure = [(1, 1), (2, 2), (3, 3)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            ret[1] = 2 * u[1]
            ret[2] = 2 * u[2]
            ret[3] = 6 * x[3] * u[2]
            return
        end,
    )
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 3)
    MOI.add_constraints.(model, x, MOI.EqualTo.(1.0:3.0))
    y = MOI.add_variables(model, 2)
    z = MOI.add_variables(model, 2)
    MOI.optimize!(model)
    f_y = MOI.VectorOfVariables([x; y])
    c_y = MOI.add_constraint(model, f_y, set)
    f_z = MOI.VectorOfVariables([reverse(x); z])
    c_z = MOI.add_constraint(model, f_z, set)
    @test MOI.is_valid(model, c_y)
    @test MOI.is_valid(model, c_z)
    F, S = MOI.VectorOfVariables, MOI.VectorNonlinearOracle{Float64}
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c_y, c_z]
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 2
    MOI.optimize!(model)
    x_v = MOI.get.(model, MOI.VariablePrimal(), x)
    y_v = MOI.get.(model, MOI.VariablePrimal(), y)
    z_v = MOI.get.(model, MOI.VariablePrimal(), z)
    @test isapprox(y_v, [x_v[1]^2, x_v[2]^2 + x_v[3]^3], atol = 1e-5)
    @test isapprox(z_v, [x_v[3]^2, x_v[2]^2 + x_v[1]^3], atol = 1e-5)
    @test MOI.get(model, MOI.ConstraintPrimal(), c_y) ≈ [x_v; y_v]
    @test MOI.get(model, MOI.ConstraintPrimal(), c_z) ≈ [reverse(x_v); z_v]
    @test MOI.get(model, MOI.ConstraintDual(), c_y) ≈ zeros(5)
    @test MOI.get(model, MOI.ConstraintDual(), c_z) ≈ zeros(5)
    return
end

function test_vector_nonlinear_oracle_optimization()
    set = MOI.VectorNonlinearOracle(;
        dimension = 4,
        l = [0.0, 0.0],
        u = [0.0, 0.0],
        eval_f = (ret, x) -> begin
            ret[1] = x[1]^2 + x[2]^2 - x[3]
            ret[2] = x[2] - x[1] - x[4]
            return
        end,
        jacobian_structure = [(1, 1), (1, 2), (2, 2), (2, 1), (1, 3), (2, 4)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = 2 * x[1]
            ret[2] = 2 * x[2]
            ret[3] = 1.0
            ret[4] = -1.0
            ret[5] = -1.0
            ret[6] = -1.0
            return
        end,
        hessian_lagrangian_structure = [(1, 1), (2, 2)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            ret[1] = 2 * u[1]
            ret[2] = 2 * u[1]
            return
        end,
    )
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 4)
    t = MOI.add_variable(model)
    MOI.add_constraint(model, x[1], MOI.GreaterThan(0.1))
    c_x3 = MOI.add_constraint(model, x[3], MOI.LessThan(1.0))
    c_x4 = MOI.add_constraint(model, x[4], MOI.GreaterThan(0.0))
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, set)
    log_x = MOI.ScalarNonlinearFunction(:log, Any[x[1]])
    log_x_minus_t = MOI.ScalarNonlinearFunction(:-, Any[log_x, t])
    c_snf = MOI.add_constraint(model, log_x_minus_t, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    F = MOI.ScalarAffineFunction{Float64}
    MOI.set(model, MOI.ObjectiveFunction{F}(), 1.0 * t)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    atol = 1e-3
    x_sol = MOI.get.(model, MOI.VariablePrimal(), x)
    @test ≈(x_sol, [1 / sqrt(2), 1 / sqrt(2), 1.0, 0.0]; atol)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), t), -log(sqrt(2)); atol)
    c_sol = MOI.get(model, MOI.ConstraintPrimal(), c)
    @test ≈(c_sol, [1 / sqrt(2), 1 / sqrt(2), 1.0, 0.0]; atol)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test ≈(c_dual, [-sqrt(2), 0.0, 0.5, -1 / sqrt(2)]; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x3), -0.5; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x4), 1 / sqrt(2); atol)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c_snf), 0.0; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_snf), 1.0; atol)
    return
end

function test_vector_nonlinear_oracle_optimization_min_sense()
    set = MOI.VectorNonlinearOracle(;
        dimension = 4,
        l = [0.0, 0.0],
        u = [0.0, 0.0],
        eval_f = (ret, x) -> begin
            ret[1] = x[1]^2 + x[2]^2 - x[3]
            ret[2] = x[2] - x[1] - x[4]
            return
        end,
        jacobian_structure = [(1, 1), (1, 2), (2, 2), (2, 1), (1, 3), (2, 4)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = 2 * x[1]
            ret[2] = 2 * x[2]
            ret[3] = 1.0
            ret[4] = -1.0
            ret[5] = -1.0
            ret[6] = -1.0
            return
        end,
        hessian_lagrangian_structure = [(1, 1), (2, 2)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            ret[1] = 2 * u[1]
            ret[2] = 2 * u[1]
            return
        end,
    )
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 4)
    t = MOI.add_variable(model)
    MOI.add_constraint(model, x[1], MOI.GreaterThan(0.1))
    c_x3 = MOI.add_constraint(model, x[3], MOI.LessThan(1.0))
    c_x4 = MOI.add_constraint(model, x[4], MOI.GreaterThan(0.0))
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, set)
    MOI.supports(model, MOI.LagrangeMultiplierStart(), typeof(c))
    @test MOI.get(model, MOI.LagrangeMultiplierStart(), c) === nothing
    MOI.set(model, MOI.LagrangeMultiplierStart(), c, [-0.5, 0.7])
    @test MOI.get(model, MOI.LagrangeMultiplierStart(), c) == [-0.5, 0.7]
    log_x = MOI.ScalarNonlinearFunction(:log, Any[x[1]])
    log_x_minus_t = MOI.ScalarNonlinearFunction(:-, Any[log_x, t])
    c_snf = MOI.add_constraint(model, log_x_minus_t, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ConstraintDualStart(), c_snf, 1.0)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    F = MOI.ScalarAffineFunction{Float64}
    MOI.set(model, MOI.ObjectiveFunction{F}(), -1.0 * t)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    atol = 1e-3
    x_sol = MOI.get.(model, MOI.VariablePrimal(), x)
    @test ≈(x_sol, [1 / sqrt(2), 1 / sqrt(2), 1.0, 0.0]; atol)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), t), -log(sqrt(2)); atol)
    c_sol = MOI.get(model, MOI.ConstraintPrimal(), c)
    @test ≈(c_sol, [1 / sqrt(2), 1 / sqrt(2), 1.0, 0.0]; atol)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test ≈(c_dual, [-sqrt(2), 0.0, 0.5, -1 / sqrt(2)]; atol)
    c_lambda = MOI.get(model, MOI.LagrangeMultiplier(), c)
    @test ≈(c_lambda, [-0.5, 1 / sqrt(2)]; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x3), -0.5; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x4), 1 / sqrt(2); atol)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c_snf), 0.0; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_snf), 1.0; atol)
    MOI.set(model, MOI.LagrangeMultiplierStart(), c, nothing)
    @test MOI.get(model, MOI.LagrangeMultiplierStart(), c) === nothing
    return
end

function test_vector_nonlinear_oracle_scalar_nonlinear_equivalent()
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 4)
    t = MOI.add_variable(model)
    MOI.add_constraint(model, x[1], MOI.GreaterThan(0.1))
    c_x3 = MOI.add_constraint(model, x[3], MOI.LessThan(1.0))
    c_x4 = MOI.add_constraint(model, x[4], MOI.GreaterThan(0.0))
    f1 = 1.0 * x[1] * x[1] + 1.0 * x[2] * x[2] - 1.0 * x[3]
    c1 = MOI.add_constraint(model, f1, MOI.EqualTo(0.0))
    f2 = 1.0 * x[2] - 1.0 * x[1] - x[4]
    c2 = MOI.add_constraint(model, f2, MOI.EqualTo(0.0))
    log_x = MOI.ScalarNonlinearFunction(:log, Any[x[1]])
    log_x_minus_t = MOI.ScalarNonlinearFunction(:-, Any[log_x, t])
    c_snf = MOI.add_constraint(model, log_x_minus_t, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    F = MOI.ScalarAffineFunction{Float64}
    MOI.set(model, MOI.ObjectiveFunction{F}(), 1.0 * t)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    atol = 1e-6
    x_sol = MOI.get.(model, MOI.VariablePrimal(), x)
    @test ≈(x_sol, [1 / sqrt(2), 1 / sqrt(2), 1.0, 0.0]; atol)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), t), -log(sqrt(2)); atol)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c1), 0.0; atol)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c2), 0.0; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c1), -0.5; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c2), 1 / sqrt(2); atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x3), -0.5; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_x4), 1 / sqrt(2); atol)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c_snf), 0.0; atol)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), c_snf), 1.0; atol)
    return
end

function test_vector_nonlinear_oracle_no_hessian()
    set = MOI.VectorNonlinearOracle(;
        dimension = 5,
        l = [0.0, 0.0],
        u = [0.0, 0.0],
        eval_f = (ret, x) -> begin
            ret[1] = x[1]^2 - x[4]
            ret[2] = x[2]^2 + x[3]^3 - x[5]
            return
        end,
        jacobian_structure = [(1, 1), (2, 2), (2, 3), (1, 4), (2, 5)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = 2 * x[1]
            ret[2] = 2 * x[2]
            ret[3] = 3 * x[3]^2
            ret[4] = -1.0
            ret[5] = -1.0
            return
        end,
    )
    model = UnoSolver.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 3)
    MOI.add_constraints.(model, x, MOI.EqualTo.(1.0:3.0))
    y = MOI.add_variables(model, 2)
    MOI.add_constraint(model, MOI.VectorOfVariables([x; y]), set)
    MOI.optimize!(model)
    x_v = MOI.get.(model, MOI.VariablePrimal(), x)
    y_v = MOI.get.(model, MOI.VariablePrimal(), y)
    @test isapprox(y_v, [x_v[1]^2, x_v[2]^2 + x_v[3]^3], atol = 1e-5)
    return
end

function test_issue_491()
    model = UnoSolver.Optimizer()
    x = MOI.add_variables(model, 2)
    g = [MOI.ScalarNonlinearFunction(:log, Any[x[i]]) for i in 1:2]
    c = MOI.add_constraint.(model, g, MOI.LessThan(1.0))
    MOI.set.(model, MOI.ConstraintDualStart(), c, 0.5)
    @test length(model.mult_g_nlp) == 2
    MOI.empty!(model)
    @test isempty(model.mult_g_nlp)
    return
end

function test_issue_491_model_example()
    model = MOI.instantiate(UnoSolver.Optimizer; with_cache_type = Float64)
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.Interval(1.0, 4.0))
    g = [MOI.ScalarNonlinearFunction(:log, Any[x[i]]) for i in 1:2]
    c = MOI.add_constraint.(model, g, MOI.LessThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = 1.0 * x[1] + 1.0 * x[2]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set.(model, MOI.ConstraintDualStart(), c, 0.5)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test ≈(MOI.get.(model, MOI.VariablePrimal(), x), exp.([1, 1]); atol = 1e-6)
    MOI.delete(model, c[1])
    MOI.set(model, MOI.ConstraintDualStart(), c[2], 0.5)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test ≈(MOI.get.(model, MOI.VariablePrimal(), x), [4, exp(1)]; atol = 1e-6)
    return
end

function test_default_objective_function()
    model = UnoSolver.Optimizer()
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    @test F == MOI.ScalarAffineFunction{Float64}
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    @test f ≈ zero(F)
    return
end

function test_comprehensive_duals_variable_bounds()
    model = MOI.instantiate(
        UnoSolver.Optimizer;
        with_cache_type = Float64,
        with_bridge_type = Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    v = MOI.add_variables(model, 4)
    w = MOI.add_constraint(model, v[1], MOI.GreaterThan(0.0))
    x = MOI.add_constraint(model, v[2], MOI.LessThan(0.0))
    y = MOI.add_constraint(model, v[3], MOI.EqualTo(0.0))
    z = MOI.add_constraint(model, v[4], MOI.Interval(0.0, 1.0))
    c = [w, x, y, z]
    a = [1.0, -2.0, 3.0, 4.0]
    tmp = MOI.add_variable(model)
    @testset "$con_f" for con_f in [
        nothing,
        1.0 * tmp,
        1.0 * tmp * tmp,
        MOI.ScalarNonlinearFunction(:exp, Any[tmp]),
    ]
        if con_f !== nothing
            MOI.add_constraint(model, con_f, MOI.LessThan(1.0))
        end
        @testset "$sense" for sense in (MOI.MIN_SENSE, MOI.MAX_SENSE)
            MOI.set(model, MOI.ObjectiveSense(), sense)
            f = (sense == MOI.MIN_SENSE ? 1 : -1) * a' * v
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            MOI.optimize!(model)
            @testset "$i" for i in 1:4
                @test MOI.get(model, MOI.ConstraintDual(), c[i]) == a[i]
            end
        end
    end
    return
end

function test_comprehensive_duals_scalar_affine()
    model = MOI.instantiate(
        UnoSolver.Optimizer;
        with_cache_type = Float64,
        with_bridge_type = Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    v = MOI.add_variables(model, 4)
    w = MOI.add_constraint(model, 1.0 * v[1], MOI.GreaterThan(0.0))
    x = MOI.add_constraint(model, 1.0 * v[2], MOI.LessThan(0.0))
    y = MOI.add_constraint(model, 1.0 * v[3], MOI.EqualTo(0.0))
    z = MOI.add_constraint(model, 1.0 * v[4], MOI.Interval(0.0, 1.0))
    c = [w, x, y, z]
    a = [1.0, -2.0, 3.0, 4.0]
    tmp = MOI.add_variable(model)
    @testset "$con_f" for con_f in [
        nothing,
        1.0 * tmp * tmp,
        MOI.ScalarNonlinearFunction(:exp, Any[tmp]),
    ]
        if con_f !== nothing
            MOI.add_constraint(model, con_f, MOI.LessThan(1.0))
        end
        @testset "$sense" for sense in (MOI.MIN_SENSE, MOI.MAX_SENSE)
            MOI.set(model, MOI.ObjectiveSense(), sense)
            f = (sense == MOI.MIN_SENSE ? 1 : -1) * a' * v
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            MOI.optimize!(model)
            @testset "$i" for i in 1:4
                @test MOI.get(model, MOI.ConstraintDual(), c[i]) == a[i]
            end
        end
    end
    return
end

function test_comprehensive_duals_scalar_nonlinear()
    model = MOI.instantiate(
        UnoSolver.Optimizer;
        with_cache_type = Float64,
        with_bridge_type = Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    v = MOI.add_variables(model, 4)
    f = [MOI.ScalarNonlinearFunction(:+, Any[vi, 1.0]) for vi in v]
    w = MOI.add_constraint(model, f[1], MOI.GreaterThan(0.0))
    x = MOI.add_constraint(model, f[2], MOI.LessThan(0.0))
    y = MOI.add_constraint(model, f[3], MOI.EqualTo(0.0))
    z = MOI.add_constraint(model, f[4], MOI.Interval(0.0, 1.0))
    c = [w, x, y, z]
    a = [1.0, -2.0, 3.0, 4.0]
    tmp = MOI.add_variable(model)
    @testset "$con_f" for con_f in [
        nothing,
        1.0 * tmp,
        1.0 * tmp * tmp,
        MOI.ScalarNonlinearFunction(:exp, Any[tmp]),
    ]
        if con_f !== nothing
            MOI.add_constraint(model, con_f, MOI.LessThan(1.0))
        end
        @testset "$sense" for sense in (MOI.MIN_SENSE, MOI.MAX_SENSE)
            MOI.set(model, MOI.ObjectiveSense(), sense)
            f = (sense == MOI.MIN_SENSE ? 1 : -1) * a' * v
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            MOI.optimize!(model)
            @testset "$i" for i in 1:4
                @test MOI.get(model, MOI.ConstraintDual(), c[i]) == a[i]
            end
        end
    end
    return
end

function test_Parameter_basic()
    F, S = MOI.VariableIndex, MOI.Parameter{Float64}
    model = UnoSolver.Optimizer()
    @test MOI.supports_add_constrained_variable(model, S)
    @test !MOI.supports_constraint(model, F, S)
    @test isempty(MOI.get(model, MOI.ListOfConstraintTypesPresent()))
    p1, c1 = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    @test MOI.is_valid(model, c1)
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c1]
    p2, c2 = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 2
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c1, c2]
    return
end

end  # module TestMOIWrapper

TestMOIWrapper.runtests()

# hs71
# min x1 * x4 * (x1 + x2 + x3) + x3
# st  x1 * x2 * x3 * x4 >= 25
#     x1^2 + x2^2 + x3^2 + x4^2 = 40
#     1 <= x1, x2, x3, x4 <= 5
# Start at (1, 5, 5, 1)
# End at (1.000..., 4.743..., 3.821..., 1.379...)

function c_objective_hs71(userdata::Nothing, x::Vector{Float64})
  f = x[1] * x[4] * (x[1] + x[2] + x[3]) + x[3]
  return f
end

function c_constraints_hs71(userdata::Nothing, c::Vector{Float64}, x::Vector{Float64})
  c[1] = x[1] * x[2] * x[3] * x[4]
  c[2] = x[1]^2 + x[2]^2 + x[3]^2 + x[4]^2
  return c
end

function c_objective_gradient_hs71(userdata::Nothing, g::Vector{Float64}, x::Vector{Float64})
  g[1] = x[1] * x[4] + x[4] * (x[1] + x[2] + x[3])
  g[2] = x[1] * x[4]
  g[3] = x[1] * x[4] + 1
  g[4] = x[1] * (x[1] + x[2] + x[3])
  return g
end

function c_jacobian_hs71(userdata::Nothing, jvals::Vector{Float64}, x::Vector{Float64})
  # Constraint (row) 1
  jvals[1] = x[2] * x[3] * x[4]  # 1,1
  jvals[2] = x[1] * x[3] * x[4]  # 1,2
  jvals[3] = x[1] * x[2] * x[4]  # 1,3
  jvals[4] = x[1] * x[2] * x[3]  # 1,4
  # Constraint (row) 2
  jvals[5] = 2 * x[1]  # 2,1
  jvals[6] = 2 * x[2]  # 2,2
  jvals[7] = 2 * x[3]  # 2,3
  jvals[8] = 2 * x[4]  # 2,4
  return jvals
end

function c_lagrangian_hessian_hs71(
  userdata::Nothing,
  hvals::Vector{Float64},
  x::Vector{Float64},
  multipliers::Vector{Float64},
  objective_multiplier::Float64,
)
  # Only store the lower triangle part of the Hessian of the Lagrangian
  # Objective
  hvals[1] = objective_multiplier * (2 * x[4])                # 1,1
  hvals[2] = objective_multiplier * (x[4])                    # 2,1
  hvals[3] = 0                                                # 2,2
  hvals[4] = objective_multiplier * (x[4])                    # 3,1
  hvals[5] = 0                                                # 3,2
  hvals[6] = 0                                                # 3,3
  hvals[7] = objective_multiplier * (2 * x[1] + x[2] + x[3])  # 4,1
  hvals[8] = objective_multiplier * (x[1])                    # 4,2
  hvals[9] = objective_multiplier * (x[1])                    # 4,3
  hvals[10] = 0                                               # 4,4

  # First constraint
  hvals[2] += multipliers[1] * (x[3] * x[4])  # 2,1
  hvals[4] += multipliers[1] * (x[2] * x[4])  # 3,1
  hvals[5] += multipliers[1] * (x[1] * x[4])  # 3,2
  hvals[7] += multipliers[1] * (x[2] * x[3])  # 4,1
  hvals[8] += multipliers[1] * (x[1] * x[3])  # 4,2
  hvals[9] += multipliers[1] * (x[1] * x[2])  # 4,3

  # Second constraint
  hvals[1]  += multipliers[2] * 2  # 1,1
  hvals[3]  += multipliers[2] * 2  # 2,2
  hvals[6]  += multipliers[2] * 2  # 3,3
  hvals[10] += multipliers[2] * 2  # 4,4
  return hvals
end

function c_jacobian_operator_hs71(
  userdata::Nothing,
  Jv::Vector{Float64},
  x::Vector{Float64},
  v::Vector{Float64},
  evaluate_at_x::Bool,
)
  Jv[1] = (x[2] * x[3] * x[4]) * v[1] + (x[1] * x[3] * x[4]) * v[2] + (x[1] * x[2] * x[4]) * v[3] + (x[1] * x[2] * x[3]) * v[4]
  Jv[2] = 2 * (x[1] * v[1] + x[2] * v[2] + x[3] * v[3] + x[4] * v[4])
  return Jv
end

function c_jacobian_transposed_operator_hs71(
  userdata::Nothing,
  Jtv::Vector{Float64},
  x::Vector{Float64},
  v::Vector{Float64},
  evaluate_at_x::Bool,
)
  Jtv[1] = (x[2] * x[3] * x[4]) * v[1] + 2 * x[1] * v[2]
  Jtv[2] = (x[1] * x[3] * x[4]) * v[1] + 2 * x[2] * v[2]
  Jtv[3] = (x[1] * x[2] * x[4]) * v[1] + 2 * x[3] * v[2]
  Jtv[4] = (x[1] * x[2] * x[3]) * v[1] + 2 * x[4] * v[2]
  return Jtv
end

function c_lagrangian_hessian_operator_hs71(
  userdata::Nothing,
  Hv::Vector{Float64},
  x::Vector{Float64},
  objective_multiplier::Float64,
  multipliers::Vector{Float64},
  v::Vector{Float64},
  evaluate_at_x::Bool,
)
  # Objective
  Hv[1] = objective_multiplier * (2*x[4]*v[1] + x[4]*v[2] + x[4]*v[3] + (2*x[1] + x[2] + x[3])*v[4])
  Hv[2] = objective_multiplier * (x[4]*v[1] + 0*v[2] + 0*v[3] + x[1]*v[4])
  Hv[3] = objective_multiplier * (x[4]*v[1] + 0*v[2] + 0*v[3] + x[1]*v[4])
  Hv[4] = objective_multiplier * ((2*x[1] + x[2] + x[3])*v[1] + x[1]*v[2] + x[1]*v[3] + 0*v[4])

  # First constraint
  Hv[1] += multipliers[1] * (x[3]*x[4]*v[2] + x[2]*x[4]*v[3] + x[2]*x[3]*v[4])
  Hv[2] += multipliers[1] * (x[3]*x[4]*v[1] + x[1]*x[4]*v[3] + x[1]*x[3]*v[4])
  Hv[3] += multipliers[1] * (x[2]*x[4]*v[1] + x[1]*x[4]*v[2] + x[1]*x[2]*v[4])
  Hv[4] += multipliers[1] * (x[2]*x[3]*v[1] + x[1]*x[3]*v[2] + x[1]*x[2]*v[3])

  # Second constraint
  Hv[1] += multipliers[2] * (2*v[1])
  Hv[2] += multipliers[2] * (2*v[2])
  Hv[3] += multipliers[2] * (2*v[3])
  Hv[4] += multipliers[2] * (2*v[4])
  return Hv
end

# Sparsity pattern of the Jacobian
function sparsity_pattern_jacobian_hs71()
  nnzj = 8
  jrows = Vector{Cint}(undef, nnzj)
  jcols = Vector{Cint}(undef, nnzj)
  # Constraint (row) 1
  jrows[1] = 1
  jcols[1] = 1
  jrows[2] = 1
  jcols[2] = 2
  jrows[3] = 1
  jcols[3] = 3
  jrows[4] = 1
  jcols[4] = 4
  # Constraint (row) 2
  jrows[5] = 2
  jcols[5] = 1
  jrows[6] = 2
  jcols[6] = 2
  jrows[7] = 2
  jcols[7] = 3
  jrows[8] = 2
  jcols[8] = 4
  return jrows, jcols, nnzj
end

# Sparsity pattern of the Hessian of the Lagrangian
function sparsity_pattern_lagrangian_hessian_hs71()
  nnzh = 10
  hrows = Vector{Cint}(undef, nnzh)
  hcols = Vector{Cint}(undef, nnzh)
  # Symmetric matrix, fill the lower left triangle only
  idx = 1
  for row in 1:4
    for col in 1:row
      hrows[idx] = row
      hcols[idx] = col
      idx += 1
    end
  end
  return hrows, hcols, nnzh
end

@testset "hs71" begin
  nvar = 4
  lvar = Float64[1.0, 1.0, 1.0, 1.0]
  uvar = Float64[5.0, 5.0, 5.0, 5.0]

  ncon = 2
  lcon = Float64[25.0, 40.0]
  ucon = Float64[2.0e19, 40.0]

  jrows, jcols, nnzj = sparsity_pattern_jacobian_hs71()
  hrows, hcols, nnzh = sparsity_pattern_lagrangian_hessian_hs71()

  x0 = Float64[1.0, 5.0, 5.0, 1.0]
  y0 = zeros(Float64, ncon)

  @testset "uno_model -- uno_solver -- uno_optimize" begin
    model = uno_model(
      "NLP",
      true,
      nvar,
      ncon,
      lvar,
      uvar,
      lcon,
      ucon,
      jrows,
      jcols,
      nnzj,
      hrows,
      hcols,
      nnzh,
      c_objective_hs71,
      c_constraints_hs71,
      c_objective_gradient_hs71,
      c_jacobian_hs71,
      c_lagrangian_hessian_hs71,
      c_jacobian_operator_hs71,
      c_jacobian_transposed_operator_hs71,
      c_lagrangian_hessian_operator_hs71,
    )

    UnoSolver.uno_set_initial_primal_iterate(model, x0)
    UnoSolver.uno_set_initial_dual_iterate(model, y0)

    solver = uno_solver()
    uno_set_solver_preset(solver, "filtersqp")
    uno_set_solver_bool_option(solver, "print_solution", true)
    uno_optimize(solver, model)

    optimization_status = UnoSolver.uno_get_optimization_status(solver)
    solution_status = UnoSolver.uno_get_solution_status(solver)
    solution_objective = UnoSolver.uno_get_solution_objective(solver)
    solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
    solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
    solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)
    hessian_model = UnoSolver.uno_get_solver_string_option(solver, "hessian_model")

    primal_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_primal_solution(solver, primal_solution)

    constraint_dual_solution = Vector{Float64}(undef, ncon)
    UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

    lower_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

    upper_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

    @test optimization_status == 0  # UNO_SUCCESS
    @test solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test primal_solution[1] ≈ 1.0000000000000000 atol = 1e-5
    @test primal_solution[2] ≈ 4.7429996418092970 atol = 1e-5
    @test primal_solution[3] ≈ 3.8211499817883077 atol = 1e-5
    @test primal_solution[4] ≈ 1.3794082897556983 atol = 1e-5
    @test solution_objective ≈ 17.014017145179164 atol = 1e-5
    @test solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test solution_stationarity ≈ 0.0 atol = 1e-5
    @test solution_complementarity ≈ 0.0 atol = 1e-5
    @test hessian_model == "exact"
  end

  @testset "L-BFGS with preset=filtersqp" begin
    model = uno_model(
      "NLP",
      true,
      nvar,
      ncon,
      lvar,
      uvar,
      lcon,
      ucon,
      jrows,
      jcols,
      nnzj,
      hrows,
      hcols,
      nnzh,
      c_objective_hs71,
      c_constraints_hs71,
      c_objective_gradient_hs71,
      c_jacobian_hs71,
      nothing,
      c_jacobian_operator_hs71,
      c_jacobian_transposed_operator_hs71,
      nothing,
    )

    UnoSolver.uno_set_initial_primal_iterate(model, x0)
    UnoSolver.uno_set_initial_dual_iterate(model, y0)

    solver = uno_solver()
    uno_set_solver_preset(solver, "filtersqp")
    uno_set_solver_bool_option(solver, "print_solution", true)
    uno_set_solver_string_option(solver, "hessian_model", "LBFGS")
    uno_optimize(solver, model)

    optimization_status = UnoSolver.uno_get_optimization_status(solver)
    solution_status = UnoSolver.uno_get_solution_status(solver)
    solution_objective = UnoSolver.uno_get_solution_objective(solver)
    solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
    solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
    solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)
    hessian_model = UnoSolver.uno_get_solver_string_option(solver, "hessian_model")

    primal_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_primal_solution(solver, primal_solution)

    constraint_dual_solution = Vector{Float64}(undef, ncon)
    UnoSolver.uno_get_constraint_dual_solution(solver, constraint_dual_solution)

    lower_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

    upper_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

    @test optimization_status == 0  # UNO_SUCCESS
    @test solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test primal_solution[1] ≈ 1.0000000000000000 atol = 1e-5
    @test primal_solution[2] ≈ 4.7429996418092970 atol = 1e-5
    @test primal_solution[3] ≈ 3.8211499817883077 atol = 1e-5
    @test primal_solution[4] ≈ 1.3794082897556983 atol = 1e-5
    @test solution_objective ≈ 17.014017145179164 atol = 1e-5
    @test solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test solution_stationarity ≈ 0.0 atol = 1e-5
    @test solution_complementarity ≈ 0.0 atol = 1e-5
    @test hessian_model == "LBFGS"
  end

  @testset "uno" begin
    stats = uno(
      "NLP",
      true,
      nvar,
      ncon,
      lvar,
      uvar,
      lcon,
      ucon,
      jrows,
      jcols,
      nnzj,
      hrows,
      hcols,
      nnzh,
      c_objective_hs71,
      c_constraints_hs71,
      c_objective_gradient_hs71,
      c_jacobian_hs71,
      c_lagrangian_hessian_hs71,
      c_jacobian_operator_hs71,
      c_jacobian_transposed_operator_hs71,
      c_lagrangian_hessian_operator_hs71,
      nothing,
      'L',
      1,
      x0,
      y0;
      preset="filtersqp",
      print_solution=true,
    )

    @test stats.optimization_status == 0  # UNO_SUCCESS
    @test stats.solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test stats.primal_solution[1] ≈ 1.0000000000000000 atol = 1e-5
    @test stats.primal_solution[2] ≈ 4.7429996418092970 atol = 1e-5
    @test stats.primal_solution[3] ≈ 3.8211499817883077 atol = 1e-5
    @test stats.primal_solution[4] ≈ 1.3794082897556983 atol = 1e-5
    @test stats.solution_objective ≈ 17.014017145179164 atol = 1e-5
    @test stats.solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test stats.solution_stationarity ≈ 0.0 atol = 1e-5
    @test stats.solution_complementarity ≈ 0.0 atol = 1e-5
  end
end

# hs5
# min sin(x1 + x2) + (x1 - x2)^2 - 1.5 * x1 + 2.5 * x2 + 1
# st  -1.5 <= x1 <= -3, 4 <= x2 <= 3
# Start at (0, 0)
# End at (-0.547..., -1.547...)

function c_objective_hs5(userdata::Nothing, x::Vector{Float64})
  f = sin(x[1] + x[2]) + (x[1] - x[2])^2 - 1.5 * x[1] + 2.5 * x[2] + 1.0
  return f
end

function c_objective_gradient_hs5(userdata::Nothing, g::Vector{Float64}, x::Vector{Float64})
  g[1] = cos(x[1] + x[2]) + 2 * (x[1] - x[2]) - 1.5
  g[2] = cos(x[1] + x[2]) - 2 * (x[1] - x[2]) + 2.5
  return g
end

function c_objective_hessian_hs5(
  userdata::Nothing,
  hvals::Vector{Float64},
  x::Vector{Float64},
  multipliers::Vector{Float64}, # ignored
  objective_multiplier::Float64,
)
  # Only store the upper triangle part of the Hessian of the objective
  # Objective
  hvals[1] = objective_multiplier * (-sin(x[1] + x[2]) + 2)  # 1,1
  hvals[2] = objective_multiplier * (-sin(x[1] + x[2]) - 2)  # 1,2
  hvals[3] = objective_multiplier * (-sin(x[1] + x[2]) + 2)  # 2,2
  return hvals
end

function c_objective_hessian_operator_hs5(
  userdata::Nothing,
  Hv::Vector{Float64},
  x::Vector{Float64},
  objective_multiplier::Float64,
  multipliers::Vector{Float64}, # ignored
  v::Vector{Float64},
  evaluate_at_x::Bool,
)
  # Objective
  Hv[1] = (-sin(x[1] + x[2]) * (v[1] + v[2]) + 2 * (v[1] - v[2])) * objective_multiplier
  Hv[2] = (-sin(x[1] + x[2]) * (v[1] + v[2]) + 2 * (v[2] - v[1])) * objective_multiplier
  return Hv
end

# Sparsity pattern of the Hessian of the objective
function sparsity_pattern_objective_hessian_hs5()
  nnzh = 3
  hrows = Vector{Cint}(undef, nnzh)
  hcols = Vector{Cint}(undef, nnzh)
  # Symmetric matrix, fill the upper right triangle only
  idx = 1
  for row in 1:2
    for col in row:2
      hrows[idx] = row
      hcols[idx] = col
      idx += 1
    end
  end
  return hrows, hcols, nnzh
end

@testset "hs5" begin
  nvar = 2
  lvar = Float64[-1.5, -3.0]
  uvar = Float64[4.0, 3.0]

  hrows, hcols, nnzh = sparsity_pattern_objective_hessian_hs5()

  x0 = Float64[0.0, 0.0]

  @testset "uno_model -- uno_solver -- uno_optimize" begin
    model = uno_model(
      "NLP",
      true,
      nvar,
      lvar,
      uvar,
      hrows,
      hcols,
      nnzh,
      c_objective_hs5,
      c_objective_gradient_hs5,
      c_objective_hessian_hs5,
      c_objective_hessian_operator_hs5,
      nothing,
      'U',
      1,
    )

    UnoSolver.uno_set_initial_primal_iterate(model, x0)

    solver = uno_solver()
    uno_set_solver_preset(solver, "filtersqp")
    uno_set_solver_bool_option(solver, "print_solution", true)
    uno_optimize(solver, model)

    optimization_status = UnoSolver.uno_get_optimization_status(solver)
    solution_status = UnoSolver.uno_get_solution_status(solver)
    solution_objective = UnoSolver.uno_get_solution_objective(solver)
    solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
    solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
    solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)
    hessian_model = UnoSolver.uno_get_solver_string_option(solver, "hessian_model")

    primal_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_primal_solution(solver, primal_solution)

    lower_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

    upper_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

    @test optimization_status == 0  # UNO_SUCCESS
    @test solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test primal_solution[1] ≈ -0.5471975484809134 atol = 1e-5
    @test primal_solution[2] ≈ -1.5471975484809133 atol = 1e-5
    @test solution_objective ≈ -1.9132229549810362 atol = 1e-5
    @test solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test solution_stationarity ≈ 0.0 atol = 1e-5
    @test solution_complementarity ≈ 0.0 atol = 1e-5
    @test hessian_model == "exact"
  end

  @testset "L-BFGS with preset=filtersqp" begin
    model = uno_model(
      "NLP",
      true,
      nvar,
      lvar,
      uvar,
      hrows,
      hcols,
      nnzh,
      c_objective_hs5,
      c_objective_gradient_hs5,
      nothing,
      nothing,
      nothing,
      'U',
      1,
    )

    UnoSolver.uno_set_initial_primal_iterate(model, x0)

    solver = uno_solver()
    uno_set_solver_preset(solver, "filtersqp")
    uno_set_solver_bool_option(solver, "print_solution", true)
    uno_set_solver_string_option(solver, "hessian_model", "LBFGS")
    uno_optimize(solver, model)

    optimization_status = UnoSolver.uno_get_optimization_status(solver)
    solution_status = UnoSolver.uno_get_solution_status(solver)
    solution_objective = UnoSolver.uno_get_solution_objective(solver)
    solution_primal_feasibility = UnoSolver.uno_get_solution_primal_feasibility(solver)
    solution_stationarity = UnoSolver.uno_get_solution_stationarity(solver)
    solution_complementarity = UnoSolver.uno_get_solution_complementarity(solver)
    hessian_model = UnoSolver.uno_get_solver_string_option(solver, "hessian_model")

    primal_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_primal_solution(solver, primal_solution)

    lower_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)

    upper_bound_dual_solution = Vector{Float64}(undef, nvar)
    UnoSolver.uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)

    @test optimization_status == 0  # UNO_SUCCESS
    @test solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test primal_solution[1] ≈ -0.5471975484809134 atol = 1e-5
    @test primal_solution[2] ≈ -1.5471975484809133 atol = 1e-5
    @test solution_objective ≈ -1.9132229549810362 atol = 1e-5
    @test solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test solution_stationarity ≈ 0.0 atol = 1e-5
    @test solution_complementarity ≈ 0.0 atol = 1e-5
    @test hessian_model == "LBFGS"
  end

  @testset "uno" begin
    stats = uno(
      "NLP",
      true,
      nvar,
      lvar,
      uvar,
      hrows,
      hcols,
      nnzh,
      c_objective_hs5,
      c_objective_gradient_hs5,
      c_objective_hessian_hs5,
      c_objective_hessian_operator_hs5,
      nothing,
      'U',
      1,
      x0,
      preset="filtersqp",
      print_solution=true,
    )

    @test stats.optimization_status == 0  # UNO_SUCCESS
    @test stats.solution_status == 1      # UNO_FEASIBLE_KKT_POINT
    @test stats.primal_solution[1] ≈ -0.5471975484809134 atol = 1e-5
    @test stats.primal_solution[2] ≈ -1.5471975484809133 atol = 1e-5
    @test stats.solution_objective ≈ -1.9132229549810362 atol = 1e-5
    @test stats.solution_primal_feasibility ≈ 0.0 atol = 1e-5
    @test stats.solution_stationarity ≈ 0.0 atol = 1e-5
    @test stats.solution_complementarity ≈ 0.0 atol = 1e-5
  end
end

module UnoSolverMathOptInterfaceExt

import UnoSolver
import MathOptInterface as MOI

function __init__()
    setglobal!(UnoSolver, :Optimizer, Optimizer)
    return
end

include("MOI_utils.jl")
include("MOI_wrapper.jl")

end  # module UnoSolverMathOptInterfaceExt

# Copyright (c) 2026 Alexis Montoison and Charlie Vanaret
# Licensed under the MIT license. See LICENSE file in the project directory for details.

const UNO_MINIMIZE = Cint(1)
const UNO_MAXIMIZE = Cint(-1)

const UNO_MULTIPLIER_POSITIVE = Cint(1)
const UNO_MULTIPLIER_NEGATIVE = Cint(-1)

const UNO_PROBLEM_LINEAR = "LP"
const UNO_PROBLEM_QUADRATIC = "QP"
const UNO_PROBLEM_NONLINEAR = "NLP"

const UNO_ZERO_BASED_INDEXING = Cint(0)
const UNO_ONE_BASED_INDEXING = Cint(1)

const UNO_LOWER_TRIANGLE = Cchar('L')
const UNO_UPPER_TRIANGLE = Cchar('U')

const UNO_OPTION_TYPE_INTEGER = Cint(0)
const UNO_OPTION_TYPE_DOUBLE = Cint(1)
const UNO_OPTION_TYPE_BOOL = Cint(2)
const UNO_OPTION_TYPE_STRING = Cint(3)
const UNO_OPTION_TYPE_NOT_FOUND = Cint(-1)

const UNO_SUCCESS = Cint(0)
const UNO_ITERATION_LIMIT = Cint(1)
const UNO_TIME_LIMIT = Cint(2)
const UNO_EVALUATION_ERROR = Cint(3)
const UNO_ALGORITHMIC_ERROR = Cint(4)
const UNO_USER_TERMINATION = Cint(5)

const UNO_NOT_OPTIMAL = Cint(0)
const UNO_FEASIBLE_KKT_POINT = Cint(1)
const UNO_FEASIBLE_FJ_POINT = Cint(2)
const UNO_INFEASIBLE_STATIONARY_POINT = Cint(3)
const UNO_FEASIBLE_SMALL_STEP = Cint(4)
const UNO_INFEASIBLE_SMALL_STEP = Cint(5)
const UNO_UNBOUNDED = Cint(6)

function uno_get_version(major, minor, patch)
    @ccall libuno.uno_get_version(major::Ptr{Int32}, minor::Ptr{Int32},
                                  patch::Ptr{Int32})::Cvoid
end

function uno_create_model(problem_type, number_variables, variables_lower_bounds,
                          variables_upper_bounds, base_indexing)
    @ccall libuno.uno_create_model(problem_type::Cstring, number_variables::Int32,
                                   variables_lower_bounds::Ptr{Cdouble},
                                   variables_upper_bounds::Ptr{Cdouble},
                                   base_indexing::Int32)::Ptr{Cvoid}
end

function uno_set_objective(model, optimization_sense, objective_function,
                           objective_gradient)
    @ccall libuno.uno_set_objective(model::Ptr{Cvoid}, optimization_sense::Int32,
                                    objective_function::Ptr{Cvoid},
                                    objective_gradient::Ptr{Cvoid})::Bool
end

function uno_set_constraints(model, number_constraints, constraint_functions,
                             constraints_lower_bounds, constraints_upper_bounds,
                             number_jacobian_nonzeros, jacobian_row_indices,
                             jacobian_column_indices, jacobian)
    @ccall libuno.uno_set_constraints(model::Ptr{Cvoid}, number_constraints::Int32,
                                      constraint_functions::Ptr{Cvoid},
                                      constraints_lower_bounds::Ptr{Cdouble},
                                      constraints_upper_bounds::Ptr{Cdouble},
                                      number_jacobian_nonzeros::Int32,
                                      jacobian_row_indices::Ptr{Int32},
                                      jacobian_column_indices::Ptr{Int32},
                                      jacobian::Ptr{Cvoid})::Bool
end

function uno_set_jacobian_operator(model, jacobian_operator)
    @ccall libuno.uno_set_jacobian_operator(model::Ptr{Cvoid},
                                            jacobian_operator::Ptr{Cvoid})::Bool
end

function uno_set_jacobian_transposed_operator(model, jacobian_transposed_operator)
    @ccall libuno.uno_set_jacobian_transposed_operator(model::Ptr{Cvoid},
                                                       jacobian_transposed_operator::Ptr{Cvoid})::Bool
end

function uno_set_lagrangian_hessian(model, number_hessian_nonzeros, hessian_triangular_part,
                                    hessian_row_indices, hessian_column_indices,
                                    lagrangian_hessian)
    @ccall libuno.uno_set_lagrangian_hessian(model::Ptr{Cvoid},
                                             number_hessian_nonzeros::Int32,
                                             hessian_triangular_part::Cchar,
                                             hessian_row_indices::Ptr{Int32},
                                             hessian_column_indices::Ptr{Int32},
                                             lagrangian_hessian::Ptr{Cvoid})::Bool
end

function uno_set_lagrangian_hessian_operator(model, lagrangian_hessian_operator)
    @ccall libuno.uno_set_lagrangian_hessian_operator(model::Ptr{Cvoid},
                                                      lagrangian_hessian_operator::Ptr{Cvoid})::Bool
end

function uno_set_lagrangian_sign_convention(model, lagrangian_sign_convention)
    @ccall libuno.uno_set_lagrangian_sign_convention(model::Ptr{Cvoid},
                                                     lagrangian_sign_convention::Int32)::Bool
end

function uno_set_user_data(model, user_data)
    @ccall libuno.uno_set_user_data(model::Ptr{Cvoid}, user_data::Ptr{Cvoid})::Bool
end

function uno_set_initial_primal_iterate_component(model, index, initial_primal_component)
    @ccall libuno.uno_set_initial_primal_iterate_component(model::Ptr{Cvoid}, index::Int32,
                                                           initial_primal_component::Cdouble)::Bool
end

function uno_set_initial_dual_iterate_component(model, index, initial_dual_component)
    @ccall libuno.uno_set_initial_dual_iterate_component(model::Ptr{Cvoid}, index::Int32,
                                                         initial_dual_component::Cdouble)::Bool
end

function uno_set_initial_primal_iterate(model, initial_primal_iterate)
    @ccall libuno.uno_set_initial_primal_iterate(model::Ptr{Cvoid},
                                                 initial_primal_iterate::Ptr{Cdouble})::Bool
end

function uno_set_initial_dual_iterate(model, initial_dual_iterate)
    @ccall libuno.uno_set_initial_dual_iterate(model::Ptr{Cvoid},
                                               initial_dual_iterate::Ptr{Cdouble})::Bool
end

function uno_create_solver()
    @ccall libuno.uno_create_solver()::Ptr{Cvoid}
end

function uno_set_solver_integer_option(solver, option_name, option_value)
    @ccall libuno.uno_set_solver_integer_option(solver::Ptr{Cvoid}, option_name::Cstring,
                                                option_value::Int32)::Bool
end

function uno_set_solver_double_option(solver, option_name, option_value)
    @ccall libuno.uno_set_solver_double_option(solver::Ptr{Cvoid}, option_name::Cstring,
                                               option_value::Cdouble)::Bool
end

function uno_set_solver_bool_option(solver, option_name, option_value)
    @ccall libuno.uno_set_solver_bool_option(solver::Ptr{Cvoid}, option_name::Cstring,
                                             option_value::Bool)::Bool
end

function uno_set_solver_string_option(solver, option_name, option_value)
    @ccall libuno.uno_set_solver_string_option(solver::Ptr{Cvoid}, option_name::Cstring,
                                               option_value::Cstring)::Bool
end

function uno_get_solver_option_type(solver, option_name)
    @ccall libuno.uno_get_solver_option_type(solver::Ptr{Cvoid},
                                             option_name::Cstring)::Int32
end

function uno_load_solver_option_file(solver, file_name)
    @ccall libuno.uno_load_solver_option_file(solver::Ptr{Cvoid}, file_name::Cstring)::Bool
end

function uno_set_solver_preset(solver, preset_name)
    @ccall libuno.uno_set_solver_preset(solver::Ptr{Cvoid}, preset_name::Cstring)::Bool
end

function uno_set_solver_callbacks(solver, notify_acceptable_iterate_callback,
                                  user_termination_callback, user_data)
    @ccall libuno.uno_set_solver_callbacks(solver::Ptr{Cvoid},
                                           notify_acceptable_iterate_callback::Ptr{Cvoid},
                                           user_termination_callback::Ptr{Cvoid},
                                           user_data::Ptr{Cvoid})::Bool
end

function uno_set_logger_stream_callback(logger_stream_callback, user_data)
    @ccall libuno.uno_set_logger_stream_callback(logger_stream_callback::Ptr{Cvoid},
                                                 user_data::Ptr{Cvoid})::Bool
end

function uno_reset_logger_stream()
    @ccall libuno.uno_reset_logger_stream()::Bool
end

function uno_optimize(solver, model)
    @ccall libuno.uno_optimize(solver::Ptr{Cvoid}, model::Ptr{Cvoid})::Cvoid
end

function uno_get_solver_integer_option(solver, option_name)
    @ccall libuno.uno_get_solver_integer_option(solver::Ptr{Cvoid},
                                                option_name::Cstring)::Cint
end

function uno_get_solver_double_option(solver, option_name)
    @ccall libuno.uno_get_solver_double_option(solver::Ptr{Cvoid},
                                               option_name::Cstring)::Cdouble
end

function uno_get_solver_bool_option(solver, option_name)
    @ccall libuno.uno_get_solver_bool_option(solver::Ptr{Cvoid}, option_name::Cstring)::Bool
end

function uno_get_solver_string_option(solver, option_name)
    @ccall libuno.uno_get_solver_string_option(solver::Ptr{Cvoid},
                                               option_name::Cstring)::Cstring
end

function uno_get_optimization_status(solver)
    @ccall libuno.uno_get_optimization_status(solver::Ptr{Cvoid})::Int32
end

function uno_get_solution_status(solver)
    @ccall libuno.uno_get_solution_status(solver::Ptr{Cvoid})::Int32
end

function uno_get_solution_objective(solver)
    @ccall libuno.uno_get_solution_objective(solver::Ptr{Cvoid})::Cdouble
end

function uno_get_primal_solution_component(solver, index)
    @ccall libuno.uno_get_primal_solution_component(solver::Ptr{Cvoid},
                                                    index::Int32)::Cdouble
end

function uno_get_constraint_dual_solution_component(solver, index)
    @ccall libuno.uno_get_constraint_dual_solution_component(solver::Ptr{Cvoid},
                                                             index::Int32)::Cdouble
end

function uno_get_lower_bound_dual_solution_component(solver, index)
    @ccall libuno.uno_get_lower_bound_dual_solution_component(solver::Ptr{Cvoid},
                                                              index::Int32)::Cdouble
end

function uno_get_upper_bound_dual_solution_component(solver, index)
    @ccall libuno.uno_get_upper_bound_dual_solution_component(solver::Ptr{Cvoid},
                                                              index::Int32)::Cdouble
end

function uno_get_primal_solution(solver, primal_solution)
    @ccall libuno.uno_get_primal_solution(solver::Ptr{Cvoid},
                                          primal_solution::Ptr{Cdouble})::Cvoid
end

function uno_get_constraint_dual_solution(solver, constraint_dual_solution)
    @ccall libuno.uno_get_constraint_dual_solution(solver::Ptr{Cvoid},
                                                   constraint_dual_solution::Ptr{Cdouble})::Cvoid
end

function uno_get_lower_bound_dual_solution(solver, lower_bound_dual_solution)
    @ccall libuno.uno_get_lower_bound_dual_solution(solver::Ptr{Cvoid},
                                                    lower_bound_dual_solution::Ptr{Cdouble})::Cvoid
end

function uno_get_upper_bound_dual_solution(solver, upper_bound_dual_solution)
    @ccall libuno.uno_get_upper_bound_dual_solution(solver::Ptr{Cvoid},
                                                    upper_bound_dual_solution::Ptr{Cdouble})::Cvoid
end

function uno_get_solution_primal_feasibility(solver)
    @ccall libuno.uno_get_solution_primal_feasibility(solver::Ptr{Cvoid})::Cdouble
end

function uno_get_solution_stationarity(solver)
    @ccall libuno.uno_get_solution_stationarity(solver::Ptr{Cvoid})::Cdouble
end

function uno_get_solution_complementarity(solver)
    @ccall libuno.uno_get_solution_complementarity(solver::Ptr{Cvoid})::Cdouble
end

function uno_get_number_iterations(solver)
    @ccall libuno.uno_get_number_iterations(solver::Ptr{Cvoid})::Int32
end

function uno_get_cpu_time(solver)
    @ccall libuno.uno_get_cpu_time(solver::Ptr{Cvoid})::Cdouble
end

function uno_get_number_objective_evaluations(solver)
    @ccall libuno.uno_get_number_objective_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_get_number_constraint_evaluations(solver)
    @ccall libuno.uno_get_number_constraint_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_get_number_objective_gradient_evaluations(solver)
    @ccall libuno.uno_get_number_objective_gradient_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_get_number_jacobian_evaluations(solver)
    @ccall libuno.uno_get_number_jacobian_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_get_number_hessian_evaluations(solver)
    @ccall libuno.uno_get_number_hessian_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_get_number_subproblem_solved_evaluations(solver)
    @ccall libuno.uno_get_number_subproblem_solved_evaluations(solver::Ptr{Cvoid})::Int32
end

function uno_destroy_model(model)
    @ccall libuno.uno_destroy_model(model::Ptr{Cvoid})::Cvoid
end

function uno_destroy_solver(solver)
    @ccall libuno.uno_destroy_solver(solver::Ptr{Cvoid})::Cvoid
end

module UnoSolver

import Uno_jll
import Uno_jll: libuno
import LinearAlgebra
import OpenBLAS32_jll

function __init__()
    config = LinearAlgebra.BLAS.lbt_get_config()
    if !any(lib -> lib.interface == :lp64, config.loaded_libs)
        LinearAlgebra.BLAS.lbt_forward(OpenBLAS32_jll.libopenblas_path)
    end
    return
end

export uno, uno_model, uno_solver, uno_optimize, uno_version
export uno_set_solver_integer_option, uno_set_solver_double_option
export uno_set_solver_bool_option, uno_set_solver_string_option
export uno_set_solver_preset, uno_statistics

include("libuno.jl")
include("C_wrapper.jl")

global Optimizer

end  # module UnoSolver

module UnoSolverNLPModelsExt

import UnoSolver
import NLPModels
import NLPModels: AbstractNLPModel

function nlpmodels_objective(nlp::AbstractNLPModel{Float64, Vector{Float64}}, x::Vector{Float64})
  f = NLPModels.obj(nlp, x)
  return f
end

function nlpmodels_constraints(nlp::AbstractNLPModel{Float64, Vector{Float64}}, c::Vector{Float64}, x::Vector{Float64})
  NLPModels.cons!(nlp, x, c)
  return c
end

function nlpmodels_objective_gradient(nlp::AbstractNLPModel{Float64, Vector{Float64}}, g::Vector{Float64}, x::Vector{Float64})
  NLPModels.grad!(nlp, x, g)
  return g
end

function nlpmodels_jacobian(nlp::AbstractNLPModel{Float64, Vector{Float64}}, jvals::Vector{Float64}, x::Vector{Float64})
  NLPModels.jac_coord!(nlp, x, jvals)
  return jvals
end

function nlpmodels_lagrangian_hessian(nlp::AbstractNLPModel{Float64, Vector{Float64}}, hvals::Vector{Float64}, x::Vector{Float64},
                                      multipliers::Vector{Float64}, objective_multiplier::Float64)
  if nlp.meta.ncon == 0
    NLPModels.hess_coord!(nlp, x, hvals; obj_weight=objective_multiplier)
  else
    NLPModels.hess_coord!(nlp, x, multipliers, hvals; obj_weight=objective_multiplier)
  end
  return hvals
end

function nlpmodels_jacobian_operator(nlp::AbstractNLPModel{Float64, Vector{Float64}}, Jv::Vector{Float64}, x::Vector{Float64},
                                     v::Vector{Float64}, evaluate_at_x::Bool)
  NLPModels.jprod!(nlp, x, v, Jv)
  return Jv
end

function nlpmodels_jacobian_transposed_operator(nlp::AbstractNLPModel{Float64, Vector{Float64}}, Jtv::Vector{Float64},
                                                x::Vector{Float64}, v::Vector{Float64}, evaluate_at_x::Bool)
  NLPModels.jtprod!(nlp, x, v, Jtv)
  return Jtv
end

function nlpmodels_lagrangian_hessian_operator(nlp::AbstractNLPModel{Float64, Vector{Float64}}, Hv::Vector{Float64},
                                               x::Vector{Float64}, objective_multiplier::Float64, multipliers::Vector{Float64},
                                               v::Vector{Float64}, evaluate_at_x::Bool)
  if nlp.meta.ncon == 0
    NLPModels.hprod!(nlp, x, v, Hv; obj_weight=objective_multiplier)
  else
    NLPModels.hprod!(nlp, x, multipliers, v, Hv; obj_weight=objective_multiplier)
  end
  return Hv
end

function UnoSolver.uno_model(nlp::AbstractNLPModel{Float64, Vector{Float64}})
  @assert nlp.meta.grad_available && (nlp.meta.ncon == 0 || nlp.meta.jac_available)
  if nlp.meta.jac_available
    jrows, jcols = NLPModels.jac_structure(nlp)
  end
  if nlp.meta.hess_available
    hrows, hcols = NLPModels.hess_structure(nlp)
  end
  islp = nlp.meta.islp || (nlp.meta.hess_available && nlp.meta.nnzh == 0)
  problem_type = islp ? "LP" : "NLP"
  model = UnoSolver.uno_model(
    problem_type,
    nlp.meta.minimize,
    nlp.meta.nvar,
    nlp.meta.ncon,
    nlp.meta.lvar,
    nlp.meta.uvar,
    nlp.meta.lcon,
    nlp.meta.ucon,
    nlp.meta.jac_available ? Cint.(jrows) : Cint[],
    nlp.meta.jac_available ? Cint.(jcols) : Cint[],
    nlp.meta.nnzj,
    nlp.meta.hess_available ? Cint.(hrows) : Cint[],
    nlp.meta.hess_available ? Cint.(hcols) : Cint[],
    nlp.meta.nnzh,
    nlpmodels_objective,
    nlp.meta.ncon > 0 ? nlpmodels_constraints : nothing,
    nlpmodels_objective_gradient,
    nlp.meta.jac_available ? nlpmodels_jacobian : nothing,
    nlp.meta.hess_available ? nlpmodels_lagrangian_hessian : nothing,
    nlp.meta.jprod_available ? nlpmodels_jacobian_operator : nothing,
    nlp.meta.jtprod_available ? nlpmodels_jacobian_transposed_operator : nothing,
    nlp.meta.hprod_available ? nlpmodels_lagrangian_hessian_operator : nothing,
    nlp,
    'L',
    1,
    nlp.meta.x0,
    nlp.meta.y0,
  )
  return model
end

function UnoSolver.uno(nlp::AbstractNLPModel{Float64, Vector{Float64}}; kwargs...)
  model = UnoSolver.uno_model(nlp)
  solver = UnoSolver.uno_solver(; kwargs...)
  UnoSolver.uno_optimize(solver, model)
  stats = UnoSolver.uno_statistics(model, solver)
  return stats
end

end  # module UnoSolverNLPModelsExt

using UnoSolver
using NLPModels, MathOptInterface, CUTEst
using LinearAlgebra, Test
using HSL_jll

version = uno_version()
println("The version of Uno is $version.")

@testset "C interface" begin
  include("C_wrapper.jl")
end

@testset "Interface for NLPModels.jl" begin
  include("NLP_wrapper.jl")
end

@testset "Interface for MathOptInterface.jl" begin
  include("MOI_wrapper.jl")
end

# Copyright (c) 2013: Iain Dunning, Miles Lubin, and contributors
# 2025: Adapted for UnoSolver.jl by Alexis Montoison and Charlie Vanaret
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

const _PARAMETER_OFFSET = 0x00f0000000000000

_is_parameter(x::MOI.VariableIndex) = x.value >= _PARAMETER_OFFSET
_is_parameter(term::MOI.ScalarAffineTerm) = _is_parameter(term.variable)
_is_parameter(term::MOI.ScalarQuadraticTerm) = _is_parameter(term.variable_1) || _is_parameter(term.variable_2)

mutable struct _VectorNonlinearOracleCache
    set::MOI.VectorNonlinearOracle{Float64}
    x::Vector{Float64}
    start::Union{Nothing,Vector{Float64}}
    eval_f_timer::Float64
    eval_jacobian_timer::Float64
    eval_hessian_lagrangian_timer::Float64

    function _VectorNonlinearOracleCache(set::MOI.VectorNonlinearOracle{Float64})
        return new(set, zeros(set.input_dimension), nothing, 0.0, 0.0, 0.0)
    end
end

"""
    Optimizer()

Create a new Uno optimizer.
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    inner::Union{Nothing,UnoSolver.Model}
    solver::Union{Nothing,UnoSolver.Solver}
    name::String
    invalid_model::Bool
    silent::Bool
    options::Dict{String,Any}
    sense::MOI.OptimizationSense
    parameters::Dict{MOI.VariableIndex,MOI.Nonlinear.ParameterIndex}
    variables::MOI.Utilities.VariablesContainer{Float64}
    list_of_variable_indices::Vector{MOI.VariableIndex}
    variable_primal_start::Vector{Union{Nothing,Float64}}
    nlp_data::MOI.NLPBlockData
    nlp_dual_start::Union{Nothing,Vector{Float64}}
    mult_g_nlp::Dict{MOI.Nonlinear.ConstraintIndex,Float64}
    qp_data::QPBlockData{Float64}
    nlp_model::Union{Nothing,MOI.Nonlinear.Model}
    ad_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation
    vector_nonlinear_oracle_constraints::Vector{Tuple{MOI.VectorOfVariables,_VectorNonlinearOracleCache}}
    jrows::Vector{Cint}
    jcols::Vector{Cint}
    hrows::Vector{Cint}
    hcols::Vector{Cint}
    needs_new_inner::Bool
    hess_available::Bool
    jprod_available::Bool
    jtprod_available::Bool
    hprod_available::Bool
    problem_type::String

    function Optimizer(; kwargs...)
        option_dict = Dict{String,Any}()
        for (name, value) in kwargs
            option_dict[name |> string] = value
        end
        return new(
            nothing,
            nothing,
            "",
            false,
            false,
            option_dict,
            MOI.FEASIBILITY_SENSE,
            Dict{MOI.VariableIndex,Float64}(),
            MOI.Utilities.VariablesContainer{Float64}(),
            MOI.VariableIndex[],
            Union{Nothing,Float64}[],
            MOI.NLPBlockData([], _EmptyNLPEvaluator(), false),
            nothing,
            Dict{MOI.Nonlinear.ConstraintIndex,Float64}(),
            QPBlockData{Float64}(),
            nothing,
            MOI.Nonlinear.SparseReverseMode(),
            Tuple{MOI.VectorOfVariables,_VectorNonlinearOracleCache}[],
            Cint[],
            Cint[],
            Cint[],
            Cint[],
            true,
            false,
            false,
            false,
            false,
            "",
        )
    end
end

const _SETS = Union{
    MOI.GreaterThan{Float64},
    MOI.LessThan{Float64},
    MOI.EqualTo{Float64},
    MOI.Interval{Float64},
}

const _FUNCTIONS = Union{
    MOI.ScalarAffineFunction{Float64},
    MOI.ScalarQuadraticFunction{Float64},
    MOI.ScalarNonlinearFunction,
}

MOI.get(::Optimizer, ::MOI.SolverVersion) = UnoSolver.uno_version() |> string

### _EmptyNLPEvaluator

struct _EmptyNLPEvaluator <: MOI.AbstractNLPEvaluator end

MOI.features_available(::_EmptyNLPEvaluator) = [:Grad, :Jac, :Hess, :JacVec, :HessVec]
MOI.initialize(::_EmptyNLPEvaluator, ::Any) = nothing
MOI.eval_constraint(::_EmptyNLPEvaluator, g, x) = nothing
MOI.jacobian_structure(::_EmptyNLPEvaluator) = Tuple{Int64,Int64}[]
MOI.hessian_lagrangian_structure(::_EmptyNLPEvaluator) = Tuple{Int64,Int64}[]
MOI.eval_constraint_jacobian(::_EmptyNLPEvaluator, J, x) = nothing
MOI.eval_hessian_lagrangian(::_EmptyNLPEvaluator, H, x, σ, μ) = nothing
MOI.eval_constraint_jacobian_product(d::_EmptyNLPEvaluator, y, x, w) = nothing
MOI.eval_constraint_jacobian_transpose_product(::_EmptyNLPEvaluator, y, x, w) = nothing
MOI.eval_hessian_lagrangian_product(::_EmptyNLPEvaluator, H, x, v, σ, μ) = nothing

function MOI.empty!(model::Optimizer)
    model.inner = nothing
    model.solver = nothing
    # SKIP: model.name
    model.invalid_model = false
    # SKIP: model.silent
    # SKIP: model.options
    model.sense = MOI.FEASIBILITY_SENSE
    empty!(model.parameters)
    MOI.empty!(model.variables)
    empty!(model.list_of_variable_indices)
    empty!(model.variable_primal_start)
    model.nlp_data = MOI.NLPBlockData([], _EmptyNLPEvaluator(), false)
    model.nlp_dual_start = nothing
    empty!(model.mult_g_nlp)
    model.qp_data = QPBlockData{Float64}()
    model.nlp_model = nothing
    # SKIP: model.ad_backend
    empty!(model.vector_nonlinear_oracle_constraints)
    model.jrows = Cint[]
    model.jcols = Cint[]
    model.hrows = Cint[]
    model.hcols = Cint[]
    model.needs_new_inner = true
    model.hess_available = false
    model.jprod_available = false
    model.jtprod_available = false
    model.hprod_available = false
    model.problem_type = ""
    return
end

function MOI.is_empty(model::Optimizer)
    return MOI.is_empty(model.variables) &&
           isempty(model.variable_primal_start) &&
           model.nlp_data.evaluator isa _EmptyNLPEvaluator &&
           model.sense == MOI.FEASIBILITY_SENSE &&
           isempty(model.vector_nonlinear_oracle_constraints)
end

MOI.supports_incremental_interface(::Optimizer) = true

function MOI.copy_to(model::Optimizer, src::MOI.ModelLike)
    return MOI.Utilities.default_copy_to(model, src)
end

MOI.get(::Optimizer, ::MOI.SolverName) = "Uno"

function _init_nlp_model(model)
    if model.nlp_model === nothing
        if !(model.nlp_data.evaluator isa _EmptyNLPEvaluator)
            error("Cannot mix the new and legacy nonlinear APIs")
        end
        model.nlp_model = MOI.Nonlinear.Model()
    end
    return
end

function MOI.supports_add_constrained_variable(
    ::Optimizer,
    ::Type{MOI.Parameter{Float64}},
)
    return true
end

function MOI.add_constrained_variable(
    model::Optimizer,
    set::MOI.Parameter{Float64},
)
    model.inner = nothing
    model.solver = nothing
    _init_nlp_model(model)
    p = MOI.VariableIndex(_PARAMETER_OFFSET + length(model.parameters))
    push!(model.list_of_variable_indices, p)
    model.parameters[p] =
        MOI.Nonlinear.add_parameter(model.nlp_model, set.value)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,typeof(set)}(p.value)
    return p, ci
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Parameter{Float64}},
)
    return haskey(model.parameters, MOI.VariableIndex(ci.value))
end

function MOI.get(
    model::Optimizer,
    ::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.VariableIndex,S<:MOI.Parameter{Float64}}
    ret = [MOI.ConstraintIndex{F,S}(p.value) for p in keys(model.parameters)]
    sort!(ret; by = x -> x.value)
    return ret
end

function MOI.get(
    model::Optimizer,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Parameter{Float64}},
)
    return length(model.parameters)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Parameter{Float64}},
    set::MOI.Parameter{Float64},
)
    p = model.parameters[MOI.VariableIndex(ci.value)]
    model.nlp_model[p] = set.value
    return
end

_replace_parameters(model::Optimizer, f) = f

function _replace_parameters(model::Optimizer, f::MOI.VariableIndex)
    if _is_parameter(f)
        return model.parameters[f]
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarAffineFunction)
    if any(_is_parameter, f.terms)
        g = convert(MOI.ScalarNonlinearFunction, f)
        return _replace_parameters(model, g)
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarQuadraticFunction)
    if any(_is_parameter, f.affine_terms) ||
       any(_is_parameter, f.quadratic_terms)
        g = convert(MOI.ScalarNonlinearFunction, f)
        return _replace_parameters(model, g)
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarNonlinearFunction)
    for (i, arg) in enumerate(f.args)
        f.args[i] = _replace_parameters(model, arg)
    end
    return f
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{<:Union{MOI.VariableIndex,_FUNCTIONS}},
    ::Type{<:_SETS},
)
    return true
end

### MOI.ListOfConstraintTypesPresent

_add_scalar_nonlinear_constraints(ret, ::Nothing) = nothing

function _add_scalar_nonlinear_constraints(ret, nlp_model::MOI.Nonlinear.Model)
    for v in values(nlp_model.constraints)
        F, S = MOI.ScalarNonlinearFunction, typeof(v.set)
        if !((F, S) in ret)
            push!(ret, (F, S))
        end
    end
    return
end

function MOI.get(model::Optimizer, attr::MOI.ListOfConstraintTypesPresent)
    ret = MOI.get(model.variables, attr)
    append!(ret, MOI.get(model.qp_data, attr))
    _add_scalar_nonlinear_constraints(ret, model.nlp_model)
    if !isempty(model.vector_nonlinear_oracle_constraints)
        push!(ret, (MOI.VectorOfVariables, MOI.VectorNonlinearOracle{Float64}))
    end
    if !isempty(model.parameters)
        push!(ret, (MOI.VariableIndex, MOI.Parameter{Float64}))
    end
    return ret
end

### MOI.Name

MOI.supports(::Optimizer, ::MOI.Name) = true

function MOI.set(model::Optimizer, ::MOI.Name, value::String)
    model.name = value
    return
end

MOI.get(model::Optimizer, ::MOI.Name) = model.name

### MOI.Silent

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(model::Optimizer, ::MOI.Silent, value)
    model.silent = value
    return
end

MOI.get(model::Optimizer, ::MOI.Silent) = model.silent

### MOI.TimeLimitSec

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, value::Real)
    MOI.set(model, MOI.RawOptimizerAttribute("time_limit"), Float64(value))
    return
end

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, ::Nothing)
    delete!(model.options, "time_limit")
    return
end

function MOI.get(model::Optimizer, ::MOI.TimeLimitSec)
    return get(model.options, "time_limit", nothing)
end

### MOI.RawOptimizerAttribute

MOI.supports(::Optimizer, ::MOI.RawOptimizerAttribute) = true

function MOI.set(model::Optimizer, p::MOI.RawOptimizerAttribute, value)
    model.options[p.name] = value
    # No need to reset model.inner and model.solver, because this gets handled in optimize!.
    return
end

function MOI.get(model::Optimizer, p::MOI.RawOptimizerAttribute)
    if !haskey(model.options, p.name)
        msg = "RawOptimizerAttribute with name $(p.name) is not already set."
        throw(MOI.GetAttributeNotAllowed(p, msg))
    end
    return model.options[p.name]
end

### Variables

"""
    column(x::MOI.VariableIndex)

Return the column associated with a variable.
"""
column(x::MOI.VariableIndex) = x.value

function MOI.add_variable(model::Optimizer)
    push!(model.variable_primal_start, nothing)
    model.inner = nothing
    model.solver = nothing
    x = MOI.add_variable(model.variables)
    push!(model.list_of_variable_indices, x)
    return x
end

function MOI.is_valid(model::Optimizer, x::MOI.VariableIndex)
    if _is_parameter(x)
        return haskey(model.parameters, x)
    end
    return MOI.is_valid(model.variables, x)
end

function MOI.get(model::Optimizer, ::MOI.ListOfVariableIndices)
    return model.list_of_variable_indices
end

function MOI.get(model::Optimizer, ::MOI.NumberOfVariables)
    return length(model.list_of_variable_indices)
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    return MOI.is_valid(model.variables, ci)
end

function MOI.get(
    model::Optimizer,
    attr::Union{
        MOI.NumberOfConstraints{MOI.VariableIndex,<:_SETS},
        MOI.ListOfConstraintIndices{MOI.VariableIndex,<:_SETS},
    },
)
    return MOI.get(model.variables, attr)
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    return MOI.get(model.variables, attr, c)
end

function MOI.add_constraint(model::Optimizer, x::MOI.VariableIndex, set::_SETS)
    index = MOI.add_constraint(model.variables, x, set)
    model.inner = nothing
    model.solver = nothing
    return index
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    set::S,
) where {S<:_SETS}
    MOI.set(model.variables, MOI.ConstraintSet(), ci, set)
    model.needs_new_inner = true
    model.solver = nothing
    return
end

function MOI.delete(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    MOI.delete(model.variables, ci)
    model.inner = nothing
    model.solver = nothing
    return
end

### ScalarAffineFunction and ScalarQuadraticFunction constraints

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.is_valid(model.qp_data, ci)
end

function MOI.add_constraint(
    model::Optimizer,
    func::Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    set::_SETS,
)
    index = MOI.add_constraint(model.qp_data, func, set)
    model.inner = nothing
    model.solver = nothing
    return index
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.NumberOfConstraints{F,S},MOI.ListOfConstraintIndices{F,S}},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:_SETS,
}
    return MOI.get(model.qp_data, attr)
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    c::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.get(model.qp_data, attr, c)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{F,S},
    set::S,
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:_SETS,
}
    MOI.set(model.qp_data, MOI.ConstraintSet(), ci, set)
    model.needs_new_inner = true
    model.solver = nothing
    return
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ConstraintDualStart,
    ::Type{<:MOI.ConstraintIndex{F,<:_SETS}},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    c::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.get(model.qp_data, attr, c)
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{F,<:_SETS},
    value::Union{Real,Nothing},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    MOI.throw_if_not_valid(model, ci)
    MOI.set(model.qp_data, attr, ci, value)
    # No need to reset model.inner and model.solver, because this gets handled in optimize!.
    return
end

### ScalarNonlinearFunction

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    if model.nlp_model === nothing
        return false
    end
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return MOI.is_valid(model.nlp_model, index)
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.ScalarNonlinearFunction,
    s::_SETS,
)
    _init_nlp_model(model)
    if !isempty(model.parameters)
        _replace_parameters(model, f)
    end
    index = MOI.Nonlinear.add_constraint(model.nlp_model, f, s)
    model.inner = nothing
    model.solver = nothing
    return MOI.ConstraintIndex{typeof(f),typeof(s)}(index.value)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.ScalarNonlinearFunction,S<:_SETS}
    ret = MOI.ConstraintIndex{F,S}[]
    if model.nlp_model === nothing
        return ret
    end
    for (k, v) in model.nlp_model.constraints
        if v.set isa S
            push!(ret, MOI.ConstraintIndex{F,S}(k.value))
        end
    end
    return ret
end

function MOI.get(
    model::Optimizer,
    attr::MOI.NumberOfConstraints{F,S},
) where {F<:MOI.ScalarNonlinearFunction,S<:_SETS}
    if model.nlp_model === nothing
        return 0
    end
    return count(v.set isa S for v in values(model.nlp_model.constraints))
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
)
    return true
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
    func::MOI.ScalarNonlinearFunction,
)
    _init_nlp_model(model)
    if !isempty(model.parameters)
        _replace_parameters(model, func)
    end
    MOI.Nonlinear.set_objective(model.nlp_model, func)
    model.inner = nothing
    model.solver = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return model.nlp_model[index].set
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,S},
    set::S,
) where {S<:_SETS}
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    func = model.nlp_model[index].expression
    model.nlp_model.constraints[index] = MOI.Nonlinear.Constraint(func, set)
    model.needs_new_inner = true
    model.solver = nothing
    return
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ConstraintDualStart,
    ::Type{<:MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS}},
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return get(model.mult_g_nlp, index, nothing)
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
    value::Union{Real,Nothing},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    if value === nothing
        delete!(model.mult_g_nlp, index)
    else
        model.mult_g_nlp[index] = convert(Float64, value)
    end
    # No need to reset model.inner and model.solver, because this gets handled in optimize!.
    return
end

### MOI.VectorOfVariables in MOI.VectorNonlinearOracle{Float64}

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.VectorNonlinearOracle{Float64}},
)
    return true
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{Float64},
    },
)
    return 1 <= ci.value <= length(model.vector_nonlinear_oracle_constraints)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    n = length(model.vector_nonlinear_oracle_constraints)
    return MOI.ConstraintIndex{F,S}.(1:n)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.NumberOfConstraints{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    return length(model.vector_nonlinear_oracle_constraints)
end

function MOI.add_constraint(
    model::Optimizer,
    f::F,
    s::S,
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    model.inner = nothing
    model.solver = nothing
    cache = _VectorNonlinearOracleCache(s)
    push!(model.vector_nonlinear_oracle_constraints, (f, cache))
    n = length(model.vector_nonlinear_oracle_constraints)
    return MOI.ConstraintIndex{F,S}(n)
end

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    offset = length(model.qp_data)
    for i in 1:(ci.value-1)
        _, s = model.vector_nonlinear_oracle_constraints[i]
        offset += s.set.output_dimension
    end
    _, s = model.vector_nonlinear_oracle_constraints[ci.value]
    return offset .+ (1:s.set.output_dimension)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    f, _ = model.vector_nonlinear_oracle_constraints[ci.value]
    return MOI.get.(model, MOI.VariablePrimal(attr.result_index), f.variables)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    f, s = model.vector_nonlinear_oracle_constraints[ci.value]
    J = zeros(length(s.set.jacobian_structure))
    x = [MOI.get(model, MOI.VariablePrimal(), xi) for xi in f.variables]
    s.set.eval_jacobian(J, x)
    λ = Float64[
        UnoSolver.uno_get_constraint_dual_solution_component(model.solver, r - 1)
        for r in row(model, ci)
    ]
    dual = zeros(MOI.dimension(s.set))
    sign = _dual_multiplier(model)
    for ((row, col), J_rc) in zip(s.set.jacobian_structure, J)
        dual[col] += sign * λ[row] * J_rc
    end
    return dual
end

function MOI.get(
    model::Optimizer,
    attr::MOI.LagrangeMultiplier,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    λ = Float64[
        UnoSolver.uno_get_constraint_dual_solution_component(model.solver, r - 1)
        for r in row(model, ci)
    ]
    return _dual_multiplier(model) * λ
end

function MOI.supports(
    ::Optimizer,
    ::MOI.LagrangeMultiplierStart,
    ::Type{MOI.ConstraintIndex{F,S}},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.LagrangeMultiplierStart,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    _, cache = model.vector_nonlinear_oracle_constraints[ci.value]
    return cache.start
end

function MOI.set(
    model::Optimizer,
    attr::MOI.LagrangeMultiplierStart,
    ci::MOI.ConstraintIndex{F,S},
    start::Union{Nothing,Vector{Float64}},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    _, cache = model.vector_nonlinear_oracle_constraints[ci.value]
    cache.start = start
    return
end

### UserDefinedFunction

MOI.supports(model::Optimizer, ::MOI.UserDefinedFunction) = true

function MOI.set(model::Optimizer, attr::MOI.UserDefinedFunction, args)
    _init_nlp_model(model)
    MOI.Nonlinear.register_operator(
        model.nlp_model,
        attr.name,
        attr.arity,
        args...,
    )
    return
end

### ListOfSupportedNonlinearOperators

function MOI.get(model::Optimizer, attr::MOI.ListOfSupportedNonlinearOperators)
    _init_nlp_model(model)
    return MOI.get(model.nlp_model, attr)
end

### MOI.VariablePrimalStart

function MOI.supports(
    ::Optimizer,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
)
    if _is_parameter(vi)
        throw(MOI.GetAttributeNotAllowed(attr, "Variable is a Parameter"))
    end
    MOI.throw_if_not_valid(model, vi)
    return model.variable_primal_start[column(vi)]
end

function MOI.set(
    model::Optimizer,
    attr::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
    value::Union{Real,Nothing},
)
    if _is_parameter(vi)
        throw(MOI.SetAttributeNotAllowed(attr, "Variable is a Parameter"))
    end
    MOI.throw_if_not_valid(model, vi)
    model.variable_primal_start[column(vi)] = value
    # No need to reset model.inner and model.solver, because this gets handled in optimize!.
    return
end

### MOI.ConstraintDualStart

_dual_start(::Optimizer, ::Nothing, ::Int = 1) = 0.0

function _dual_start(model::Optimizer, value::Real, scale::Int = 1)
    return _dual_multiplier(model) * value * scale
end

### MOI.NLPBlockDualStart

MOI.supports(::Optimizer, ::MOI.NLPBlockDualStart) = true

function MOI.set(
    model::Optimizer,
    ::MOI.NLPBlockDualStart,
    values::Union{Nothing,Vector},
)
    model.nlp_dual_start = values
    # No need to reset model.inner and model.solver, because this gets handled in optimize!.
    return
end

MOI.get(model::Optimizer, ::MOI.NLPBlockDualStart) = model.nlp_dual_start

### MOI.NLPBlock

MOI.supports(::Optimizer, ::MOI.NLPBlock) = true

# This may also be set by `optimize!` and contain the block created from
# ScalarNonlinearFunction
MOI.get(model::Optimizer, ::MOI.NLPBlock) = model.nlp_data

function MOI.set(model::Optimizer, ::MOI.NLPBlock, nlp_data::MOI.NLPBlockData)
    if model.nlp_model !== nothing
        error("Cannot mix the new and legacy nonlinear APIs")
    end
    model.nlp_data = nlp_data
    model.inner = nothing
    model.solver = nothing
    return
end

### ObjectiveSense

MOI.supports(::Optimizer, ::MOI.ObjectiveSense) = true

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    model.sense = sense
    model.needs_new_inner = true
    model.solver = nothing
    return
end

MOI.get(model::Optimizer, ::MOI.ObjectiveSense) = model.sense

### ObjectiveFunction

function MOI.get(model::Optimizer, attr::MOI.ObjectiveFunctionType)
    if model.nlp_model !== nothing && model.nlp_model.objective !== nothing
        return MOI.ScalarNonlinearFunction
    end
    return MOI.get(model.qp_data, attr)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{Float64},
            MOI.ScalarQuadraticFunction{Float64},
        },
    },
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{F},
) where {
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return convert(F, MOI.get(model.qp_data, attr))
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{F},
    func::F,
) where {
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    MOI.set(model.qp_data, attr, func)
    if model.nlp_model !== nothing
        MOI.Nonlinear.set_objective(model.nlp_model, nothing)
    end
    model.inner = nothing
    model.solver = nothing
    return
end

function MOI.eval_objective(model::Optimizer, x)
    if model.sense == MOI.FEASIBILITY_SENSE
        return 0.0
    elseif model.nlp_data.has_objective
        return MOI.eval_objective(model.nlp_data.evaluator, x)::Float64
    end
    return MOI.eval_objective(model.qp_data, x)
end

function MOI.eval_objective_gradient(model::Optimizer, grad, x)
    if model.sense == MOI.FEASIBILITY_SENSE
        grad .= zero(eltype(grad))
    elseif model.nlp_data.has_objective
        MOI.eval_objective_gradient(model.nlp_data.evaluator, grad, x)
    else
        MOI.eval_objective_gradient(model.qp_data, grad, x)
    end
    return
end

function _eval_constraint(
    g::AbstractVector,
    offset::Int,
    x::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    ret = view(g, offset .+ (1:s.set.output_dimension))
    s.eval_f_timer += @elapsed s.set.eval_f(ret, s.x)
    return offset + s.set.output_dimension
end

function MOI.eval_constraint(model::Optimizer, g, x)
    MOI.eval_constraint(model.qp_data, g, x)
    offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _eval_constraint(g, offset, x, f, s)
    end
    g_nlp = view(g, (offset+1):length(g))
    MOI.eval_constraint(model.nlp_data.evaluator, g_nlp, x)
    return
end

function _jacobian_structure(
    ret::AbstractVector,
    row_offset::Int,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for (i, j) in s.set.jacobian_structure
        push!(ret, (row_offset + i, f.variables[j].value))
    end
    return row_offset + s.set.output_dimension
end

function MOI.jacobian_structure(model::Optimizer)
    J = MOI.jacobian_structure(model.qp_data)
    offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _jacobian_structure(J, offset, f, s)
    end
    if length(model.nlp_data.constraint_bounds) > 0
        J_nlp = MOI.jacobian_structure(
            model.nlp_data.evaluator,
        )::Vector{Tuple{Int64,Int64}}
        for (row, col) in J_nlp
            push!(J, (row + offset, col))
        end
    end
    return J
end

function _eval_constraint_jacobian(
    values::AbstractVector,
    offset::Int,
    x::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    nnz = length(s.set.jacobian_structure)
    s.eval_jacobian_timer +=
        @elapsed s.set.eval_jacobian(view(values, offset .+ (1:nnz)), s.x)
    return offset + nnz
end

function MOI.eval_constraint_jacobian(model::Optimizer, values, x)
    offset = MOI.eval_constraint_jacobian(model.qp_data, values, x)
    offset -= 1  # .qp_data returns one-indexed offset
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _eval_constraint_jacobian(values, offset, x, f, s)
    end
    nlp_values = view(values, (offset+1):length(values))
    MOI.eval_constraint_jacobian(model.nlp_data.evaluator, nlp_values, x)
    return
end

function _hessian_lagrangian_structure(
    ret::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for (i, j) in s.set.hessian_lagrangian_structure
        push!(ret, (f.variables[i].value, f.variables[j].value))
    end
    return
end

function MOI.hessian_lagrangian_structure(model::Optimizer)
    H = MOI.hessian_lagrangian_structure(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        _hessian_lagrangian_structure(H, f, s)
    end
    append!(H, MOI.hessian_lagrangian_structure(model.nlp_data.evaluator))
    return H
end

function _eval_hessian_lagrangian(
    H::AbstractVector,
    H_offset::Int,
    x::AbstractVector,
    μ::AbstractVector,
    μ_offset::Int,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    H_nnz = length(s.set.hessian_lagrangian_structure)
    H_view = view(H, H_offset .+ (1:H_nnz))
    μ_view = view(μ, μ_offset .+ (1:s.set.output_dimension))
    s.eval_hessian_lagrangian_timer +=
        @elapsed s.set.eval_hessian_lagrangian(H_view, s.x, μ_view)
    return H_offset + H_nnz, μ_offset + s.set.output_dimension
end

function MOI.eval_hessian_lagrangian(model::Optimizer, H, x, σ, μ)
    offset = MOI.eval_hessian_lagrangian(model.qp_data, H, x, σ, μ)
    offset -= 1  # model.qp_data returns one-indexed offset
    μ_offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset, μ_offset =
            _eval_hessian_lagrangian(H, offset, x, μ, μ_offset, f, s)
    end
    H_nlp = view(H, (offset+1):length(H))
    μ_nlp = view(μ, (μ_offset+1):length(μ))
    MOI.eval_hessian_lagrangian(model.nlp_data.evaluator, H_nlp, x, σ, μ_nlp)
    return
end

function MOI.eval_constraint_jacobian_product(model::Optimizer, y, x, w)
    @assert isempty(model.vector_nonlinear_oracle_constraints)
    fill!(y, 0.0)
    qp_offset = length(model.qp_data)
    y_nlp = view(y, (qp_offset+1):length(y))
    MOI.eval_constraint_jacobian_product(model.nlp_data.evaluator, y_nlp, x, w)
    MOI.eval_constraint_jacobian_product(model.qp_data, y, x, w)
    return
end

function MOI.eval_constraint_jacobian_transpose_product(model::Optimizer, y, x, w)
    @assert isempty(model.vector_nonlinear_oracle_constraints)
    fill!(y, 0.0)
    qp_offset = length(model.qp_data)
    w_nlp = view(w, (qp_offset+1):length(w))
    MOI.eval_constraint_jacobian_transpose_product(model.nlp_data.evaluator, y, x, w_nlp)
    MOI.eval_constraint_jacobian_transpose_product(model.qp_data, y, x, w)
    return
end

function MOI.eval_hessian_lagrangian_product(model::Optimizer, H, x, v, σ, μ)
    @assert isempty(model.vector_nonlinear_oracle_constraints)
    fill!(H, 0.0)
    qp_offset = length(model.qp_data)
    μ_nlp = view(μ, (qp_offset+1):length(μ))
    MOI.eval_hessian_lagrangian_product(model.nlp_data.evaluator, H, x, v, σ, μ_nlp)
    MOI.eval_hessian_lagrangian_product(model.qp_data, H, x, v, σ, μ)
    return
end

### MOI.AutomaticDifferentiationBackend

MOI.supports(::Optimizer, ::MOI.AutomaticDifferentiationBackend) = true

function MOI.get(model::Optimizer, ::MOI.AutomaticDifferentiationBackend)
    return model.ad_backend
end

function MOI.set(
    model::Optimizer,
    ::MOI.AutomaticDifferentiationBackend,
    backend::MOI.Nonlinear.AbstractAutomaticDifferentiation,
)
    # Setting the backend will invalidate the model if it is different. But we
    # don't requrire == for `::MOI.Nonlinear.AutomaticDifferentiationBackend` so
    # act defensive and invalidate regardless.
    model.inner = nothing
    model.solver = nothing
    model.ad_backend = backend
    return
end

### MOI.optimize!

function _setup_model(model::Optimizer)
    vars = MOI.get(model.variables, MOI.ListOfVariableIndices())
    if isempty(vars)
        model.invalid_model = true
        return
    end
    if model.nlp_model !== nothing
        evaluator = MOI.Nonlinear.Evaluator(model.nlp_model, model.ad_backend, vars)
        model.nlp_data = MOI.NLPBlockData(evaluator)
    end
    has_oracle = !isempty(model.vector_nonlinear_oracle_constraints)
    has_quadratic_constraints =
        any(isequal(_kFunctionTypeScalarQuadratic), model.qp_data.function_type)
    has_nlp_constraints = !isempty(model.nlp_data.constraint_bounds) || has_oracle
    has_nlp_objective = model.nlp_data.has_objective
    has_hessian = :Hess in MOI.features_available(model.nlp_data.evaluator)
    has_jacobian_operator = :JacVec in MOI.features_available(model.nlp_data.evaluator)
    has_hessian_operator = :HessVec in MOI.features_available(model.nlp_data.evaluator)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        if s.set.eval_hessian_lagrangian === nothing
            has_hessian = false
            break
        end
    end
    init_feat = [:Grad]
    if has_hessian
        push!(init_feat, :Hess)
    end
    if has_hessian_operator
        push!(init_feat, :HessVec)
    end
    if has_nlp_constraints
        push!(init_feat, :Jac)
    end
    if has_jacobian_operator
        push!(init_feat, :JacVec)
    end
    MOI.initialize(model.nlp_data.evaluator, init_feat)

    model.hess_available = has_hessian
    model.jprod_available = has_jacobian_operator && !has_oracle
    model.jtprod_available = has_jacobian_operator && !has_oracle
    model.hprod_available = has_hessian_operator && !has_oracle

    jacobian_sparsity = MOI.jacobian_structure(model)
    nnzj = length(jacobian_sparsity)
    jrows = Vector{Cint}(undef, nnzj)
    jcols = Vector{Cint}(undef, nnzj)
    for i in 1:nnzj
        jrows[i], jcols[i] = jacobian_sparsity[i]
    end
    model.jrows = jrows
    model.jcols = jcols

    hessian_sparsity = has_hessian ? MOI.hessian_lagrangian_structure(model) : Tuple{Int,Int}[]
    nnzh = length(hessian_sparsity)
    hrows = Vector{Cint}(undef, nnzh)
    hcols = Vector{Cint}(undef, nnzh)
    for i in 1:nnzh
        hrows[i], hcols[i] = hessian_sparsity[i]
    end
    model.hrows = hrows
    model.hcols = hcols

    if has_hessian && (nnzh == 0)
        model.problem_type = "LP"
    else
        if has_quadratic_constraints || has_nlp_constraints || has_nlp_objective
            model.problem_type = "NLP"
        elseif model.qp_data.objective_function_type == _kFunctionTypeScalarQuadratic
            model.problem_type = "QP"
        else
            @assert (model.qp_data.objective_function_type == _kFunctionTypeVariableIndex) || (model.qp_data.objective_function_type == _kFunctionTypeScalarAffine)
            model.problem_type = "LP"
        end
    end
    model.needs_new_inner = true
    return
end

function _setup_inner(model::Optimizer)::UnoSolver.Model
    if !model.needs_new_inner
        return model.inner
    end
    g_L, g_U = copy(model.qp_data.g_L), copy(model.qp_data.g_U)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        append!(g_L, s.set.l)
        append!(g_U, s.set.u)
    end
    for bound in model.nlp_data.constraint_bounds
        push!(g_L, bound.lower)
        push!(g_U, bound.upper)
    end
    nvar = length(model.variables.lower)
    ncon = length(g_L)
    nnzj = length(model.jrows)
    nnzh = length(model.hrows)

    moi_objective(model, x) = MOI.eval_objective(model, x)
    moi_objective_gradient(model, g, x) = MOI.eval_objective_gradient(model, g, x)
    moi_constraints(model, c, x) = MOI.eval_constraint(model, c, x)
    moi_jacobian(model, jvals, x) = MOI.eval_constraint_jacobian(model, jvals, x)
    moi_lagrangian_hessian(model, hvals, x, multipliers, objective_multiplier) = MOI.eval_hessian_lagrangian(model, hvals, x, objective_multiplier, multipliers)
    moi_jacobian_operator(model, Jv, x, v, evaluate_at_x) = MOI.eval_constraint_jacobian_product(model, Jv, x, v)
    moi_jacobian_transposed_operator(model, Jtv, x, v, evaluate_at_x) = MOI.eval_constraint_jacobian_transpose_product(model, Jtv, x, v)
    moi_lagrangian_hessian_operator(model, Hv, x, objective_multiplier, multipliers, v, evaluate_at_x) = MOI.eval_hessian_lagrangian_product(model, Hv, x, v, objective_multiplier, multipliers)

    model.inner = UnoSolver.uno_model(
        model.problem_type,
        model.sense == MOI.MIN_SENSE,
        nvar,
        ncon,
        model.variables.lower,
        model.variables.upper,
        g_L,
        g_U,
        model.jrows,
        model.jcols,
        nnzj,
        model.hrows,
        model.hcols,
        nnzh,
        moi_objective,
        moi_constraints,
        moi_objective_gradient,
        moi_jacobian,
        model.hess_available ? moi_lagrangian_hessian : nothing,
        model.jprod_available ? moi_jacobian_operator : nothing,
        model.jtprod_available ? moi_jacobian_transposed_operator : nothing,
        model.hprod_available ? moi_lagrangian_hessian_operator : nothing,
        model,
        'L',
        1,
    )
    model.needs_new_inner = false
    return model.inner
end

function _setup_solver(model::Optimizer)::UnoSolver.Solver
    # We could reuse the C++ workspace in the future
    model.solver = UnoSolver.uno_solver()
    return model.solver
end

function MOI.optimize!(model::Optimizer)
    if model.inner === nothing
        _setup_model(model)
    end
    if model.invalid_model
        return
    end

    inner = _setup_inner(model)
    solver = _setup_solver(model)

    if model.nlp_model !== nothing
        empty!(model.qp_data.parameters)
        for (p, index) in model.parameters
            model.qp_data.parameters[p.value] = model.nlp_model[index]
        end
    end

    # The default logger is "INFO".
    UnoSolver.uno_set_solver_string_option(solver, "logger", model.silent ? "SILENT" : "INFO")

    # If provided, set the preset before any other options.
    if haskey(model.options, "preset")
        UnoSolver.uno_set_solver_preset(solver, model.options["preset"])
    end

    # Other misc options that over-ride the ones set above.
    for (name, value) in model.options
        (name == "preset") && continue
        if value isa String
            @assert UnoSolver.uno_set_solver_string_option(solver, name, value)
        elseif value isa Float64
            @assert UnoSolver.uno_set_solver_double_option(solver, name, value)
        elseif value isa Bool
            @assert UnoSolver.uno_set_solver_bool_option(solver, name, value)
        elseif value isa Integer
            @assert UnoSolver.uno_set_solver_integer_option(solver, name, Cint(value))
        else
            error(
                "Unable to add option `\"$name\"` with the value " *
                "`$value::$(typeof(value))`. The value must be a `::String`, a `::Float64`, an `::Integer`, or a `::Bool`.",
            )
        end
    end

    # Initialize the starting point, projecting variables from 0 onto their
    # bounds if VariablePrimalStart is not provided.
    for i in 1:length(model.variable_primal_start)
        x0_i = something(
            model.variable_primal_start[i],
            clamp(0.0, model.variables.lower[i], model.variables.upper[i]),
        )
        UnoSolver.uno_set_initial_primal_iterate_component(inner, i-1, x0_i)
    end

    for (i, start) in enumerate(model.qp_data.mult_g)
        y0_i = _dual_start(model, start, -1)
        UnoSolver.uno_set_initial_dual_iterate_component(inner, i-1, y0_i)
    end
    offset = length(model.qp_data.mult_g)
    if model.nlp_dual_start === nothing
        for i in offset+1:inner.ncon
            UnoSolver.uno_set_initial_dual_iterate_component(inner, i-1, 0.0)
        end
        # First there is VectorNonlinearOracle...
        for (_, cache) in model.vector_nonlinear_oracle_constraints
            if cache.start !== nothing
                for i in 1:cache.set.output_dimension
                    UnoSolver.uno_set_initial_dual_iterate_component(inner, offset+i-1, _dual_start(model, cache.start[i], -1))
                end
            end
            offset += cache.set.output_dimension
        end
        # ...then come the ScalarNonlinearFunctions
        for (key, val) in model.mult_g_nlp
            UnoSolver.uno_set_initial_dual_iterate_component(inner, offset+key.value-1, _dual_start(model, val, -1))
        end
    else
        for (i, start) in enumerate(model.nlp_dual_start::Vector{Float64})
            y0_i = _dual_start(model, start, -1)
            UnoSolver.uno_set_initial_dual_iterate_component(inner, offset+i-1, y0_i)
        end
    end

    # Clear timers
    for (_, s) in model.vector_nonlinear_oracle_constraints
        s.eval_f_timer = 0.0
        s.eval_jacobian_timer = 0.0
        s.eval_hessian_lagrangian_timer = 0.0
    end
    UnoSolver.uno_optimize(solver, inner)
    return
end

function _status_code_mapping(uno_termination_status::Cint, uno_solution_status::Cint)
    if uno_termination_status == UnoSolver.UNO_ITERATION_LIMIT
        return (MOI.ITERATION_LIMIT, MOI.UNKNOWN_RESULT_STATUS) # here we could test feasibility
    elseif uno_termination_status == UnoSolver.UNO_TIME_LIMIT
        return (MOI.TIME_LIMIT, MOI.UNKNOWN_RESULT_STATUS) # here we could test feasibility
    elseif uno_termination_status == UnoSolver.UNO_EVALUATION_ERROR
        return (MOI.INVALID_MODEL, MOI.UNKNOWN_RESULT_STATUS)
    elseif uno_termination_status == UnoSolver.UNO_ALGORITHMIC_ERROR
        return (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS)
    else # UNO_SUCCESS
        if uno_solution_status == UnoSolver.UNO_FEASIBLE_KKT_POINT
            return (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT)
        elseif uno_solution_status == UnoSolver.UNO_FEASIBLE_FJ_POINT
            return (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT)
        elseif uno_solution_status == UnoSolver.UNO_INFEASIBLE_STATIONARY_POINT
            return (MOI.LOCALLY_INFEASIBLE, MOI.INFEASIBLE_POINT)
        elseif uno_solution_status == UnoSolver.UNO_FEASIBLE_SMALL_STEP
            return (MOI.SLOW_PROGRESS, MOI.FEASIBLE_POINT)
        elseif uno_solution_status == UnoSolver.UNO_INFEASIBLE_SMALL_STEP
            return (MOI.SLOW_PROGRESS, MOI.INFEASIBLE_POINT)
        else # UNO_UNBOUNDED
            return (MOI.DUAL_INFEASIBLE, MOI.FEASIBLE_POINT)
        end
    end
end

### MOI.ResultCount

# Uno always has an iterate available.
function MOI.get(model::Optimizer, ::MOI.ResultCount)
    return (model.inner !== nothing && model.solver !== nothing) ? 1 : 0
end

### MOI.TerminationStatus

function MOI.get(model::Optimizer, ::MOI.TerminationStatus)
    if model.invalid_model
        return MOI.INVALID_MODEL
    elseif model.inner === nothing || model.solver === nothing
        return MOI.OPTIMIZE_NOT_CALLED
    end
    uno_termination_status = UnoSolver.uno_get_optimization_status(model.solver)
    uno_solution_status = UnoSolver.uno_get_solution_status(model.solver)
    termination_status, _ = _status_code_mapping(uno_termination_status, uno_solution_status)
    return termination_status
end

### MOI.RawStatusString

function MOI.get(model::Optimizer, ::MOI.RawStatusString)
    if model.invalid_model
        return "The model has no variable"
    elseif model.inner === nothing || model.solver === nothing
        return "Optimize not called"
    end
    uno_status = UnoSolver.uno_get_optimization_status(model.solver)
    return string(uno_status)
end

### MOI.PrimalStatus

function _manually_evaluated_primal_status(model::Optimizer)
    # Alexis -- revisit this code when we know how to handle the workspace
    # x, g = model.inner.x, model.inner.g
    x = Vector{Float64}(undef, model.inner.nvar)
    UnoSolver.uno_get_primal_solution(model.solver, x)
    g = Vector{Float64}(undef, model.inner.ncon)
    MOI.eval_constraint(model, g, x)

    x_L, x_U = model.variables.lower, model.variables.upper
    g_L, g_U = copy(model.qp_data.g_L), copy(model.qp_data.g_U)
    # Assuming constraints are guaranteed to be in the order:
    # [qp_cons, nlp_cons, oracle]
    for bound in model.nlp_data.constraint_bounds
        push!(g_L, bound.lower)
        push!(g_U, bound.upper)
    end
    for (_, cache) in model.vector_nonlinear_oracle_constraints
        append!(g_L, cache.set.l)
        append!(g_U, cache.set.u)
    end
    m, n = length(g_L), length(x)
    # 1e-8 is the default primal tolerance
    tol = get(model.options, "primal_tolerance", 1e-8)
    if all(x_L[i] - tol <= x[i] <= x_U[i] + tol for i in 1:n) &&
       all(g_L[i] - tol <= g[i] <= g_U[i] + tol for i in 1:m)
        return MOI.FEASIBLE_POINT
    end
    # 1e-6 is the default acceptable tolerance
    atol = get(model.options, "loose_primal_tolerance", 1e-6)
    if all(x_L[i] - atol <= x[i] <= x_U[i] + atol for i in 1:n) &&
       all(g_L[i] - atol <= g[i] <= g_U[i] + atol for i in 1:m)
        return MOI.NEARLY_FEASIBLE_POINT
    end
    return MOI.INFEASIBLE_POINT
end

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    if !(1 <= attr.result_index <= MOI.get(model, MOI.ResultCount()))
        return MOI.NO_SOLUTION
    end
    uno_termination_status = UnoSolver.uno_get_optimization_status(model.solver)
    uno_solution_status = UnoSolver.uno_get_solution_status(model.solver)
    _, primal_status = _status_code_mapping(uno_termination_status, uno_solution_status)
    if primal_status == MOI.UNKNOWN_RESULT_STATUS
        return _manually_evaluated_primal_status(model)
    end
    return primal_status
end

### MOI.DualStatus

function MOI.get(model::Optimizer, attr::MOI.DualStatus)
    if !(1 <= attr.result_index <= MOI.get(model, MOI.ResultCount()))
        return MOI.NO_SOLUTION
    end
    uno_termination_status = UnoSolver.uno_get_optimization_status(model.solver)
    uno_solution_status = UnoSolver.uno_get_solution_status(model.solver)
    _, dual_status = _status_code_mapping(uno_termination_status, uno_solution_status)
    return dual_status
end

### MOI.SolveTimeSec

MOI.get(model::Optimizer, ::MOI.SolveTimeSec) = isnothing(model.solver) ? NaN : UnoSolver.uno_get_cpu_time(model.solver)

### MOI.BarrierIterations

MOI.get(model::Optimizer, ::MOI.BarrierIterations) = isnothing(model.solver) ? 0 : UnoSolver.uno_get_number_iterations(model.solver)

### MOI.ObjectiveValue

function MOI.get(model::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(model, attr)
    obj_val = UnoSolver.uno_get_solution_objective(model.solver)
    return obj_val
end

### MOI.VariablePrimal

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimal,
    vi::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, vi)
    if _is_parameter(vi)
        p = model.parameters[vi]
        return model.nlp_model[p]
    end
    return UnoSolver.uno_get_primal_solution_component(model.solver, column(vi)-1)
end

### MOI.ConstraintPrimal

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return ci.value
end

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction},
)
    offset = length(model.qp_data)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        offset += s.set.output_dimension
    end
    return offset + ci.value
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{<:_FUNCTIONS,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    # Alexis -- revisit this code when we know how to handle the workspace
    # model.inner.g[row(model, ci)]
    x = Vector{Float64}(undef, model.inner.nvar)
    UnoSolver.uno_get_primal_solution(model.solver, x)
    g = Vector{Float64}(undef, model.inner.ncon)
    MOI.eval_constraint(model, g, x)
    return g[row(model, ci)]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    # Alexis -- revisit this code when we know how to handle the workspace
    # model.inner.x[ci.value]
    x = Vector{Float64}(undef, model.inner.nvar)
    UnoSolver.uno_get_primal_solution(model.solver, x)
    return x[ci.value]
end

### MOI.ConstraintDual

function _dual_multiplier(model::Optimizer)
    multiplier = (model.sense == MOI.MAX_SENSE) ? 1.0 : -1.0
    return multiplier
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{<:_FUNCTIONS,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    λ = UnoSolver.uno_get_constraint_dual_solution_component(model.solver, row(model, ci)-1)
    return _dual_multiplier(model) * λ
end

_reduced_cost_to_dual(::Type{S}, rc) where {S} = rc
_reduced_cost_to_dual(::Type{MOI.GreaterThan{Float64}}, rc) = max(0.0, rc)
_reduced_cost_to_dual(::Type{MOI.LessThan{Float64}}, rc) = min(0.0, rc)

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S<:_SETS}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    xL_i = UnoSolver.uno_get_lower_bound_dual_solution_component(model.solver, ci.value-1)
    xU_i = UnoSolver.uno_get_upper_bound_dual_solution_component(model.solver, ci.value-1)
    return _reduced_cost_to_dual(S, _dual_multiplier(model) * (xL_i + xU_i))
end

### MOI.NLPBlockDual

function MOI.get(model::Optimizer, attr::MOI.NLPBlockDual)
    MOI.check_result_index_bounds(model, attr)
    s = _dual_multiplier(model)
    return Float64[
        s * UnoSolver.uno_get_constraint_dual_solution_component(model.solver, i)
        for i in length(model.qp_data):(model.inner.ncon-1)
    ]
end

#!/usr/bin/env bash
set -e

# detect OS
OS_NAME="$(uname -s)"
case "$OS_NAME" in
    Linux*)  OS="linux-gnu";;
    Darwin*) OS="apple-darwin";;
    Windows*) OS="w64-mingw32";;
    MINGW64_NT*) OS="w64-mingw32";;
    MSYS_NT*) OS="w64-mingw32";;
    *) echo "Unsupported OS: $OS_NAME"; exit 1;;
esac
# detect architecture
ARCH_NAME="$(uname -m)"
case "$ARCH_NAME" in
    x86_64|amd64) ARCH="x86_64";;
    arm64|aarch64) ARCH="aarch64";;
    *) echo "Unknown architecture '$ARCH_NAME'."; exit 1;;
esac

# change directory
cd dependencies

# download BQPD
VERSION="v1.0.0"
REPO="https://github.com/leyffer/BQPD_jll.jl/releases/download/BQPD-${VERSION}%2B0"
ASSET_NAME="BQPD.${VERSION}.${ARCH}-${OS}-libgfortran5.tar.gz"
ASSET_URL="${REPO}/${ASSET_NAME}"
echo "Downloading: ${ASSET_URL}"
curl -L -o BQPD.tar.gz "$ASSET_URL"
tar -xzvf BQPD.tar.gz
pwd

# download UnoUtils: MUMPS (+ METIS, BLAS and LAPACK) and HiGHS
VERSION="2026.2.17"
REPO="https://github.com/amontoison/UnoUtils_jll.jl/releases/download/UnoUtils-v${VERSION}%2B0"
ASSET_NAME="UnoUtils.v${VERSION}.${ARCH}-${OS}-libgfortran5.tar.gz"
ASSET_URL="${REPO}/${ASSET_NAME}"
echo "Downloading: ${ASSET_URL}"
curl -L -o UnoUtils.tar.gz "$ASSET_URL"
tar -xzvf UnoUtils.tar.gz
pwd

# delete unwanted directories
# rm -rf lib/cmake/cblas* lib/cmake/lapack* lib/pkgconfig
rm -rf lib/cmake lib/pkgconfig

if [[ "$OS" == "w64-mingw32" ]]; then
    cd ..
    ASSET_URL="https://github.com/JuliaLang/PackageCompiler.jl/releases/download/v1.0.0/x86_64-8.1.0-release-posix-seh-rt_v6-rev0.tar.gz"
    curl -L -o libstdc++.tar.gz "$ASSET_URL"
    tar -xzvf libstdc++.tar.gz
    cp ./mingw64/lib/gcc/x86_64-w64-mingw32/8.1.0/libstdc++.a ./dependencies/lib/libstdc++.a
fi

# Uno presets

Uno implements presets, that is combinations of ingredients that correspond to existing solvers. At the moment, the available presets are `filtersqp` (after the trust-region restoration filter SQP solver filterSQP) and `ipopt` (after the line-search filter restoration infeasible interior-point solver IPOPT). We show below how the eight ingredients naturally arise in these two methods.

## Trust-region restoration filter SQP

Convergence of SQP filter methods has been proven under mild conditions in the context of trust-region methods and of line-search methods. The trust-region optimality QP subproblem about $(x^{(k)}, y^{(k)})$ is defined as:

$$
\tag{$QP^{(k)}(\Delta^{(l)})$}
\begin{array}{ll} \displaystyle
\min_{d_x}  & \frac{1}{2} d_x^T H_1^{(k)} d_x + (\nabla f^{(k)})^T d_x \\
\mbox{s.t.} & c^{(k)} + (\nabla c^{(k)})^T d_x = 0 \\
				& x^{(k)} + d_x \ge 0 \\
				& \|d_x\|_\infty \le \Delta^{(l)},
\end{array}
$$

where $\Delta^{(l)} > 0$ is the current trust-region radius. If the QP subproblem is infeasible ($\Delta^{(l)}$ is too small or the linearized constraints are inconsistent), we switch to feasibility restoration and solve a smooth reformulation of the $\ell_1$ feasibility problem with elastic variables $u^+ \in \mathbb{R}^m$ and $u^- \in \mathbb{R}^m$:

$$
\tag{$FQP^{(k)}(\Delta^{(l)})$}
\begin{array}{ll} \displaystyle
\min_{d_x, u^+, u^-} & \frac{1}{2} d_x^T H_0^{(k)} d_x + e^T u^+ + e^T u^- \\
\mbox{s.t.} 			& c^{(k)} + (\nabla c^{(k)})^T d_x - u^+ + u^- = 0 \\
							& x^{(k)} + d_x \ge 0 \\
							& \|d_x\|_\infty \le \Delta^{(l)} \\
							& u^+ \ge 0, \; u^- \ge 0.
\end{array}
$$

If the trial iterate $x^{(k)} + d_x$ makes sufficient progress with respect to the filter method, it is accepted. If the trust region was active at the solution of the QP ($\|d_x^*\|_\infty = \Delta^{(l)}$), we enlarge the radius. If the trial iterate is rejected, we resolve the trust-region subproblem with a smaller trust-region radius.

## Line-search filter restoration infeasible interior-point method

An infeasible interior-point method does not require feasibility with respect to the general constraints. A prerequisite is to turn inequality constraints into equality constraints using slack variables:

$$
\begin{array}{ll} \displaystyle
\min_{x,s}  & f(x) \\
\mbox{s.t.} & c(x) - s = 0 \\
				& l_x \le x \le u_x \\
				& l_c \le s \le u_c.
\end{array}
$$

Provided that the subproblem is convex, the primal-dual direction is the solution of the primal-dual system:

$$
\tag{$IPSP_\mu$}
\begin{pmatrix}
H_1^{(k)} + (X^{(k)})^{-1} Z^{(k)} + \delta_w I & \nabla c^{(k)} \\
(\nabla c^{(k)})^T & -\delta_c I
\end{pmatrix}
\begin{pmatrix} d_x \\ -d_y \end{pmatrix}
= -
\begin{pmatrix}
\nabla f^{(k)} - \nabla c^{(k)} y^{(k)} - \mu (X^{(k)})^{-1} e \\
c^{(k)}
\end{pmatrix},
$$

where $X^{(k)} = \text{diag}(x^{(k)})$, $Z^{(k)} = \text{diag}(z^{(k)})$, $e$ is a vector of ones of appropriate size, and $\delta_w$ and $\delta_c$ are primal and dual inertia correction coefficients. The dual direction for the bound constraints is given by $d_z = (X^{(k)})^{-1} (\mu e - Z^{(k)} d_x) - z^{(k)}$. The fraction-to-boundary rule determines primal and dual step lengths that maintain positivity of $x$ and $z$:

$$
\begin{array}{ll}
\alpha_x^{(k)} & \stackrel{\text{def}}{=} \max\{\alpha \in (0, 1] \mid x^{(k)} + \alpha d_x \ge (1 - \tau) x^{(k)}\} \\
\alpha_z^{(k)} & \stackrel{\text{def}}{=} \max\{\alpha \in (0, 1] \mid z^{(k)} + \alpha d_z \ge (1 - \tau) z^{(k)}\},
\end{array}
$$

where $\tau$ is a parameter close to 1. A filter line search assesses whether the trial iterate makes sufficient progress with respect to the filter method. If the step length ultimately falls below a given threshold (e.g., $10^{-7}$), we switch to feasibility restoration. Note that by construction the filter entries depend on the barrier parameter $\mu$ through the auxiliary measure $\xi$. Consequently, the filter must be flushed whenever $\mu$ is updated.

# Acknowledgments

This work was supported by the Applied Mathematics activity within U.S. Department of Energy, Office of Science, Advanced Scientific Computing Research, under Contract DE-AC02-06CH11357.

We would like to thank David Kiessling (KU Leuven) for fruitful discussions about constrained optimization and his extensive testing of Uno, Nils-Christian Kempke (Cardinal Operations) for his valuable help with technical questions in C++, and Gail Pieper (Argonne National Laboratory) for proofreading our manuscript.

We are highly grateful to the following individuals who contributed their expertise and time to the open-source implementation of Uno: Oscar Dowson, Marcel Jacobse, David Kiessling, Rujia Liu, Stefano Lovato, Alexis Montoison, Manuel Schaich, and Silvio Traversaro. We have greatly benefited from their careful contributions and discussions.

## Installation instructions

### Packages and libraries

* install BLAS and LAPACK:
```console
sudo apt install libblas-dev liblapack-dev
```
* install cmake (and optionally ccmake, CMake curses interface):
```console
sudo apt install cmake cmake-curses-gui
```

* **(optional)** download the AMPL solver library (ASL): http://www.netlib.org/ampl/solvers/

* **(optional)** download  solvers:
    * BQPD (null-space active set solver for nonconvex quadratic programming): get a precompiled binary for your architecture (https://github.com/leyffer/BQPD_jll.jl/releases) or get in touch with Sven Leyffer to apply for an academic license (https://www.mcs.anl.gov/~leyffer/solvers.html)
    * MA57 (sparse indefinite symmetric linear solver): http://www.hsl.rl.ac.uk/catalogue/ma57.html
    * LIBHSL (collection of libraries for sparse linear systems): https://licences.stfc.ac.uk/products/Software/HSL/LibHSL
    * MUMPS (sparse indefinite symmetric linear solver): https://mumps-solver.org/index.php?page=dwnld
    * SSIDS (sparse indefinite symmetric linear solver): https://github.com/ralna/spral
    * HiGHS (linear programming and convex quadratic programming solver): https://highs.dev

* to compile MUMPS in sequential mode, remove the flag `-fopenmp` at the end of your `Makefile.inc` and set the following variables:
```console
INCS = $(INCSEQ)
LIBS = $(LIBSEQ)
LIBSEQNEEDED = libseqneeded
```

* compile SSIDS without OpenMP with the Meson flag `-Dopenmp=false`

* you may experience a short lag at startup (about 1/4s) when running Uno with SSIDS. This is due to `hwloc` (hardware locality), a tool that aims at discovering hardware resources in parallel architectures. To precompute the required topology, run the following commands before running Uno:
```
lstopo --of xml ~/.config/hwloc-topology.xml
echo 'export HWLOC_XMLFILE=$HOME/.config/hwloc-topology.xml' >> ~/.bashrc
```

### Compilation

1. Create a `build` directory in the main directory and move to it:
```console
mkdir build && cd build
```
2. Execute cmake:  
```console
cmake [options] ..
```
You can pass the following options:
- build type: `-DCMAKE_BUILD_TYPE=[Release|Debug]`
- build the Uno static library `uno_static`: `-DBUILD_STATIC_LIBS=[ON|OFF]`
- build the Uno shared library `uno_shared`: `-DBUILD_SHARED_LIBS=[ON|OFF]`
- path to the BQPD library: `-DBQPD=path_to_libbqpd`
- path to the MA27 library: `-DMA57=path_to_libma27`
- path to the MA57 library: `-DMA57=path_to_libma57`
- path to ASL library: `-DAMPLSOLVER=path_to_libamplsolver`
- path to HiGHS library: `-DHIGHS=path_to_libhighs`
- path to HSL library: `-DHSL=path_to_libhsl`
- path to METIS library (`fakemetis` is built with MA57): `-DMETIS=path_to_libmetis`
- path to MUMPS library: `-DMUMPS_LIBRARY=path_to_libdmumps`
- path to MUMPS common library: `-DMUMPS_COMMON_LIBRARY=path_to_libmumps_common`
- path to MUMPS PORD library: `-DMUMPS_PORD_LIBRARY=path_to_mumps_libpord`
- path to MUMPS MPISEQ library: `-DMUMPS_MPISEQ_LIBRARY=path_to_mumps_mpiseq_lib`
- path to MUMPS include directory: `-DMUMPS_INCLUDE_DIR=path_to_mumps_include_dir`
- path to SPRAL library: `-DSPRAL=path_to_libspral`

3. **(or)** Use ccmake to provide the paths to the required and optional libraries:
```console
ccmake ..
```
4. Compile (in parallel: `n` being the number of threads, e.g. 6):
```console
make -jn
```

To compile the code with different configurations, simply create a `build` directory for each configuration and perform instructions 1 to 4.

### Install

5. Install the built libraries and header (`uno_static`, `uno_shared` and `Uno_C_API.h`):
```console
sudo make install
```

### Unit tests

6. Install the GoogleTest suite:
```console
sudo apt install googletest
```
7. Compile the test suite:
```console
make run_unotest -jn
```
8. Run the test suite:
```console
./run_unotest
```

### Precompiled libraries and executables

We provide precompiled Uno libraries and executables in the [releases tab](https://github.com/cvanaret/Uno/releases/latest/) for Linux (x64 and aarch64), macOS (x64 and aarch64), and Windows (x64).

On some platforms, the dynamic linker needs to know where to look for libraries at runtime.
You might need to set the following environment variables:

- `LD_LIBRARY_PATH` on Linux
- `DYLD_LIBRARY_PATH` or `DYLD_FALLBACK_LIBRARY_PATH` on macOS
- `PATH` on Windows

These variables should include the directory where you extracted the library files.
For all platforms, the environment variable `PATH` is needed to locate the binary `uno_ampl` / `uno_ampl.exe`.

**Example for Linux**:
```console
tar -xzf Uno.vX.Y.Z.linux.tar.gz
export LD_LIBRARY_PATH=/path/to/extracted/Uno/lib:$LD_LIBRARY_PATH
export PATH=/path/to/extracted/Uno/bin:$PATH
```

Note: The shared library `libhsl.so` / `libhsl.dylib` / `libhsl.dll` provided in the precompiled archive is a dummy version that does not include the official HSL linear solvers such as `MA27` or `MA57`.
However, it can be safely replaced with the official precompiled [libHSL](https://licences.stfc.ac.uk/products/Software/HSL/LibHSL) library without the need to recompile anything.
The routine symbols are identical, allowing seamless hot-swapping of the library.

# Unification framework

## Notation and stationarity conditions

### Notation

We start by defining the scaled Lagrangian or Fritz John function of (NLP) at $(x, y, z, \pi)$:

$$\mathcal{L}_\pi(x, y, z) \stackrel{\text{def}}{=} \pi f(x) - y^T c(x) - z^T x = \pi f(x) - \sum_{j=1}^m y_j c_j(x) - \sum_{i=1}^n z_i x_i,$$

where $y$ and $z \ge 0$ are the Lagrange multipliers of the general constraints $c(x) = 0$ and the bound constraints $x \ge 0$, respectively, and $\pi \ge 0$ is an objective multiplier that is introduced to handle infeasibility or lack of constraint qualification (CQ) in a consistent way.

$\nabla_x \mathcal{L}_\pi(x, y, z)$ is the gradient of the scaled Lagrangian with respect to $x$:

$$\nabla_x \mathcal{L}_\pi(x, y, z) \stackrel{\text{def}}{=} \pi \nabla f(x) - \sum_{j=1}^m y_j \nabla c_j(x) - z.$$

$\nabla^2_{xx} \mathcal{L}_\pi(x, y)$ is the Hessian of the scaled Lagrangian with respect to $x$:

$$\nabla^2_{xx} \mathcal{L}_\pi(x, y) = \pi \nabla^2 f(x) - \sum_{j=1}^m y_j \nabla^2 c_j(x).$$

### First-order stationarity conditions

We are primarily concerned with first-order stationary points. The first-order optimality conditions (aka Fritz John conditions) of problem (NLP) at a stationary point $x^*$ state that there exist $(\pi^*, y^*, z^*)$ such that:

$$\text{(stationarity)} \quad \nabla_x \mathcal{L}_{\pi^*}(x^*, y^*, z^*) = 0$$

$$\text{(primal feasibility)} \quad c(x^*) = 0, \quad x^* \ge 0$$

$$\text{(dual feasibility)} \quad \pi^* \ge 0, \quad z_i^* \geq 0, \quad (\pi^*, y^*, z^*) \not= (0, 0, 0)$$

$$\text{(complementarity)} \quad x_i^* z_i^* = 0, \quad \forall i \in \{1, \ldots, n\}.$$

If $\pi^* > 0$, the optimality conditions are equivalent to the KKT conditions, which can be recovered by scaling the stationarity equation by $1/\pi^*$. If $\pi^* = 0$, they characterize Fritz John points, that is, feasible points at which a constraint qualification is violated.

## A unifying framework for nonlinearly constrained optimization

A local quadratic approximation of (NLP) at iteration $k$ about the current primal-dual point is given by:

$$
\begin{array}{ll} \displaystyle
\min_x      & \frac{1}{2} (x - x^{(k)})^T H^{(k)} (x - x^{(k)}) + (\nabla f^{(k)})^T (x - x^{(k)}) \\
\mbox{s.t.} & c^{(k)} + (\nabla c^{(k)})^T (x - x^{(k)}) = 0 \\
				& x \ge 0,
\end{array}
$$

where $H(x, y)$ is any approximation of $\nabla^2_{xx} \mathcal{L}_\pi(x, y)$, and the superscript $(k)$ denotes evaluation at the current iterate. For convex equality-constrained problems, an iteration can be interpreted as taking a Newton step on the first-order optimality conditions of the problem, hence the name *Lagrange-Newton methods*.

In this section we introduce a unified view for describing Lagrange-Newton methods and argue that they can be assembled by combining **eight generic building blocks or *ingredients***. These ingredients are organized in four layers:

- the **reformulation** layer:
  - a **constraint relaxation strategy** constructs feasible subproblems by relaxing the general constraints;
  - an **inequality handling method** handles the inequality constraints;
- the **subproblem** layer:
  - a **Hessian model** determines the approximation of the Lagrangian Hessian;
  - an **inertia correction strategy** corrects the inertia of the Lagrangian Hessian or of the KKT matrix;
- the **subproblem solver** layer:
  - a **subproblem solver** approximately solves the subproblem by exploiting its characteristics, such as convexity, presence of constraints, presence of bounds, and presence of inequality constraints;
- the **globalization** layer:
  - a **globalization strategy** determines whether a trial iterate makes sufficient progress toward a solution and accepts or rejects it; and
  - a **globalization mechanism** controls the length of the direction and defines the recourse action taken when a trial iterate is rejected.

The role of each ingredient is shown in the following abstract algorithm.

**Algorithm 1 (Abstract algorithm).**

> **Input:** initial point $(x^{(0)}, y^{(0)}, z^{(0)})$  
> Set $k \gets 0$  
> **while** termination criteria at $(x^{(k)}, y^{(k)}, z^{(k)})$ not met **do**  
> &emsp;**repeat**  
> &emsp;&emsp;Solve a (sequence of) feasible subproblem(s) that approximate(s) (NLP) at $(x^{(k)}, y^{(k)}, z^{(k)})$  
> &emsp;&emsp;Assemble trial iterate $(\hat{x}^{(k+1)}, \hat{y}^{(k+1)}, \hat{z}^{(k+1)})$  
> &emsp;**until** $(\hat{x}^{(k+1)}, \hat{y}^{(k+1)}, \hat{z}^{(k+1)})$ is acceptable  
> &emsp;Update $(x^{(k+1)}, y^{(k+1)}, z^{(k+1)}) \gets (\hat{x}^{(k)}, \hat{y}^{(k)}, \hat{z}^{(k)})$  
> &emsp;$k \gets k + 1$  
> **end while**  
> **Output:** $(x^{(k)}, y^{(k)}, z^{(k)})$

The inner loop (**repeat**) generates and solves a feasible subproblem (possibly a sequence of feasible subproblems) until a trial iterate is accepted by the globalization strategy, and the outer loop (**while**) generates a sequence of acceptable iterates until termination.

The "wheel of strategies" below organizes a wide range of strategies into a coherent hierarchy. The outer layer represents the optimization layers, the middle layer represents the ingredients, and the inner layer represents the strategies. Strategies that perform similar tasks within an optimization method are listed under the same ingredient (e.g., a line search and a trust-region method are both globalization mechanisms).

<p align="center">
   <img src="../figures/wheel.png" alt="Unifying framework: the wheel of strategies." width="60%" />
</p>

## Unified view of state-of-the-art techniques

In this section we describe a set of strategies that fall into each of the following ingredients of our unifying framework: globalization strategies, constraint relaxation strategies, inequality handling methods, Hessian models, inertia correction strategies, and globalization mechanisms. Our goal is to illustrate the wide variety of methods within a common notation to motivate the design of our modular solver.

### Globalization strategies

Constrained optimization methods must achieve two competing goals: minimizing the objective function and minimizing the constraint violation. Globalization strategies determine whether a trial iterate $\hat{x}^{(k+1)} \stackrel{\text{def}}{=} x^{(k)} + \alpha d_x^{(k)}$ (for a given step length $\alpha \in (0, 1]$) makes acceptable progress with respect to these goals. We consider strategies that ensure *global convergence*, that is, convergence to a local minimum, or (weaker) stationary point, from any starting point.

Three (possibly primal-dual) *progress measures* are monitored throughout the optimization process:

1. an **infeasibility measure** $\eta$ (typically $\|c(x)\|$ for some norm);
2. an **objective measure** $\omega_\pi$ parameterized by the objective multiplier $\pi \ge 0$ (typically $\pi f(x)$); and
3. an **auxiliary measure** $\xi$ (terms such as barrier and proximal terms).

The local models of $\eta(x)$, $\omega_\pi(x)$, and $\xi(x)$ at iteration $k$ about the current iterate are denoted by $\mathbf{\eta}^{(k)}(d_x)$, $\mathbf{\omega}_\pi^{(k)}(d_x)$, and $\mathbf{\xi}^{(k)}(d_x)$ for a given primal direction $d_x$. We define the respective *predicted reductions*:

$$\Delta \mathbf{\eta}^{(k)}(d_x) \stackrel{\text{def}}{=} \mathbf{\eta}^{(k)}(0) - \mathbf{\eta}^{(k)}(d_x)$$

$$\Delta \mathbf{\omega}_\pi^{(k)}(d_x) \stackrel{\text{def}}{=} \mathbf{\omega}_\pi^{(k)}(0) - \mathbf{\omega}_\pi^{(k)}(d_x)$$

$$\Delta \mathbf{\xi}^{(k)}(d_x) \stackrel{\text{def}}{=} \mathbf{\xi}^{(k)}(0) - \mathbf{\xi}^{(k)}(d_x)$$

In order to ensure convergence, the progress measures and their local models must be intimately linked to the definitions of the problem and the subproblem.

The two main classes of globalization strategies are merit functions and filter methods (Figure 2). They typically enforce a sufficient decrease condition that forces some scalar combination of $\eta$, $\omega_\pi$, and $\xi$ to decrease by at least a fraction of the decrease predicted by the local model.

![Example of a filter and a merit function.](figures/globalization_strategies.png)

**Figure 2.** Example of a filter and a merit function.

#### Merit functions

A merit (or penalty) function combines the three goals $\eta$, $\omega_\rho$, and $\xi$ into a single scalar value:

$$\psi_\rho(x) \stackrel{\text{def}}{=} \omega_\rho(x) + \eta(x) + \xi(x),$$

where $\rho \ge 0$ is an inverse penalty parameter. Its predicted reduction is given by:

$$\Delta \mathbf{\psi}_\rho^{(k)}(d_x) \stackrel{\text{def}}{=} \Delta \mathbf{\omega}_\rho^{(k)}(d_x) + \Delta \mathbf{\xi}^{(k)}(d_x) + \Delta \mathbf{\eta}^{(k)}(d_x).$$

The trial iterate $\hat{x}^{(k+1)}$ is accepted if the actual reduction $\psi_\rho(x^{(k)}) - \psi_\rho(\hat{x}^{(k+1)})$ in the merit function is larger than a fraction $\sigma \in (0, 1)$ of its predicted reduction:

$$\psi_\rho(x^{(k)}) - \psi_\rho(\hat{x}^{(k+1)}) \ge \sigma \Delta \mathbf{\psi}_\rho^{(k)}(\alpha d_x^{(k)}).$$

The sufficient decrease condition (also known as Armijo condition) indicates how the subproblem solve is connected to the merit function to ensure global convergence.

#### Filter methods

Filter methods are motivated by the desire to decouple reduction in the objective function from progress toward feasibility. The decrease function is given by:

$$\phi(x) \stackrel{\text{def}}{=} \omega_1(x) + \xi(x),$$

and its predicted reduction is given by:

$$\Delta \mathbf{\phi}^{(k)}(d_x) \stackrel{\text{def}}{=} \Delta \mathbf{\omega}_1^{(k)}(d_x) + \Delta \mathbf{\xi}^{(k)}(d_x).$$

Filter methods measure progress toward a solution by comparing the trial infeasibility measure $\eta$ and objective measure $\phi$ to a filter $\mathcal{F}$, a list of pairs $(\eta^{(l)}, \phi^{(l)})$ (typically from previous iterates) such that no pair dominates another pair. The trial iterate $\hat{x}^{(k+1)}$ is acceptable to the filter if and only if the following conditions hold:

$$\phi(\hat{x}^{(k+1)}) \leq \phi^{(l)} - \gamma \eta(\hat{x}^{(k+1)}) \quad \text{or} \quad \eta(\hat{x}^{(k+1)}) < \beta \eta^{(l)}, \quad \forall (\eta^{(l)}, \phi^{(l)}) \in \mathcal{F}^{(k)},$$

where $\gamma > 0$ and $0 < \beta < 1$ are constants. Filter methods use a standard sufficient reduction (Armijo) condition from unconstrained optimization to ensure convergence to a local minimum:

$$\phi(x^{(k)}) - \phi(\hat{x}^{(k+1)}) \geq \sigma \Delta \mathbf{\phi}^{(k)}(\alpha d_x^{(k)}),$$

where $\sigma \in (0, 1)$. Filter methods use the switching condition $\Delta \mathbf{\phi}^{(k)}(\alpha d_x^{(k)}) \geq \delta \eta(x^{(k)})^2$, where $\delta > 0$, to decide when this condition should be enforced.

### Constraint relaxation strategies

Subproblem constraint relaxation strategies guarantee that the subproblems are well defined and feasible. In general, we cannot assume that the nonlinear problem (NLP) is locally or globally feasible, nor that a given subproblem is feasible (the linearized constraints may be inconsistent or the trust-region radius may be too small). To address these unfavorable scenarios, constraint relaxation strategies relax the constraints systematically or when the standard subproblem is infeasible, thus giving more emphasis to decreasing the constraint violation.

#### $\ell_1$ relaxation

The $\ell_1$ relaxation strategy replaces a constrained optimization problem with a nonsmooth bound-constrained problem in which a penalty term is added to the objective:

$$\min_x \quad \rho f(x) + \|c(x)\|_1 \quad \text{s.t.} \quad x \ge 0,$$

where $\rho \ge 0$ is an inverse penalty parameter. An appropriate value of $\rho$ may be determined by steering rules. The nonsmooth $\ell_1$ relaxed problem can be reformulated as a smooth constrained problem with elastic variables. The $\ell_1$ relaxation is exact: one can show under mild conditions that for $\rho > 0$ sufficiently small, a second-order sufficient point of the $\ell_1$ relaxation is also a second-order sufficient point of (NLP).

#### Feasibility restoration

An infeasible subproblem results from inconsistent linearized or bound constraints, or when the trust-region radius is too small; it is an indication that (NLP) may be infeasible. In this case, the method reverts to the *feasibility restoration phase*: the original objective is temporarily discarded, and the following feasibility problem is solved instead:

$$\min_x \quad \|c(x)\| \quad \text{s.t.} \quad x \ge 0,$$

for some norm $\|\cdot\|$ in $\mathbb{R}^m$. Feasibility restoration improves feasibility until a minimum of the constraint violation is obtained or the subproblem becomes feasible again, in which case solving the original problem (the *optimality phase*) is resumed.

### Inequality handling methods

Inequality handling methods deal with the combinatorics induced by inequality constraints within the context of Lagrange-Newton approximations.

#### Inequality-constrained methods

In inequality-constrained methods, the handling of inequality constraints is deferred to the subproblem solver. Traditionally, sequential quadratic programming (SQP) methods generate a sequence of inequality-constrained quadratic problems (QPs) that are solved by means of an active-set QP solver. SQP methods converge quadratically under reasonable assumptions near a local minimizer, once the active set settles down.

#### Equality-constrained methods

Equality-constrained methods operate in two phases: the first phase solves a "low-fidelity" subproblem (such as an LP or a convex QP with a quasi-Newton Hessian), which provides an estimate of the active set $\mathcal{A}$. The second phase solves a "high-fidelity" (such as second-order) equality-constrained problem with exact Hessian. A typical example is SLPEQP (aka SLQP): it estimates the active set by solving an LP, then solves an equality-constrained QP (EQP).

#### Interior-point methods

*Primal-dual interior-point methods* relax the complementarity equations by a barrier parameter $\mu > 0$:

$$x_i z_i = \mu, \quad \forall i \in \{1, \ldots, n\},$$

which implies $x > 0$ and $z > 0$. Positivity of $x$ and $z$ is then enforced at each iteration, e.g., by a fraction-to-the-boundary rule. Similarly to homotopy methods, $\mu$ is asymptotically driven to 0 until the termination criteria are met.

In contrast, *primal interior-point methods* (or barrier methods) treat $z$ as dependent variables, corresponding to solving the following nonlinear equality-constrained problem:

$$\min_x \quad f(x) - \mu \sum_{i=1}^n \log(x_i) \quad \text{s.t.} \quad c(x) = 0.$$

### Hessian models

The Hessian model is a high- or low-quality representation of the Lagrangian Hessian of the original model. It may be:

- the exact Hessian $H^{(k)} = \nabla_{xx}^2 \mathcal{L}_\rho(x^{(k)}, y^{(k)})$ if it is provided by the modeler or the modeling framework;
- a quasi-Newton approximation such as BFGS or SR1, or a limited-memory version thereof;
- the identity matrix;
- the zero matrix.

### Inertia correction strategies

Since line-search methods require that $d_x^{(k)}$ be a descent direction, the Lagrangian Hessian or the augmented system is usually regularized such that the former becomes positive definite, and the latter has $n$ positive, $m$ negative, and $0$ zero eigenvalues, that is the inertia $(n, m, 0)$. An approximation of the inertia is provided by factorization codes such as MA57.

Typically, the inertia of the Hessian $H^{(k)}$ is corrected by adding a multiple of the identity matrix: $H^{(k)} + \delta I$ for some $\delta > \min\{\text{eig}(H^{(k)})\}$. The inertia of an augmented matrix $M \stackrel{\text{def}}{=} \begin{pmatrix} A & B \\ B^T & \end{pmatrix}$ is controlled by adjusting the regularization parameters $\delta_w \ge 0$ and $\delta_c \ge 0$ in the matrix $\begin{pmatrix} A + \delta_w I & B \\ B^T & -\delta_c I \end{pmatrix}$.

### Globalization mechanisms

When the methods are started far from a solution, directions may be unbounded or result in trial iterates that increase both the objective and the constraint violation. Globalization mechanisms provide a recourse action if a local approximation is deemed too poor to make progress toward a solution: line-search methods restrict the length of the step along a given direction, while trust-region methods restrict the length of the direction a priori.

#### Line-search methods

Line-search methods compute a trial step $\alpha d_x^{(k)}$ by determining a step length $\alpha \in (0, 1]$ along the direction $d_x^{(k)}$. Backtracking line-search methods generate a sequence of trial iterates $x^{(k)} + \alpha^{(k,l)} d_x^{(k)}$ for $l \in \mathbb{N}$ until acceptance, where $\alpha^{(k,l)} = c^l \alpha_{\max}^{(k)}$, $\alpha_{\max}^{(k)} \in (0, 1]$ and $c \in (0, 1)$.

#### Trust-region methods

Trust-region methods limit the length of the direction $d_x$ a priori by imposing the trust-region constraint $\|d_x\| \leq \Delta^{(l)}$ for some norm in $\mathbb{R}^n$, where $\Delta^{(l)} > 0$ is the trust-region radius. If the trial iterate is accepted by the globalization strategy, $\Delta^{(l)}$ is increased if the trust region is active at $d_x^{(k,l)}$. Otherwise, $\Delta^{(l)}$ is decreased. Contrary to line-search methods, a positive definite Lagrangian Hessian is not required because directions of negative curvature are bounded by the trust region.

### Summary

Table 1 presents a unified view of state-of-the-art solvers within the proposed unifying framework.

**Table 1.** Description of state-of-the-art solvers within the proposed unifying framework.

| Solver | Constraint relaxation strategy | Inequality handling method | Globalization strategy | Globalization mechanism | Hessian model | Inertia correction strategy | Method |
|--------|-------------------------------|---------------------------|----------------------|------------------------|---------------|----------------------------|--------|
| ALGLIB MinNLC | $\ell_1$ relaxation | IC | filter method | trust region | QN | none | SQP |
| CONOPT | feasible step method | IC | objective merit | line search | QN | none | GRG |
| FICO XSLP | $\ell_1$ relaxation | IC | -- | $\ell_\infty$ trust region | none | none | SLP |
| filterSQP | feasibility restoration | IC | filter method | $\ell_\infty$ trust region | exact | none | SQP |
| IPOPT | feasibility restoration | primal-dual IPM | filter method | line search | exact / QN | primal-dual | IPM |
| KNITRO-ASM | $\ell_1$ relaxation | EC | $\ell_1$ merit | trust region | exact | ? | SLQP |
| KNITRO-IPM | step decomposition | primal-dual IPM | $\ell_2$ merit | line search + trust region | exact | none | IPM |
| LANCELOT | bound-constrained AL | EC | AL merit | $\ell_2$ / $\ell_\infty$ trust region | exact | none | AL |
| LOQO | $\ell_2^2$ relaxation | primal-dual IPM | $\ell_2^2$ merit | line search | exact | primal | IPM |
| MINOS | linearly constrained AL + $\ell_1$ relaxation | IC | forcing sequences | line search | QN | none | GRG |
| NAG e04uc/e04wdc | $\ell_1$ relaxation | IC | AL merit | line search | QN | none | SQP |
| NLPQL | right-hand-side relaxation | IC | AL merit | line search | QN | none | SQP |
| SLSQP | right-hand-side relaxation | IC | $\ell_1$ merit | line search | QN | none | SQP |
| SNOPT | $\ell_1$ relaxation | IC | AL merit | line search | QN | none | SQP |
| SQuID | $\ell_1$ relaxation | IC | $\ell_1$ merit | line search | exact | primal | S$\ell_1$QP |
| WORHP | right-hand-side relaxation | IC | $\ell_1$ merit / filter method | line search | QN | none | SQP |

---

Uno, a unified solver for nonlinearly constrained optimization
==============================================================

We consider nonlinearly constrained optimization problems of the form

$$
\begin{array}{ll} \displaystyle
\min_x      & f(x) \\
\mbox{s.t.} & l \le
\begin{Bmatrix}
c(x) \\
Ax \\
x
\end{Bmatrix}
\le u,
\end{array}
$$

where $x \in \mathbb{R}^n$, $f : \mathbb{R}^n \to \mathbb{R}$, $c: \mathbb{R}^n \to \mathbb{R}^{m_c}$, $A \in \mathbb{R}^{m_A \times n}$, and $l \in (\mathbb{R} \cup \{-\infty\})^{m_c + m_A + n}$ and $u \in (\mathbb{R} \cup \{+\infty\})^{m_c + m_A + n}$. $f$ and $c$ may be nonconvex, which results in a nonconvex optimization problem. This formulation allows for unbounded variables and equality constraints and explicitly separates general nonlinear, linear, and bound constraints, enabling solvers to readily exploit this structure. However, for the sake of simplicity of this presentation and without loss of generality, we consider the problem in the following form:

$$
\tag{NLP}
\begin{array}{ll} \displaystyle
\min_x      & f(x) \\
\mbox{s.t.} & c(x) = 0 \\
				& x \ge 0,
\end{array}
$$

where $x \in \mathbb{R}^n$, $f : \mathbb{R}^n \to \mathbb{R}$, and $c: \mathbb{R}^n \to \mathbb{R}^m$.

Most derivative-based iterative methods for nonlinearly constrained nonconvex optimization share common algorithmic components. Building on this insight, we introduce an abstract framework structured around generic building blocks that describes these methods in a unified fashion. We then present **Uno** (Unifying Nonlinear Optimization)[^1], a modular open-source solver for nonlinearly constrained optimization that unifies numerous state-of-the-art methods and organizes existing strategies into a coherent hierarchy (see wheel of strategies below).

<p align="center">
   <img src="figures/wheel.png" alt="Unifying framework: the wheel of strategies." width="60%" />
</p>

Uno allows the automatic generation of various strategy combinations on the fly with no programming effort from the user. While all combinations do not lead to convergent methods, some of them result in efficient solvers that may not exist as software implementations. Uno currently implements the following strategies:

- **constraint relaxation strategies**: feasibility restoration;
- **inequality handling methods**: inequality constrained method, interior-point method;
- **Hessian models**: exact, L-BFGS, identity, zero;
- **inertia control strategies**: primal, primal-dual, none;
- **globalization strategies**: filter method, funnel method, merit function;
- **globalization mechanisms**: backtracking line search, trust-region method.

We believe that Uno has the potential to serve as an experimental laboratory for practitioners and optimizers and to accelerate research in nonlinearly constrained optimization. Our ultimate goal is to promote the extension of state-of-the-art nonlinear optimization techniques to new classes of problems such as problems with equilibrium constraints and nonlinear robust optimization.

[^1]: Uno was first introduced at the ISMP 2018 conference under the name Argonot.

## Unification theory

We argue that most Lagrange-Newton methods can be broken down into the following generic ingredients:
* a **constraint relaxation strategy**: a systematic way to relax the general constraints;
* an **inequality handling method**: a systematic way to handle the inequality constraints;
* a **Lagrange-Newton subproblem**: a local Lagrange-Newton approximation of the reformulated problem, composed of:
	* a **Hessian model**: a model of the Lagrangian Hessian of the original problem;
	* an **inertia control strategy**: a strategy to correct the inertia of the Lagrangian Hessian or the augmented system of the reformulated problem;
* a **globalization strategy**: an acceptance test of the trial iterate;
* a **globalization mechanism**: a recourse action upon rejection of the trial iterate.


The following graph gives an overview of state-of-the-art strategies:
<p align="center">
   <img src="docs/figures/wheel.png" alt="Uno hypergraph" width="55%" />
</p>

# Uno: a unified solver for nonlinearly constrained optimization

We have implemented our unifying framework for nonlinearly constrained optimization within Uno, a modular solver written in C++17. A generic and flexible code, it supports a broad range of strategies that can be combined automatically and on the fly with no programming effort from the user. The code is packaged in a lightweight library (around 10,000 lines of code for the current version, excluding interfaces) available as open-source software under the MIT license at https://github.com/cvanaret/Uno. Uno is available via its C, Julia (registered package `UnoSolver.jl`), Python (the packaging of `unopy` is under development), Fortran, and AMPL interfaces.

## Generic architecture

The modularity of Uno stems from its generic architecture: each ingredient is implemented once and independently of the others, which improves readability, and makes building blocks less prone to error and easier to maintain than monolithic codes.

Figure 3 represents Uno's object-oriented architecture as a Unified Modeling Language (UML) diagram based on inheritance ("is a") and composition ("has a"). The ingredients are modeled as abstract classes: they define interfaces, that is, generic actions and behaviors that must be implemented by concrete strategies modeled as subclasses. For example:

- the classes `BacktrackingLineSearch` and `TrustRegionStrategy` inherit from the abstract class `GlobalizationMechanism` and thus must implement the purely virtual member function `compute_acceptable_iterate()`;
- the `GlobalizationMechanism` class possesses a member of type `ConstraintRelaxationStrategy`.

![Uno's UML diagram.](figures/uml_diagram.png)

**Figure 3.** Uno's UML diagram.

## Automatic strategy combinations

Uno implements state-of-the-art strategies that can be combined automatically thanks to the modular software architecture. The number of possible strategy combinations is the size of the Cartesian product of the eight ingredients. Note that all combinations do not necessarily result in sensible algorithms, or even convergent approaches.

At the moment, Uno prohibits the combination of interior-point methods and trust-region strategies. A possible strategy is KNITRO's step decomposition: the direction is decomposed into a normal step that minimizes the constraint violation within the trust region, and a tangential step that minimizes the objective for a given constraint violation target within the trust region. This limitation will be resolved in later Uno versions.

Some strategy combinations are available as "presets" that automatically connect the eight ingredients and set values for the hyperparameters. The following presets are available:

- **`filtersqp`**: A trust-region restoration filter SQP method à la filterSQP. Second-order correction steps were not implemented.
- **`ipopt`**: A line-search restoration filter interior-point method à la IPOPT. Second-order correction steps, scaling, least-square multipliers, iterative refinement, iterative bound relaxations, non-monotone techniques, and soft feasibility restoration were not implemented.

## Features of Uno

### Interfaces to subproblem solvers

Interfaces to the following subproblem solvers are available:

- **BQPD**: a null-space active-set solver for nonconvex QPs. BQPD accepts Hessian-vector products instead of an explicit matrix;
- **MA57**, **MA27**, and **MUMPS**: direct solvers for sparse symmetric indefinite linear systems;
- **HiGHS**: a parallel simplex implementation for linear programming.

### Definition of the subproblem

The constraint relaxation strategy and the inequality handling method successively reformulate the original problem with respect to the general constraints $c(x) = 0$ and the bound constraints $x \ge 0$. A local model of the resulting reformulated problem is then built.

The Lagrange-Newton subproblem is composed of the following elements: the reformulated problem, the current primal-dual iterate, the Hessian model, the inertia correction strategy, and a possible trust-region radius. These elements interact with one another to automatically define the progress measures and their local models, the Lagrangian Hessian or augmented matrix with the correct inertia, and the type of subproblem solvers that can be used.

The subproblem is represented schematically in Figure 4.

![Definition of a Subproblem.](figures/subproblem.png)

**Figure 4.** Definition of a `Subproblem`.

### Definition of progress measures

The progress measures are defined automatically by the successive reformulations of the optimization problem (`l1RelaxedProblem` and `PrimalDualInteriorPointProblem`):

- the norm of the infeasibility measure is determined by that of the feasibility problem or that of the relaxed problem;
- the objective measure is $\omega_\pi(x) \stackrel{\text{def}}{=} \pi f(x)$ (for all the currently implemented strategies);
- the auxiliary measure accumulates proximal (in the feasibility problem `l1RelaxedProblem`) and barrier (in `PrimalDualInteriorPointProblem`) terms.

### Inertia correction

Each Hessian model declares whether it is positive definite, and whether it is available as an explicit matrix and as a linear operator. The inertia of the Lagrangian Hessian is corrected if:

- the Hessian model is not already positive definite; and
- the Hessian model is available as an explicit matrix; and
- the inertia correction strategy performs primal correction ("primal" or "primal-dual").

### Instantiation of ingredients

Most ingredients are picked by the user via options. The following ingredients may be set or overridden by Uno after analyzing the problem:

- for inequality-constrained methods, the subproblem solver is picked depending whether the subproblems have curvature;
- if the reformulated problem is unconstrained, the constraint relaxation strategy is set to the custom `NoRelaxation` strategy, the globalization strategy is set to `l1MeritFunction`, and if there is no curvature in the subproblem, the subproblem solver is set to the custom `BoxLPSolver`;
- if the Hessian model is "exact" but neither an explicit Hessian matrix nor a Hessian linear operator was provided by the modeler, the Hessian model is set to "zero" and a warning message is printed.

### Sparse matrix formats

Each subproblem solver possesses an object that inherits from the abstract class `EvaluationSpace` in which they store the Jacobian matrix, the Hessian matrix, or the augmented matrix in specific sparse formats:

- BQPD expects a Jacobian in Compressed Sparse Row (CSR) format;
- MA57, MA27, and MUMPS expect a matrix in COOrdinate (COO) format;
- HiGHS expects the Jacobian in Compressed Sparse (Row or Column) format.

### Termination criteria

Uno terminates at the primal-dual iterate $(x^*, y^*, z^*, \pi^*)$ if:

- sufficient first-order optimality conditions are approximately satisfied:
  - a **feasible KKT point** (CQ holds) if it satisfies stationarity, primal feasibility, dual feasibility, and complementarity with $\pi^* > 0$;
  - a **feasible FJ point** (CQ does not hold) if it satisfies these conditions with $\pi^* = 0$;
  - an **infeasible stationary point** (a minimum of the constraint violation) if it satisfies stationarity and dual feasibility with $\pi^* = 0$, no primal feasibility and a complementarity condition on the violated constraints;
- primal feasibility is approximately satisfied and the trust-region radius is close to machine epsilon;
- the first-order optimality conditions cannot be satisfied for the user-defined tolerance $\varepsilon$ but are satisfied for a looser tolerance for a certain number of consecutive iterations.

### Error handling

Uno terminates with an error message if it encounters an IEEE exception at the initial point $x^{(0)}$. Otherwise, it tries to recover from IEEE exceptions during the optimization process by invoking the globalization mechanism: reducing the current trust-region radius or reducing the tentative step length in the backtracking line search.

# Checklists

The purpose of this page is to collate a series of checklists for commonly performed changes to the source code of Uno.

In each case, copy the checklist into the description of the pull request.

## Making a release of Uno

In preparation for an Uno release, use the following checklist. These steps can be done in the same commit, or separately.

````
## Pre-release

- [ ] Change the version number in `CITATION.cff` (twice)
- [ ] Change the version number in `CMakeLists.txt`
- [ ] Change the version number in `interfaces/C/Uno_C_API.h`
- [ ] Change the version number in `interfaces/Fortran/uno_c.f90`
- [ ] Update the logo in `docs/figures/logo.png`
- [ ] The PR should have the title `Prep for vX.Y.Z.`
- [ ] The commit messages in this PR do not contain `[ci skip]`

## Post-release

- `Uno_jll.jl` and `UnoSolver.jl`
  - [ ] Update the [Yggdrasil tarballs](https://github.com/JuliaPackaging/Yggdrasil/blob/master/U/Uno/build_tarballs.jl)
  - [ ] Change the `Uno_jll` version number in `interfaces/Julia/Project.toml`
  - [ ] Change the `Uno_jll` version number in `interfaces/Julia/gen/Project.toml`
  - [ ] Change the patch version number in `interfaces/Julia/Project.toml`
- [ ] Update the logo in [the Github settings](https://github.com/cvanaret/Uno/settings)
````

## Making a release of `UnoSolver.jl`

In preparation for an `UnoSolver.jl` release, use the following checklist.

````
## Pre-release

- [ ] Change the version number in `interfaces/Julia/Project.toml`
- [ ] The title of the PR should start with `[UnoSolver.jl] Release`
- [ ] Tag the register bot in a commit: `@JuliaRegistrator register subdir="interfaces/Julia"
````

## Making a release of `unopy`

In preparation for an `unopy` release, use the following checklists: first for the test release to [TestPyPI](https://test.pypi.org/project/unopy) and the corresponding tests with `pip install`, then for the actual release to [PyPI](https://pypi.org/project/unopy) and the corresponding tests with `pip install`.

````
## Test release

- [ ] Change the version number in `pyproject.toml`
- [ ] The title of the test commit should start with `[unopy] Test release`

## Pre-release

- [ ] Change the version number in `pyproject.toml`
- [ ] The title of the PR should start with `[unopy] Release`
````

# Options

This document lists the configuration options that Uno accepts, their types and default values.
Options are grouped by functional area.
Defaults are taken from `uno/options/DefaultOptions.cpp`.

## Ingredients

| Ingredient | Available strategies |
| :---       | :---                 |
| `constraint_relaxation_strategy` | `feasibility_restoration` |
| `inequality_handling_method` | `inequality_constrained`, `interior_point` |
| `hessian_model` | `exact`, `LBFGS`, `identity`, `zero` |
| `inertia_correction_strategy` | `primal`, `primal_dual`, `none` |
| `globalization_mechanism` | `TR`, `LS` |
| `globalization_strategy` | `merit_function`, `fletcher_filter_method`, `waechter_filter_method`, `funnel_method` |

## Subproblem solver

| Ingredient | Available strategies |
| :---       | :---                 |
| `QP_solver` | `BQPD`, `HiGHS` (if available) |
| `LP_solver` | `BQPD`, `HiGHS` (if available) |
| `linear_solver` | `MA57`, `MA27`, `MUMPS`, `SSIDS` (if available) |

If not provided, the solver is chosen automatically from the available solvers (if any).

## Termination

| Option             | Type | Default | Description |
| :---               | :--- | :---    | :---        |
| `primal_tolerance` | double | 1e-8 | Tolerance on constraint violation |
| `dual_tolerance` | double | 1e-8 | Tolerance on stationarity and complementarity |
| `loose_primal_tolerance` | double | 1e-6 | Loose tolerance on constraint violation |
| `loose_dual_tolerance` | double | 1e-6 | Loose tolerance on stationarity and complementarity |
| `loose_tolerance_iteration_threshold` | integer | 15 | Number of iterations for the loose tolerance to apply |
| `max_iterations` | integer | 2000 | Maximum number of outer iterations |
| `time_limit` | double | infinity | Time limit |
| `print_solution` | bool | false | Whether the primal-dual solution is printed |
| `unbounded_objective_threshold` | double | -1e20 | Objective threshold under which the problem is declared unbounded |

## Main options

### String options
| Option             | Possible values | Default | Description |
| :---               | :---            | :---    | :---        |
| `logger`           | `SILENT`, `DISCRETE`, `WARNING`, `INFO`, `DEBUG`, `DEBUG2`, `DEBUG3` | `INFO` | Verbosity level of the logger |
| `progress_norm`    | `L1`, `L2`, `INF` | `L1` | Norm used for the progress measures |
| `residual_norm`    | `L1`, `L2`, `INF` | `INF` | Norm used for the residuals |

### Numerical options
| Option             | Type | Default | Description |
| :---               | :--- | :---    | :---        |
| `residual_scaling_threshold` | double | 100.0 | Scaling factor in stationarity and complementarity residuals |
| `protect_actual_reduction_against_roundoff` | bool | `false` | Whether the actual reduction is slightly modified to account for roundoff |
| `protected_actual_reduction_macheps_coefficient` | double | 10 | Coefficient of the machine epsilon in the protected actual reduction |
| `print_subproblem` | bool |  `false` | Whether the subproblem is printed in `DEBUG` mode |

## Globalization strategy options

| Option                     | Type   | Default | Description |
| :---                       | :---   | :---    | :---        |
| `armijo_decrease_fraction` | double | 1e-4    | Fraction of the predicted reduction that should be achieved by the actual reduction in the Armijo condition |
| `armijo_tolerance`         | double | 1e-9    | Minimum value of the predicted reduction in the Armijo condition, 0 otherwise |

## Switching method options

| Option                             | Type   | Default | Description |
| :---                               | :---   | :---    | :---        |
| `switching_delta`                  | double | 0.999   | Fraction of the constraint violation that should be achieved by the predicted reduction in the switching condition |
| `switching_infeasibility_exponent` | double | 2       | Exponent of the constraint violation in the switching condition |

## Merit function options

| Option                                     | Type    | Default | Description |
| :---                                       | :---    | :---    | :---        |
| `sufficient_infeasibility_decrease_ratio`  | double  | 0.9     | Sufficient infeasibility decrease ratio |

## Filter method options

### String options

| Option        | Possible values           | Default    | Description |
| :---          | :---                      | :---       | :---        |
| `filter_type` | `standard`, `nonmonotone` | `standard` | Type of the filter data structure |

### Numerical options

| Option                                            | Type    | Default | Description |
| :---                                              | :---    | :---    | :---        |
| `filter_beta`                                     | double  | 0.999   | Fraction in the infeasibility sufficient reduction condition |
| `filter_gamma`                                    | double  | 0.001   | Slope in the objective sufficient reduction condition |
| `filter_ubd`                                      | double  | 1e2     | Minimum value for the initial upper bound on the infeasibility |
| `filter_fact`                                     | double  | 1.25    | Multiple of the initial infeasibility for the initial upper bound on the infeasibility |
| `filter_capacity`                                 | integer | 50      | Maximum number of filter entries |
| `filter_sufficient_infeasibility_decrease_factor` | double  | 0.9     | Infeasibility decrease factor in the infeasibility sufficient decrease condition |
| `nonmonotone_filter_number_dominated_entries`     | integer | 3       | Number of dominated filter entries (nonmonotone filter) |

## Funnel options

| Option                                          | Type    | Default | Description |
| :---                                            | :---    | :---    | :---        |
| `funnel_kappa`                                  | double  | 0.5     | Convex combination coefficient in funnel update rule |
| `funnel_beta`                                   | double  | 0.9999  | Fraction in the infeasibility sufficient reduction condition |
| `funnel_gamma`                                  | double  | 0.001   | Slope in the objective sufficient reduction condition |
| `funnel_ubd`                                    | double  | 1.0     | Minimum value for the initial upper bound on the infeasibility |
| `funnel_fact`                                   | double  | 1.5     | Multiple of the initial infeasibility for the initial upper bound on the infeasibility |
| `funnel_update_strategy`                        | integer | 1       | Rule for the funnel update (1, 2, or 3) |
| `funnel_require_acceptance_wrt_current_iterate` | bool    | `false` | Whether the trial iterate should improve upon the current iterate |

## Line search options

| Option                            | Type   | Default | Description |
| :---                              | :---   | :---    | :---        |
| `LS_backtracking_ratio`           | double | 0.5     | Decrease ratio of the step length for backtracking line search |
| `LS_min_step_length`              | double | 1e-12   | Minimum acceptable step length before failure is reported |
| `LS_scale_duals_with_step_length` | bool   | `true`  | Whether the Lagrange multipliers are scaled with the step length |

## Inertia correction options

| Option                                       | Type    | Default | Description |
| :---                                         | :---    | :---    | :---        |
| `regularization_failure_threshold`           | double  | 1e40    | Threshold for the primal inertia correction coefficient above which failure is reported |
| `primal_regularization_initial_factor`       | double  | 1e-4    | Initial value of primal inertia correction coefficient |
| `regularization_increase_factor`             | double  | 2       | Increase factor for the primal inertia correction coefficient |
| `dual_regularization_fraction`               | double  | 1e-8    | Fraction of the dual inertia correction parameter |
| `primal_regularization_lb`                   | double  | 1e-20   | Minimum value of the primal inertia correction coefficient upon decrease |
| `primal_regularization_decrease_factor`      | double  | 3.0     | Decrease factor for the primal inertia correction coefficient |
| `primal_regularization_fast_increase_factor` | double  | 100.0   | Fast increase factor for the primal inertia correction coefficient |
| `primal_regularization_slow_increase_factor` | double  | 8.0     | Slow increase factor for the primal inertia correction coefficient |
| `threshold_unsuccessful_attempts`            | integer | 8       | Number of unsuccessful attempts until inertia correction becomes more aggressive |

## Quasi-Newton options

| Option                     | Type    | Default | Description |
| :---                       | :---    | :---    | :---        |
| `quasi_newton_memory_size` | integer | 6       | Size of the quasi-Newton limited memory |

## Trust region options

| Option                          | Type   | Default | Description |
| :---                            | :---   | :---    | :---        |
| `TR_radius`                     | double | 10.0    | Initial value of the radius |
| `TR_increase_factor`            | double | 2       | Increase factor of the radius for successful iterations |
| `TR_decrease_factor`            | double | 2       | Decrease factor of the radius for unsuccessful iterations |
| `TR_aggressive_decrease_factor` | double | 4       | Decrease factor of the radius when errors occur |
| `TR_activity_tolerance`         | double | 1e-6    | Tolerance with which the trust-region constraint is considered active |
| `TR_min_radius`                 | double | 1e-12   | Minimum radius acceptable before failure is reported |
| `TR_radius_reset_threshold`     | double | 1e-4    | Smallest value to which the radius is reset at the beginning of an iteration |

## Feasibility restoration options

| Option                                                 | Type   | Default | Description |
| :---                                                   | :---   | :---    | :---        |
| `switch_to_optimality_requires_linearized_feasibility` | bool   | `true`  | Whether the switch to optimality phase requires the linearized constraints to be consistent |
| `l1_constraint_violation_coefficient`                  | double | 1       | Coefficient of the constraint violation in the $\ell_1$ relaxed problem |

## Barrier subproblem options

### String options

| Option             | Possible values | Default    | Description |
| :---               | :---            | :---       | :---        |
| `barrier_function` | `log`           | `log`      | Type of the barrier function |

### Numerical options

| Option                                 | Type   | Default | Description |
| :---                                   | :---   | :---    | :---        |
| `barrier_initial_parameter`            | double | 0.1     | Initial value of the barrier parameter |
| `barrier_default_multiplier`           | double | 1       | Initial value of the bound multipliers |
| `barrier_tau_min`                      | double | 0.99    | Coefficient of the fraction-to-boundary rule |
| `barrier_k_sigma`                      | double | 1e10    | Safeguard parameter for rescaling the bound multipliers |
| `barrier_k_mu`                         | double | 0.2     | Coefficient for multiplicative update of the barrier parameter |
| `barrier_theta_mu`                     | double | 1.5     | Coefficient for geometric update of the barrier parameter |
| `barrier_k_epsilon`                    | double | 10      | Scaling factor of the barrier parameter in the barrier update rule |
| `barrier_update_fraction`              | double | 10      | Fraction in the barrier update rule |
| `barrier_regularization_exponent`      | double | 0.25    | Exponent of the barrier parameter in the dual inertia correction parameter |
| `barrier_small_direction_factor`       | double | 10.0    | Multiple of the machine epsilon in the small step condition |
| `barrier_push_variable_to_interior_k1` | double | 1e-2    | Coefficient for the perturbation of the initial bounds |
| `barrier_push_variable_to_interior_k2` | double | 1e-2    | Coefficient for the perturbation of the initial bounds |
| `barrier_damping_factor`               | double | 1e-5    | Damping coefficient for single bounds |
| `barrier_small_infeasibility_factor`   | double | 1e-4    | Factor in the small infeasibility test |
| `least_square_multiplier_max_norm`     | double | 1e3     | Maximum accepted norm of the least-square multipliers |

## BQPD options

| Option                | Possible values         | Default     | Description |
| :---                  | :---                    | :---        | :---        |
| `BQPD_kmax_heuristic` | `filtersqp`, `minotaur` | `filtersqp` | Heuristic used to pick upper bound on nullspace size (`kmax`) |
